package at.ac.tuwien.infosys.www.pixy.conversion;

import java.util.*;

public class BuiltinFunctions {
    
    // set containing the lower-case names of ALL builtin PHP functions,
    // i.e. including those that are not modeled in the builtin functions
    // input file
    private static Set allBuiltinFunctions = BuiltinFunctions.initBuiltinFunctions();
    
    // we don't want instances of this helper class
    private BuiltinFunctions() { }
    
    // initializes the builtin functions set
    private static Set initBuiltinFunctions() {

        HashSet<String> allBuiltinFunctions = new HashSet<String>();

        // this additional sanitization function can be used
        // to suppress false warnings
        allBuiltinFunctions.add(InternalStrings.suppression);
        
        allBuiltinFunctions.add("abs");
        allBuiltinFunctions.add("acos");
        allBuiltinFunctions.add("acosh");
        allBuiltinFunctions.add("addcslashes");
        allBuiltinFunctions.add("addslashes");
        allBuiltinFunctions.add("aggregate");
        allBuiltinFunctions.add("aggregate_info");
        allBuiltinFunctions.add("aggregate_methods");
        allBuiltinFunctions.add("aggregate_methods_by_list");
        allBuiltinFunctions.add("aggregate_methods_by_regexp");
        allBuiltinFunctions.add("aggregate_properties");
        allBuiltinFunctions.add("aggregate_properties_by_list");
        allBuiltinFunctions.add("aggregate_properties_by_regexp");
        allBuiltinFunctions.add("aggregation_info");
        allBuiltinFunctions.add("apache_child_terminate");
        allBuiltinFunctions.add("apache_get_modules");
        allBuiltinFunctions.add("apache_get_version");
        allBuiltinFunctions.add("apache_getenv");
        allBuiltinFunctions.add("apache_lookup_uri");
        allBuiltinFunctions.add("apache_note");
        allBuiltinFunctions.add("apache_request_headers");
        allBuiltinFunctions.add("apache_reset_timeout");
        allBuiltinFunctions.add("apache_response_headers");
        allBuiltinFunctions.add("apache_setenv");
        allBuiltinFunctions.add("apd_breakpoint");
        allBuiltinFunctions.add("apd_callstack");
        allBuiltinFunctions.add("apd_clunk");
        allBuiltinFunctions.add("apd_continue");
        allBuiltinFunctions.add("apd_croak");
        allBuiltinFunctions.add("apd_dump_function_table");
        allBuiltinFunctions.add("apd_dump_persistent_resources");
        allBuiltinFunctions.add("apd_dump_regular_resources");
        allBuiltinFunctions.add("apd_echo");
        allBuiltinFunctions.add("apd_get_active_symbols");
        allBuiltinFunctions.add("apd_set_pprof_trace");
        allBuiltinFunctions.add("apd_set_session");
        allBuiltinFunctions.add("apd_set_session_trace");
        allBuiltinFunctions.add("apd_set_socket_session_trace");
        allBuiltinFunctions.add("array");
        allBuiltinFunctions.add("array_change_key_case");
        allBuiltinFunctions.add("array_chunk");
        allBuiltinFunctions.add("array_combine");
        allBuiltinFunctions.add("array_count_values");
        allBuiltinFunctions.add("array_diff");
        allBuiltinFunctions.add("array_diff_assoc");
        allBuiltinFunctions.add("array_diff_key");
        allBuiltinFunctions.add("array_diff_uassoc");
        allBuiltinFunctions.add("array_diff_ukey");
        allBuiltinFunctions.add("array_fill");
        allBuiltinFunctions.add("array_filter");
        allBuiltinFunctions.add("array_flip");
        allBuiltinFunctions.add("array_intersect");
        allBuiltinFunctions.add("array_intersect_assoc");
        allBuiltinFunctions.add("array_intersect_key");
        allBuiltinFunctions.add("array_intersect_uassoc");
        allBuiltinFunctions.add("array_intersect_ukey");
        allBuiltinFunctions.add("array_key_exists");
        allBuiltinFunctions.add("array_keys");
        allBuiltinFunctions.add("array_map");
        allBuiltinFunctions.add("array_merge");
        allBuiltinFunctions.add("array_merge_recursive");
        allBuiltinFunctions.add("array_multisort");
        allBuiltinFunctions.add("array_pad");
        allBuiltinFunctions.add("array_pop");
        allBuiltinFunctions.add("array_push");
        allBuiltinFunctions.add("array_rand");
        allBuiltinFunctions.add("array_reduce");
        allBuiltinFunctions.add("array_reverse");
        allBuiltinFunctions.add("array_search");
        allBuiltinFunctions.add("array_shift");
        allBuiltinFunctions.add("array_slice");
        allBuiltinFunctions.add("array_splice");
        allBuiltinFunctions.add("array_sum");
        allBuiltinFunctions.add("array_udiff");
        allBuiltinFunctions.add("array_udiff_assoc");
        allBuiltinFunctions.add("array_udiff_uassoc");
        allBuiltinFunctions.add("array_uintersect");
        allBuiltinFunctions.add("array_uintersect_assoc");
        allBuiltinFunctions.add("array_uintersect_uassoc");
        allBuiltinFunctions.add("array_unique");
        allBuiltinFunctions.add("array_unshift");
        allBuiltinFunctions.add("array_values");
        allBuiltinFunctions.add("array_walk");
        allBuiltinFunctions.add("array_walk_recursive");
        allBuiltinFunctions.add("ArrayIterator::current");
        allBuiltinFunctions.add("ArrayIterator::key");
        allBuiltinFunctions.add("ArrayIterator::next");
        allBuiltinFunctions.add("ArrayIterator::rewind");
        allBuiltinFunctions.add("ArrayIterator::seek");
        allBuiltinFunctions.add("ArrayIterator::valid");
        allBuiltinFunctions.add("ArrayObject::__construct");
        allBuiltinFunctions.add("ArrayObject::append");
        allBuiltinFunctions.add("ArrayObject::count");
        allBuiltinFunctions.add("ArrayObject::getIterator");
        allBuiltinFunctions.add("ArrayObject::offsetExists");
        allBuiltinFunctions.add("ArrayObject::offsetGet");
        allBuiltinFunctions.add("ArrayObject::offsetSet");
        allBuiltinFunctions.add("ArrayObject::offsetUnset");
        allBuiltinFunctions.add("arsort");
        allBuiltinFunctions.add("ascii2ebcdic");
        allBuiltinFunctions.add("asin");
        allBuiltinFunctions.add("asinh");
        allBuiltinFunctions.add("asort");
        allBuiltinFunctions.add("aspell_check");
        allBuiltinFunctions.add("aspell_check_raw");
        allBuiltinFunctions.add("aspell_new");
        allBuiltinFunctions.add("aspell_suggest");
        allBuiltinFunctions.add("assert");
        allBuiltinFunctions.add("assert_options");
        allBuiltinFunctions.add("atan");
        allBuiltinFunctions.add("atan2");
        allBuiltinFunctions.add("atanh");
        allBuiltinFunctions.add("base64_decode");
        allBuiltinFunctions.add("base64_encode");
        allBuiltinFunctions.add("base_convert");
        allBuiltinFunctions.add("basename");
        allBuiltinFunctions.add("bcadd");
        allBuiltinFunctions.add("bccomp");
        allBuiltinFunctions.add("bcdiv");
        allBuiltinFunctions.add("bcmod");
        allBuiltinFunctions.add("bcmul");
        allBuiltinFunctions.add("bcompile_write_file");
        allBuiltinFunctions.add("bcompiler_load");
        allBuiltinFunctions.add("bcompiler_load_exe");
        allBuiltinFunctions.add("bcompiler_parse_class");
        allBuiltinFunctions.add("bcompiler_read");
        allBuiltinFunctions.add("bcompiler_write_class");
        allBuiltinFunctions.add("bcompiler_write_constant");
        allBuiltinFunctions.add("bcompiler_write_exe_footer");
        allBuiltinFunctions.add("bcompiler_write_footer");
        allBuiltinFunctions.add("bcompiler_write_function");
        allBuiltinFunctions.add("bcompiler_write_functions_from_file");
        allBuiltinFunctions.add("bcompiler_write_header");
        allBuiltinFunctions.add("bcpow");
        allBuiltinFunctions.add("bcpowmod");
        allBuiltinFunctions.add("bcscale");
        allBuiltinFunctions.add("bcsqrt");
        allBuiltinFunctions.add("bcsub");
        allBuiltinFunctions.add("bin2hex");
        allBuiltinFunctions.add("bind_textdomain_codeset");
        allBuiltinFunctions.add("bindec");
        allBuiltinFunctions.add("bindtextdomain");
        allBuiltinFunctions.add("bzclose");
        allBuiltinFunctions.add("bzcompress");
        allBuiltinFunctions.add("bzdecompress");
        allBuiltinFunctions.add("bzerrno");
        allBuiltinFunctions.add("bzerror");
        allBuiltinFunctions.add("bzerrstr");
        allBuiltinFunctions.add("bzflush");
        allBuiltinFunctions.add("bzopen");
        allBuiltinFunctions.add("bzread");
        allBuiltinFunctions.add("bzwrite");
        allBuiltinFunctions.add("CachingIterator::__toString");
        allBuiltinFunctions.add("CachingIterator::hasNext");
        allBuiltinFunctions.add("CachingIterator::next");
        allBuiltinFunctions.add("CachingIterator::rewind");
        allBuiltinFunctions.add("CachingIterator::valid");
        allBuiltinFunctions.add("CachingRecursiveIterator::getChildren");
        allBuiltinFunctions.add("CachingRecursiveIterator::hasChildren");
        allBuiltinFunctions.add("cal_days_in_month");
        allBuiltinFunctions.add("cal_from_jd");
        allBuiltinFunctions.add("cal_info");
        allBuiltinFunctions.add("cal_to_jd");
        allBuiltinFunctions.add("call_user_func");
        allBuiltinFunctions.add("call_user_func_array");
        allBuiltinFunctions.add("call_user_method");
        allBuiltinFunctions.add("call_user_method_array");
        allBuiltinFunctions.add("ccvs_add");
        allBuiltinFunctions.add("ccvs_auth");
        allBuiltinFunctions.add("ccvs_command");
        allBuiltinFunctions.add("ccvs_count");
        allBuiltinFunctions.add("ccvs_delete");
        allBuiltinFunctions.add("ccvs_done");
        allBuiltinFunctions.add("ccvs_init");
        allBuiltinFunctions.add("ccvs_lookup");
        allBuiltinFunctions.add("ccvs_new");
        allBuiltinFunctions.add("ccvs_report");
        allBuiltinFunctions.add("ccvs_return");
        allBuiltinFunctions.add("ccvs_reverse");
        allBuiltinFunctions.add("ccvs_sale");
        allBuiltinFunctions.add("ccvs_status");
        allBuiltinFunctions.add("ccvs_textvalue");
        allBuiltinFunctions.add("ccvs_void");
        allBuiltinFunctions.add("ceil");
        allBuiltinFunctions.add("chdir");
        allBuiltinFunctions.add("checkdate");
        allBuiltinFunctions.add("checkdnsrr");
        allBuiltinFunctions.add("chgrp");
        allBuiltinFunctions.add("chmod");
        allBuiltinFunctions.add("chop");
        allBuiltinFunctions.add("chown");
        allBuiltinFunctions.add("chr");
        allBuiltinFunctions.add("chroot");
        allBuiltinFunctions.add("chunk_split");
        allBuiltinFunctions.add("class_exists");
        allBuiltinFunctions.add("class_implements");
        allBuiltinFunctions.add("class_parents");
        allBuiltinFunctions.add("classkit_import");
        allBuiltinFunctions.add("classkit_method_add");
        allBuiltinFunctions.add("classkit_method_copy");
        allBuiltinFunctions.add("classkit_method_redefine");
        allBuiltinFunctions.add("classkit_method_remove");
        allBuiltinFunctions.add("classkit_method_rename");
        allBuiltinFunctions.add("clearstatcache");
        allBuiltinFunctions.add("closedir");
        allBuiltinFunctions.add("closelog");
        allBuiltinFunctions.add("com");
        allBuiltinFunctions.add("com_addref");
        allBuiltinFunctions.add("com_create_guid");
        allBuiltinFunctions.add("com_event_sink");
        allBuiltinFunctions.add("com_get");
        allBuiltinFunctions.add("com_get_active_object");
        allBuiltinFunctions.add("com_invoke");
        allBuiltinFunctions.add("com_isenum");
        allBuiltinFunctions.add("com_load");
        allBuiltinFunctions.add("com_load_typelib");
        allBuiltinFunctions.add("com_message_pump");
        allBuiltinFunctions.add("com_print_typeinfo");
        allBuiltinFunctions.add("com_propget");
        allBuiltinFunctions.add("com_propput");
        allBuiltinFunctions.add("com_propset");
        allBuiltinFunctions.add("com_release");
        allBuiltinFunctions.add("com_set");
        allBuiltinFunctions.add("compact");
        allBuiltinFunctions.add("connection_aborted");
        allBuiltinFunctions.add("connection_status");
        allBuiltinFunctions.add("connection_timeout");
        allBuiltinFunctions.add("constant");
        allBuiltinFunctions.add("convert_cyr_string");
        allBuiltinFunctions.add("convert_uudecode");
        allBuiltinFunctions.add("convert_uuencode");
        allBuiltinFunctions.add("copy");
        allBuiltinFunctions.add("cos");
        allBuiltinFunctions.add("cosh");
        allBuiltinFunctions.add("count");
        allBuiltinFunctions.add("count_chars");
        allBuiltinFunctions.add("cpdf_add_annotation");
        allBuiltinFunctions.add("cpdf_add_outline");
        allBuiltinFunctions.add("cpdf_arc");
        allBuiltinFunctions.add("cpdf_begin_text");
        allBuiltinFunctions.add("cpdf_circle");
        allBuiltinFunctions.add("cpdf_clip");
        allBuiltinFunctions.add("cpdf_close");
        allBuiltinFunctions.add("cpdf_closepath");
        allBuiltinFunctions.add("cpdf_closepath_fill_stroke");
        allBuiltinFunctions.add("cpdf_closepath_stroke");
        allBuiltinFunctions.add("cpdf_continue_text");
        allBuiltinFunctions.add("cpdf_curveto");
        allBuiltinFunctions.add("cpdf_end_text");
        allBuiltinFunctions.add("cpdf_fill");
        allBuiltinFunctions.add("cpdf_fill_stroke");
        allBuiltinFunctions.add("cpdf_finalize");
        allBuiltinFunctions.add("cpdf_finalize_page");
        allBuiltinFunctions.add("cpdf_global_set_document_limits");
        allBuiltinFunctions.add("cpdf_import_jpeg");
        allBuiltinFunctions.add("cpdf_lineto");
        allBuiltinFunctions.add("cpdf_moveto");
        allBuiltinFunctions.add("cpdf_newpath");
        allBuiltinFunctions.add("cpdf_open");
        allBuiltinFunctions.add("cpdf_output_buffer");
        allBuiltinFunctions.add("cpdf_page_init");
        allBuiltinFunctions.add("cpdf_place_inline_image");
        allBuiltinFunctions.add("cpdf_rect");
        allBuiltinFunctions.add("cpdf_restore");
        allBuiltinFunctions.add("cpdf_rlineto");
        allBuiltinFunctions.add("cpdf_rmoveto");
        allBuiltinFunctions.add("cpdf_rotate");
        allBuiltinFunctions.add("cpdf_rotate_text");
        allBuiltinFunctions.add("cpdf_save");
        allBuiltinFunctions.add("cpdf_save_to_file");
        allBuiltinFunctions.add("cpdf_scale");
        allBuiltinFunctions.add("cpdf_set_action_url");
        allBuiltinFunctions.add("cpdf_set_char_spacing");
        allBuiltinFunctions.add("cpdf_set_creator");
        allBuiltinFunctions.add("cpdf_set_current_page");
        allBuiltinFunctions.add("cpdf_set_font");
        allBuiltinFunctions.add("cpdf_set_font_directories");
        allBuiltinFunctions.add("cpdf_set_font_map_file");
        allBuiltinFunctions.add("cpdf_set_horiz_scaling");
        allBuiltinFunctions.add("cpdf_set_keywords");
        allBuiltinFunctions.add("cpdf_set_leading");
        allBuiltinFunctions.add("cpdf_set_page_animation");
        allBuiltinFunctions.add("cpdf_set_subject");
        allBuiltinFunctions.add("cpdf_set_text_matrix");
        allBuiltinFunctions.add("cpdf_set_text_pos");
        allBuiltinFunctions.add("cpdf_set_text_rendering");
        allBuiltinFunctions.add("cpdf_set_text_rise");
        allBuiltinFunctions.add("cpdf_set_title");
        allBuiltinFunctions.add("cpdf_set_viewer_preferences");
        allBuiltinFunctions.add("cpdf_set_word_spacing");
        allBuiltinFunctions.add("cpdf_setdash");
        allBuiltinFunctions.add("cpdf_setflat");
        allBuiltinFunctions.add("cpdf_setgray");
        allBuiltinFunctions.add("cpdf_setgray_fill");
        allBuiltinFunctions.add("cpdf_setgray_stroke");
        allBuiltinFunctions.add("cpdf_setlinecap");
        allBuiltinFunctions.add("cpdf_setlinejoin");
        allBuiltinFunctions.add("cpdf_setlinewidth");
        allBuiltinFunctions.add("cpdf_setmiterlimit");
        allBuiltinFunctions.add("cpdf_setrgbcolor");
        allBuiltinFunctions.add("cpdf_setrgbcolor_fill");
        allBuiltinFunctions.add("cpdf_setrgbcolor_stroke");
        allBuiltinFunctions.add("cpdf_show");
        allBuiltinFunctions.add("cpdf_show_xy");
        allBuiltinFunctions.add("cpdf_stringwidth");
        allBuiltinFunctions.add("cpdf_stroke");
        allBuiltinFunctions.add("cpdf_text");
        allBuiltinFunctions.add("cpdf_translate");
        allBuiltinFunctions.add("crack_check");
        allBuiltinFunctions.add("crack_closedict");
        allBuiltinFunctions.add("crack_getlastmessage");
        allBuiltinFunctions.add("crack_opendict");
        allBuiltinFunctions.add("crc32");
        allBuiltinFunctions.add("create_function");
        allBuiltinFunctions.add("crypt");
        allBuiltinFunctions.add("ctype_alnum");
        allBuiltinFunctions.add("ctype_alpha");
        allBuiltinFunctions.add("ctype_cntrl");
        allBuiltinFunctions.add("ctype_digit");
        allBuiltinFunctions.add("ctype_graph");
        allBuiltinFunctions.add("ctype_lower");
        allBuiltinFunctions.add("ctype_print");
        allBuiltinFunctions.add("ctype_punct");
        allBuiltinFunctions.add("ctype_space");
        allBuiltinFunctions.add("ctype_upper");
        allBuiltinFunctions.add("ctype_xdigit");
        allBuiltinFunctions.add("curl_close");
        allBuiltinFunctions.add("curl_copy_handle");
        allBuiltinFunctions.add("curl_errno");
        allBuiltinFunctions.add("curl_error");
        allBuiltinFunctions.add("curl_exec");
        allBuiltinFunctions.add("curl_getinfo");
        allBuiltinFunctions.add("curl_init");
        allBuiltinFunctions.add("curl_multi_add_handle");
        allBuiltinFunctions.add("curl_multi_close");
        allBuiltinFunctions.add("curl_multi_exec");
        allBuiltinFunctions.add("curl_multi_getcontent");
        allBuiltinFunctions.add("curl_multi_info_read");
        allBuiltinFunctions.add("curl_multi_init");
        allBuiltinFunctions.add("curl_multi_remove_handle");
        allBuiltinFunctions.add("curl_multi_select");
        allBuiltinFunctions.add("curl_setopt");
        allBuiltinFunctions.add("curl_version");
        allBuiltinFunctions.add("current");
        allBuiltinFunctions.add("cybercash_base64_decode");
        allBuiltinFunctions.add("cybercash_base64_encode");
        allBuiltinFunctions.add("cybercash_decr");
        allBuiltinFunctions.add("cybercash_encr");
        allBuiltinFunctions.add("cyrus_authenticate");
        allBuiltinFunctions.add("cyrus_bind");
        allBuiltinFunctions.add("cyrus_close");
        allBuiltinFunctions.add("cyrus_connect");
        allBuiltinFunctions.add("cyrus_query");
        allBuiltinFunctions.add("cyrus_unbind");
        allBuiltinFunctions.add("date");
        allBuiltinFunctions.add("date_sunrise");
        allBuiltinFunctions.add("date_sunset");
        allBuiltinFunctions.add("dba_close");
        allBuiltinFunctions.add("dba_delete");
        allBuiltinFunctions.add("dba_exists");
        allBuiltinFunctions.add("dba_fetch");
        allBuiltinFunctions.add("dba_firstkey");
        allBuiltinFunctions.add("dba_handlers");
        allBuiltinFunctions.add("dba_insert");
        allBuiltinFunctions.add("dba_key_split");
        allBuiltinFunctions.add("dba_list");
        allBuiltinFunctions.add("dba_nextkey");
        allBuiltinFunctions.add("dba_open");
        allBuiltinFunctions.add("dba_optimize");
        allBuiltinFunctions.add("dba_popen");
        allBuiltinFunctions.add("dba_replace");
        allBuiltinFunctions.add("dba_sync");
        allBuiltinFunctions.add("dbase_add_record");
        allBuiltinFunctions.add("dbase_close");
        allBuiltinFunctions.add("dbase_create");
        allBuiltinFunctions.add("dbase_delete_record");
        allBuiltinFunctions.add("dbase_get_header_info");
        allBuiltinFunctions.add("dbase_get_record");
        allBuiltinFunctions.add("dbase_get_record_with_names");
        allBuiltinFunctions.add("dbase_numfields");
        allBuiltinFunctions.add("dbase_numrecords");
        allBuiltinFunctions.add("dbase_open");
        allBuiltinFunctions.add("dbase_pack");
        allBuiltinFunctions.add("dbase_replace_record");
        allBuiltinFunctions.add("dblist");
        allBuiltinFunctions.add("dbmclose");
        allBuiltinFunctions.add("dbmdelete");
        allBuiltinFunctions.add("dbmexists");
        allBuiltinFunctions.add("dbmfetch");
        allBuiltinFunctions.add("dbmfirstkey");
        allBuiltinFunctions.add("dbminsert");
        allBuiltinFunctions.add("dbmnextkey");
        allBuiltinFunctions.add("dbmopen");
        allBuiltinFunctions.add("dbmreplace");
        allBuiltinFunctions.add("dbplus_add");
        allBuiltinFunctions.add("dbplus_aql");
        allBuiltinFunctions.add("dbplus_chdir");
        allBuiltinFunctions.add("dbplus_close");
        allBuiltinFunctions.add("dbplus_curr");
        allBuiltinFunctions.add("dbplus_errcode");
        allBuiltinFunctions.add("dbplus_errno");
        allBuiltinFunctions.add("dbplus_find");
        allBuiltinFunctions.add("dbplus_first");
        allBuiltinFunctions.add("dbplus_flush");
        allBuiltinFunctions.add("dbplus_freealllocks");
        allBuiltinFunctions.add("dbplus_freelock");
        allBuiltinFunctions.add("dbplus_freerlocks");
        allBuiltinFunctions.add("dbplus_getlock");
        allBuiltinFunctions.add("dbplus_getunique");
        allBuiltinFunctions.add("dbplus_info");
        allBuiltinFunctions.add("dbplus_last");
        allBuiltinFunctions.add("dbplus_lockrel");
        allBuiltinFunctions.add("dbplus_next");
        allBuiltinFunctions.add("dbplus_open");
        allBuiltinFunctions.add("dbplus_prev");
        allBuiltinFunctions.add("dbplus_rchperm");
        allBuiltinFunctions.add("dbplus_rcreate");
        allBuiltinFunctions.add("dbplus_rcrtexact");
        allBuiltinFunctions.add("dbplus_rcrtlike");
        allBuiltinFunctions.add("dbplus_resolve");
        allBuiltinFunctions.add("dbplus_restorepos");
        allBuiltinFunctions.add("dbplus_rkeys");
        allBuiltinFunctions.add("dbplus_ropen");
        allBuiltinFunctions.add("dbplus_rquery");
        allBuiltinFunctions.add("dbplus_rrename");
        allBuiltinFunctions.add("dbplus_rsecindex");
        allBuiltinFunctions.add("dbplus_runlink");
        allBuiltinFunctions.add("dbplus_rzap");
        allBuiltinFunctions.add("dbplus_savepos");
        allBuiltinFunctions.add("dbplus_setindex");
        allBuiltinFunctions.add("dbplus_setindexbynumber");
        allBuiltinFunctions.add("dbplus_sql");
        allBuiltinFunctions.add("dbplus_tcl");
        allBuiltinFunctions.add("dbplus_tremove");
        allBuiltinFunctions.add("dbplus_undo");
        allBuiltinFunctions.add("dbplus_undoprepare");
        allBuiltinFunctions.add("dbplus_unlockrel");
        allBuiltinFunctions.add("dbplus_unselect");
        allBuiltinFunctions.add("dbplus_update");
        allBuiltinFunctions.add("dbplus_xlockrel");
        allBuiltinFunctions.add("dbplus_xunlockrel");
        allBuiltinFunctions.add("dbx_close");
        allBuiltinFunctions.add("dbx_compare");
        allBuiltinFunctions.add("dbx_connect");
        allBuiltinFunctions.add("dbx_error");
        allBuiltinFunctions.add("dbx_escape_string");
        allBuiltinFunctions.add("dbx_fetch_row");
        allBuiltinFunctions.add("dbx_query");
        allBuiltinFunctions.add("dbx_sort");
        allBuiltinFunctions.add("dcgettext");
        allBuiltinFunctions.add("dcngettext");
        allBuiltinFunctions.add("deaggregate");
        allBuiltinFunctions.add("debug_backtrace");
        allBuiltinFunctions.add("debug_print_backtrace");
        allBuiltinFunctions.add("debug_zval_dump");
        allBuiltinFunctions.add("debugger_off");
        allBuiltinFunctions.add("debugger_on");
        allBuiltinFunctions.add("decbin");
        allBuiltinFunctions.add("dechex");
        allBuiltinFunctions.add("decoct");
        allBuiltinFunctions.add("define");
        allBuiltinFunctions.add("define_syslog_variables");
        allBuiltinFunctions.add("defined");
        allBuiltinFunctions.add("deg2rad");
        allBuiltinFunctions.add("delete");
        allBuiltinFunctions.add("descriptor->free");
        allBuiltinFunctions.add("dgettext");
        allBuiltinFunctions.add("die");
        allBuiltinFunctions.add("dio_close");
        allBuiltinFunctions.add("dio_fcntl");
        allBuiltinFunctions.add("dio_open");
        allBuiltinFunctions.add("dio_read");
        allBuiltinFunctions.add("dio_seek");
        allBuiltinFunctions.add("dio_stat");
        allBuiltinFunctions.add("dio_tcsetattr");
        allBuiltinFunctions.add("dio_truncate");
        allBuiltinFunctions.add("dio_write");
        allBuiltinFunctions.add("dir");
        allBuiltinFunctions.add("DirectoryIterator::__construct");
        allBuiltinFunctions.add("DirectoryIterator::current");
        allBuiltinFunctions.add("DirectoryIterator::getATime");
        allBuiltinFunctions.add("DirectoryIterator::getChildren");
        allBuiltinFunctions.add("DirectoryIterator::getCTime");
        allBuiltinFunctions.add("DirectoryIterator::getFilename");
        allBuiltinFunctions.add("DirectoryIterator::getGroup");
        allBuiltinFunctions.add("DirectoryIterator::getInode");
        allBuiltinFunctions.add("DirectoryIterator::getMTime");
        allBuiltinFunctions.add("DirectoryIterator::getOwner");
        allBuiltinFunctions.add("DirectoryIterator::getPath");
        allBuiltinFunctions.add("DirectoryIterator::getPathname");
        allBuiltinFunctions.add("DirectoryIterator::getPerms");
        allBuiltinFunctions.add("DirectoryIterator::getSize");
        allBuiltinFunctions.add("DirectoryIterator::getType");
        allBuiltinFunctions.add("DirectoryIterator::isDir");
        allBuiltinFunctions.add("DirectoryIterator::isDot");
        allBuiltinFunctions.add("DirectoryIterator::isExecutable");
        allBuiltinFunctions.add("DirectoryIterator::isFile");
        allBuiltinFunctions.add("DirectoryIterator::isLink");
        allBuiltinFunctions.add("DirectoryIterator::isReadable");
        allBuiltinFunctions.add("DirectoryIterator::isWritable");
        allBuiltinFunctions.add("DirectoryIterator::key");
        allBuiltinFunctions.add("DirectoryIterator::next");
        allBuiltinFunctions.add("DirectoryIterator::rewind");
        allBuiltinFunctions.add("DirectoryIterator::valid");
        allBuiltinFunctions.add("dirname");
        allBuiltinFunctions.add("disk_free_space");
        allBuiltinFunctions.add("disk_total_space");
        allBuiltinFunctions.add("diskfreespace");
        allBuiltinFunctions.add("dl");
        allBuiltinFunctions.add("dngettext");
        allBuiltinFunctions.add("dns_check_record");
        allBuiltinFunctions.add("dns_get_mx");
        allBuiltinFunctions.add("dns_get_record");
        allBuiltinFunctions.add("dom_import_simplexml");
        allBuiltinFunctions.add("DOMAttr->isId");
        allBuiltinFunctions.add("DomAttribute->name");
        allBuiltinFunctions.add("DomAttribute->specified");
        allBuiltinFunctions.add("DomAttribute->value");
        allBuiltinFunctions.add("DOMCharacterData->appendData");
        allBuiltinFunctions.add("DOMCharacterData->deleteData");
        allBuiltinFunctions.add("DOMCharacterData->insertData");
        allBuiltinFunctions.add("DOMCharacterData->replaceData");
        allBuiltinFunctions.add("DOMCharacterData->substringData");
        allBuiltinFunctions.add("DOMDocument->__construct");
        allBuiltinFunctions.add("DomDocument->add_root");
        allBuiltinFunctions.add("DomDocument->create_attribute");
        allBuiltinFunctions.add("DomDocument->create_cdata_section");
        allBuiltinFunctions.add("DomDocument->create_comment");
        allBuiltinFunctions.add("DomDocument->create_element");
        allBuiltinFunctions.add("DomDocument->create_element_ns");
        allBuiltinFunctions.add("DomDocument->create_entity_reference");
        allBuiltinFunctions.add("DomDocument->create_processing_instruction");
        allBuiltinFunctions.add("DomDocument->create_text_node");
        allBuiltinFunctions.add("DOMDocument->createAttribute");
        allBuiltinFunctions.add("DOMDocument->createAttributeNS");
        allBuiltinFunctions.add("DOMDocument->createCDATASection");
        allBuiltinFunctions.add("DOMDocument->createComment");
        allBuiltinFunctions.add("DOMDocument->createDocumentFragment");
        allBuiltinFunctions.add("DOMDocument->createElement");
        allBuiltinFunctions.add("DOMDocument->createElementNS");
        allBuiltinFunctions.add("DOMDocument->createEntityReference");
        allBuiltinFunctions.add("DOMDocument->createProcessingInstruction");
        allBuiltinFunctions.add("DOMDocument->createTextNode");
        allBuiltinFunctions.add("DomDocument->doctype");
        allBuiltinFunctions.add("DomDocument->document_element");
        allBuiltinFunctions.add("DomDocument->dump_file");
        allBuiltinFunctions.add("DomDocument->dump_mem");
        allBuiltinFunctions.add("DomDocument->get_element_by_id");
        allBuiltinFunctions.add("DomDocument->get_elements_by_tagname");
        allBuiltinFunctions.add("DOMDocument->getElementById");
        allBuiltinFunctions.add("DOMDocument->getElementsByTagName");
        allBuiltinFunctions.add("DOMDocument->getElementsByTagNameNS()");
        allBuiltinFunctions.add("DomDocument->html_dump_mem");
        allBuiltinFunctions.add("DOMDocument->importNode");
        allBuiltinFunctions.add("DOMDocument->load");
        allBuiltinFunctions.add("DOMDocument->loadHTML");
        allBuiltinFunctions.add("DOMDocument->loadHTMLFile");
        allBuiltinFunctions.add("DOMDocument->loadXML");
        allBuiltinFunctions.add("DOMDocument->normalize");
        allBuiltinFunctions.add("DOMDocument->relaxNGValidate");
        allBuiltinFunctions.add("DOMDocument->relaxNGValidateSource");
        allBuiltinFunctions.add("DOMDocument->save");
        allBuiltinFunctions.add("DOMDocument->saveHTML()");
        allBuiltinFunctions.add("DOMDocument->saveHTMLFile()");
        allBuiltinFunctions.add("DOMDocument->saveXML()");
        allBuiltinFunctions.add("DOMDocument->schemaValidate");
        allBuiltinFunctions.add("DOMDocument->schemaValidateSource");
        allBuiltinFunctions.add("DOMDocument->validate");
        allBuiltinFunctions.add("DOMDocument->xinclude");
        allBuiltinFunctions.add("DomDocument->xinclude");
        allBuiltinFunctions.add("DomDocumentType->entities");
        allBuiltinFunctions.add("DomDocumentType->internal_subset");
        allBuiltinFunctions.add("DomDocumentType->name");
        allBuiltinFunctions.add("DomDocumentType->notations");
        allBuiltinFunctions.add("DomDocumentType->public_id");
        allBuiltinFunctions.add("DomDocumentType->system_id");
        allBuiltinFunctions.add("DomElement->get_attribute");
        allBuiltinFunctions.add("DomElement->get_attribute_node");
        allBuiltinFunctions.add("DomElement->get_elements_by_tagname");
        allBuiltinFunctions.add("DOMElement->getAttribute");
        allBuiltinFunctions.add("DOMElement->getAttributeNode");
        allBuiltinFunctions.add("DOMElement->getAttributeNodeNS");
        allBuiltinFunctions.add("DOMElement->getAttributeNS");
        allBuiltinFunctions.add("DOMElement->getElementsByTagName");
        allBuiltinFunctions.add("DOMElement->getElementsByTagNameNS");
        allBuiltinFunctions.add("DomElement->has_attribute");
        allBuiltinFunctions.add("DOMElement->hasAttribute");
        allBuiltinFunctions.add("DOMElement->hasAttributeNS");
        allBuiltinFunctions.add("DomElement->remove_attribute");
        allBuiltinFunctions.add("DOMElement->removeAttribute");
        allBuiltinFunctions.add("DOMElement->removeAttributeNode");
        allBuiltinFunctions.add("DOMElement->removeAttributeNS");
        allBuiltinFunctions.add("DomElement->set_attribute");
        allBuiltinFunctions.add("DOMElement->setAttribute");
        allBuiltinFunctions.add("DOMElement->setAttributeNode");
        allBuiltinFunctions.add("DOMElement->setAttributeNodeNS");
        allBuiltinFunctions.add("DOMElement->setAttributeNS");
        allBuiltinFunctions.add("DomElement->tagname");
        allBuiltinFunctions.add("DOMImplementation->createDocument");
        allBuiltinFunctions.add("DOMImplementation->createDocumentType");
        allBuiltinFunctions.add("DOMImplementation->hasFeature()");
        allBuiltinFunctions.add("DOMNamedNodeMap->getNamedItem");
        allBuiltinFunctions.add("DOMNamedNodeMap->getNamedItemNS");
        allBuiltinFunctions.add("DOMNamedNodeMap->item");
        allBuiltinFunctions.add("DomNode->add_namespace");
        allBuiltinFunctions.add("DomNode->append_child");
        allBuiltinFunctions.add("DomNode->append_sibling");
        allBuiltinFunctions.add("DOMNode->appendChild");
        allBuiltinFunctions.add("DomNode->attributes");
        allBuiltinFunctions.add("DomNode->child_nodes");
        allBuiltinFunctions.add("DomNode->clone_node");
        allBuiltinFunctions.add("DOMNode->cloneNode");
        allBuiltinFunctions.add("DomNode->dump_node");
        allBuiltinFunctions.add("DomNode->first_child");
        allBuiltinFunctions.add("DomNode->get_content");
        allBuiltinFunctions.add("DomNode->has_attributes");
        allBuiltinFunctions.add("DomNode->has_child_nodes");
        allBuiltinFunctions.add("DOMNode->hasAttributes");
        allBuiltinFunctions.add("DOMNode->hasChildNodes");
        allBuiltinFunctions.add("DomNode->insert_before");
        allBuiltinFunctions.add("DOMNode->insertBefore");
        allBuiltinFunctions.add("DomNode->is_blank_node");
        allBuiltinFunctions.add("DOMNode->isSameNode");
        allBuiltinFunctions.add("DOMNode->isSupported");
        allBuiltinFunctions.add("DomNode->last_child");
        allBuiltinFunctions.add("DOMNode->lookupNamespaceURI");
        allBuiltinFunctions.add("DOMNode->lookupPrefix");
        allBuiltinFunctions.add("DomNode->next_sibling");
        allBuiltinFunctions.add("DomNode->node_name");
        allBuiltinFunctions.add("DomNode->node_type");
        allBuiltinFunctions.add("DomNode->node_value");
        allBuiltinFunctions.add("DOMNode->normalize");
        allBuiltinFunctions.add("DomNode->owner_document");
        allBuiltinFunctions.add("DomNode->parent_node");
        allBuiltinFunctions.add("DomNode->prefix");
        allBuiltinFunctions.add("DomNode->previous_sibling");
        allBuiltinFunctions.add("DomNode->remove_child");
        allBuiltinFunctions.add("DOMNode->removeChild");
        allBuiltinFunctions.add("DomNode->replace_child");
        allBuiltinFunctions.add("DomNode->replace_node");
        allBuiltinFunctions.add("DOMNode->replaceChild");
        allBuiltinFunctions.add("DomNode->set_content");
        allBuiltinFunctions.add("DomNode->set_name");
        allBuiltinFunctions.add("DomNode->set_namespace");
        allBuiltinFunctions.add("DomNode->unlink_node");
        allBuiltinFunctions.add("DOMNodelist->item");
        allBuiltinFunctions.add("DomProcessingInstruction->data");
        allBuiltinFunctions.add("DomProcessingInstruction->target");
        allBuiltinFunctions.add("DOMStringList->item");
        allBuiltinFunctions.add("DOMText->isWhitespaceInElementContent");
        allBuiltinFunctions.add("DOMText->splitText");
        allBuiltinFunctions.add("domxml_new_doc");
        allBuiltinFunctions.add("domxml_open_file");
        allBuiltinFunctions.add("domxml_open_mem");
        allBuiltinFunctions.add("domxml_version");
        allBuiltinFunctions.add("domxml_xmltree");
        allBuiltinFunctions.add("domxml_xslt_stylesheet");
        allBuiltinFunctions.add("domxml_xslt_stylesheet_doc");
        allBuiltinFunctions.add("domxml_xslt_stylesheet_file");
        allBuiltinFunctions.add("DOMXPath->__construct");
        allBuiltinFunctions.add("DOMXPath->evaluate()");
        allBuiltinFunctions.add("DOMXPath->query");
        allBuiltinFunctions.add("DOMXPath->registerNamespace");
        allBuiltinFunctions.add("DomXsltStylesheet->process");
        allBuiltinFunctions.add("DomXsltStylesheet->result_dump_file");
        allBuiltinFunctions.add("DomXsltStylesheet->result_dump_mem");
        allBuiltinFunctions.add("dotnet");
        allBuiltinFunctions.add("dotnet_load");
        allBuiltinFunctions.add("doubleval");
        allBuiltinFunctions.add("each");
        allBuiltinFunctions.add("easter_date");
        allBuiltinFunctions.add("easter_days");
        allBuiltinFunctions.add("ebcdic2ascii");
        allBuiltinFunctions.add("echo");
        allBuiltinFunctions.add("empty");
        allBuiltinFunctions.add("end");
        allBuiltinFunctions.add("ereg");
        allBuiltinFunctions.add("ereg_replace");
        allBuiltinFunctions.add("eregi");
        allBuiltinFunctions.add("eregi_replace");
        allBuiltinFunctions.add("error_log");
        allBuiltinFunctions.add("error_reporting");
        allBuiltinFunctions.add("escapeshellarg");
        allBuiltinFunctions.add("escapeshellcmd");
        allBuiltinFunctions.add("eval");
        allBuiltinFunctions.add("exec");
        allBuiltinFunctions.add("exif_imagetype");
        allBuiltinFunctions.add("exif_read_data");
        allBuiltinFunctions.add("exif_tagname");
        allBuiltinFunctions.add("exif_thumbnail");
        allBuiltinFunctions.add("exit");
        allBuiltinFunctions.add("exp");
        allBuiltinFunctions.add("explode");
        allBuiltinFunctions.add("expm1");
        allBuiltinFunctions.add("extension_loaded");
        allBuiltinFunctions.add("extract");
        allBuiltinFunctions.add("ezmlm_hash");
        allBuiltinFunctions.add("fam_cancel_monitor");
        allBuiltinFunctions.add("fam_close");
        allBuiltinFunctions.add("fam_monitor_collection");
        allBuiltinFunctions.add("fam_monitor_directory");
        allBuiltinFunctions.add("fam_monitor_file");
        allBuiltinFunctions.add("fam_next_event");
        allBuiltinFunctions.add("fam_open");
        allBuiltinFunctions.add("fam_pending");
        allBuiltinFunctions.add("fam_resume_monitor");
        allBuiltinFunctions.add("fam_suspend_monitor");
        allBuiltinFunctions.add("fbsql_affected_rows");
        allBuiltinFunctions.add("fbsql_autocommit");
        allBuiltinFunctions.add("fbsql_blob_size");
        allBuiltinFunctions.add("fbsql_change_user");
        allBuiltinFunctions.add("fbsql_clob_size");
        allBuiltinFunctions.add("fbsql_close");
        allBuiltinFunctions.add("fbsql_commit");
        allBuiltinFunctions.add("fbsql_connect");
        allBuiltinFunctions.add("fbsql_create_blob");
        allBuiltinFunctions.add("fbsql_create_clob");
        allBuiltinFunctions.add("fbsql_create_db");
        allBuiltinFunctions.add("fbsql_data_seek");
        allBuiltinFunctions.add("fbsql_database");
        allBuiltinFunctions.add("fbsql_database_password");
        allBuiltinFunctions.add("fbsql_db_query");
        allBuiltinFunctions.add("fbsql_db_status");
        allBuiltinFunctions.add("fbsql_drop_db");
        allBuiltinFunctions.add("fbsql_errno");
        allBuiltinFunctions.add("fbsql_error");
        allBuiltinFunctions.add("fbsql_fetch_array");
        allBuiltinFunctions.add("fbsql_fetch_assoc");
        allBuiltinFunctions.add("fbsql_fetch_field");
        allBuiltinFunctions.add("fbsql_fetch_lengths");
        allBuiltinFunctions.add("fbsql_fetch_object");
        allBuiltinFunctions.add("fbsql_fetch_row");
        allBuiltinFunctions.add("fbsql_field_flags");
        allBuiltinFunctions.add("fbsql_field_len");
        allBuiltinFunctions.add("fbsql_field_name");
        allBuiltinFunctions.add("fbsql_field_seek");
        allBuiltinFunctions.add("fbsql_field_table");
        allBuiltinFunctions.add("fbsql_field_type");
        allBuiltinFunctions.add("fbsql_free_result");
        allBuiltinFunctions.add("fbsql_get_autostart_info");
        allBuiltinFunctions.add("fbsql_hostname");
        allBuiltinFunctions.add("fbsql_insert_id");
        allBuiltinFunctions.add("fbsql_list_dbs");
        allBuiltinFunctions.add("fbsql_list_fields");
        allBuiltinFunctions.add("fbsql_list_tables");
        allBuiltinFunctions.add("fbsql_next_result");
        allBuiltinFunctions.add("fbsql_num_fields");
        allBuiltinFunctions.add("fbsql_num_rows");
        allBuiltinFunctions.add("fbsql_password");
        allBuiltinFunctions.add("fbsql_pconnect");
        allBuiltinFunctions.add("fbsql_query");
        allBuiltinFunctions.add("fbsql_read_blob");
        allBuiltinFunctions.add("fbsql_read_clob");
        allBuiltinFunctions.add("fbsql_result");
        allBuiltinFunctions.add("fbsql_rollback");
        allBuiltinFunctions.add("fbsql_select_db");
        allBuiltinFunctions.add("fbsql_set_lob_mode");
        allBuiltinFunctions.add("fbsql_set_password");
        allBuiltinFunctions.add("fbsql_set_transaction");
        allBuiltinFunctions.add("fbsql_start_db");
        allBuiltinFunctions.add("fbsql_stop_db");
        allBuiltinFunctions.add("fbsql_tablename");
        allBuiltinFunctions.add("fbsql_username");
        allBuiltinFunctions.add("fbsql_warnings");
        allBuiltinFunctions.add("fclose");
        allBuiltinFunctions.add("fdf_add_doc_javascript");
        allBuiltinFunctions.add("fdf_add_template");
        allBuiltinFunctions.add("fdf_close");
        allBuiltinFunctions.add("fdf_create");
        allBuiltinFunctions.add("fdf_enum_values");
        allBuiltinFunctions.add("fdf_errno");
        allBuiltinFunctions.add("fdf_error");
        allBuiltinFunctions.add("fdf_get_ap");
        allBuiltinFunctions.add("fdf_get_attachment");
        allBuiltinFunctions.add("fdf_get_encoding");
        allBuiltinFunctions.add("fdf_get_file");
        allBuiltinFunctions.add("fdf_get_flags");
        allBuiltinFunctions.add("fdf_get_opt");
        allBuiltinFunctions.add("fdf_get_status");
        allBuiltinFunctions.add("fdf_get_value");
        allBuiltinFunctions.add("fdf_get_version");
        allBuiltinFunctions.add("fdf_header");
        allBuiltinFunctions.add("fdf_next_field_name");
        allBuiltinFunctions.add("fdf_open");
        allBuiltinFunctions.add("fdf_open_string");
        allBuiltinFunctions.add("fdf_remove_item");
        allBuiltinFunctions.add("fdf_save");
        allBuiltinFunctions.add("fdf_save_string");
        allBuiltinFunctions.add("fdf_set_ap");
        allBuiltinFunctions.add("fdf_set_encoding");
        allBuiltinFunctions.add("fdf_set_file");
        allBuiltinFunctions.add("fdf_set_flags");
        allBuiltinFunctions.add("fdf_set_javascript_action");
        allBuiltinFunctions.add("fdf_set_on_import_javascript");
        allBuiltinFunctions.add("fdf_set_opt");
        allBuiltinFunctions.add("fdf_set_status");
        allBuiltinFunctions.add("fdf_set_submit_form_action");
        allBuiltinFunctions.add("fdf_set_target_frame");
        allBuiltinFunctions.add("fdf_set_value");
        allBuiltinFunctions.add("fdf_set_version");
        allBuiltinFunctions.add("feof");
        allBuiltinFunctions.add("fflush");
        allBuiltinFunctions.add("fgetc");
        allBuiltinFunctions.add("fgetcsv");
        allBuiltinFunctions.add("fgets");
        allBuiltinFunctions.add("fgetss");
        allBuiltinFunctions.add("file");
        allBuiltinFunctions.add("file_exists");
        allBuiltinFunctions.add("file_get_contents");
        allBuiltinFunctions.add("file_put_contents");
        allBuiltinFunctions.add("fileatime");
        allBuiltinFunctions.add("filectime");
        allBuiltinFunctions.add("filegroup");
        allBuiltinFunctions.add("fileinode");
        allBuiltinFunctions.add("filemtime");
        allBuiltinFunctions.add("fileowner");
        allBuiltinFunctions.add("fileperms");
        allBuiltinFunctions.add("filepro");
        allBuiltinFunctions.add("filepro_fieldcount");
        allBuiltinFunctions.add("filepro_fieldname");
        allBuiltinFunctions.add("filepro_fieldtype");
        allBuiltinFunctions.add("filepro_fieldwidth");
        allBuiltinFunctions.add("filepro_retrieve");
        allBuiltinFunctions.add("filepro_rowcount");
        allBuiltinFunctions.add("filesize");
        allBuiltinFunctions.add("filetype");
        allBuiltinFunctions.add("FilterIterator::current");
        allBuiltinFunctions.add("FilterIterator::getInnerIterator");
        allBuiltinFunctions.add("FilterIterator::key");
        allBuiltinFunctions.add("FilterIterator::next");
        allBuiltinFunctions.add("FilterIterator::rewind");
        allBuiltinFunctions.add("FilterIterator::valid");
        allBuiltinFunctions.add("floatval");
        allBuiltinFunctions.add("flock");
        allBuiltinFunctions.add("floor");
        allBuiltinFunctions.add("flush");
        allBuiltinFunctions.add("fmod");
        allBuiltinFunctions.add("fnmatch");
        allBuiltinFunctions.add("fopen");
        allBuiltinFunctions.add("fpassthru");
        allBuiltinFunctions.add("fprintf");
        allBuiltinFunctions.add("fputcsv");
        allBuiltinFunctions.add("fputs");
        allBuiltinFunctions.add("fread");
        allBuiltinFunctions.add("frenchtojd");
        allBuiltinFunctions.add("fribidi_log2vis");
        allBuiltinFunctions.add("fscanf");
        allBuiltinFunctions.add("fseek");
        allBuiltinFunctions.add("fsockopen");
        allBuiltinFunctions.add("fstat");
        allBuiltinFunctions.add("ftell");
        allBuiltinFunctions.add("ftok");
        allBuiltinFunctions.add("ftp_alloc");
        allBuiltinFunctions.add("ftp_cdup");
        allBuiltinFunctions.add("ftp_chdir");
        allBuiltinFunctions.add("ftp_chmod");
        allBuiltinFunctions.add("ftp_close");
        allBuiltinFunctions.add("ftp_connect");
        allBuiltinFunctions.add("ftp_delete");
        allBuiltinFunctions.add("ftp_exec");
        allBuiltinFunctions.add("ftp_fget");
        allBuiltinFunctions.add("ftp_fput");
        allBuiltinFunctions.add("ftp_get");
        allBuiltinFunctions.add("ftp_get_option");
        allBuiltinFunctions.add("ftp_login");
        allBuiltinFunctions.add("ftp_mdtm");
        allBuiltinFunctions.add("ftp_mkdir");
        allBuiltinFunctions.add("ftp_nb_continue");
        allBuiltinFunctions.add("ftp_nb_fget");
        allBuiltinFunctions.add("ftp_nb_fput");
        allBuiltinFunctions.add("ftp_nb_get");
        allBuiltinFunctions.add("ftp_nb_put");
        allBuiltinFunctions.add("ftp_nlist");
        allBuiltinFunctions.add("ftp_pasv");
        allBuiltinFunctions.add("ftp_put");
        allBuiltinFunctions.add("ftp_pwd");
        allBuiltinFunctions.add("ftp_quit");
        allBuiltinFunctions.add("ftp_raw");
        allBuiltinFunctions.add("ftp_rawlist");
        allBuiltinFunctions.add("ftp_rename");
        allBuiltinFunctions.add("ftp_rmdir");
        allBuiltinFunctions.add("ftp_set_option");
        allBuiltinFunctions.add("ftp_site");
        allBuiltinFunctions.add("ftp_size");
        allBuiltinFunctions.add("ftp_ssl_connect");
        allBuiltinFunctions.add("ftp_systype");
        allBuiltinFunctions.add("ftruncate");
        allBuiltinFunctions.add("func_get_arg");
        allBuiltinFunctions.add("func_get_args");
        allBuiltinFunctions.add("func_num_args");
        allBuiltinFunctions.add("function_exists");
        allBuiltinFunctions.add("fwrite");
        allBuiltinFunctions.add("gd_info");
        allBuiltinFunctions.add("get_browser");
        allBuiltinFunctions.add("get_cfg_var");
        allBuiltinFunctions.add("get_class");
        allBuiltinFunctions.add("get_class_methods");
        allBuiltinFunctions.add("get_class_vars");
        allBuiltinFunctions.add("get_current_user");
        allBuiltinFunctions.add("get_declared_classes");
        allBuiltinFunctions.add("get_declared_interfaces");
        allBuiltinFunctions.add("get_defined_constants");
        allBuiltinFunctions.add("get_defined_functions");
        allBuiltinFunctions.add("get_defined_vars");
        allBuiltinFunctions.add("get_extension_funcs");
        allBuiltinFunctions.add("get_headers");
        allBuiltinFunctions.add("get_html_translation_table");
        allBuiltinFunctions.add("get_include_path");
        allBuiltinFunctions.add("get_included_files");
        allBuiltinFunctions.add("get_loaded_extensions");
        allBuiltinFunctions.add("get_magic_quotes_gpc");
        allBuiltinFunctions.add("get_magic_quotes_runtime");
        allBuiltinFunctions.add("get_meta_tags");
        allBuiltinFunctions.add("get_object_vars");
        allBuiltinFunctions.add("get_parent_class");
        allBuiltinFunctions.add("get_required_files");
        allBuiltinFunctions.add("get_resource_type");
        allBuiltinFunctions.add("getallheaders");
        allBuiltinFunctions.add("getcwd");
        allBuiltinFunctions.add("getdate");
        allBuiltinFunctions.add("getenv");
        allBuiltinFunctions.add("gethostbyaddr");
        allBuiltinFunctions.add("gethostbyname");
        allBuiltinFunctions.add("gethostbynamel");
        allBuiltinFunctions.add("getimagesize");
        allBuiltinFunctions.add("getlastmod");
        allBuiltinFunctions.add("getmxrr");
        allBuiltinFunctions.add("getmygid");
        allBuiltinFunctions.add("getmyinode");
        allBuiltinFunctions.add("getmypid");
        allBuiltinFunctions.add("getmyuid");
        allBuiltinFunctions.add("getopt");
        allBuiltinFunctions.add("getprotobyname");
        allBuiltinFunctions.add("getprotobynumber");
        allBuiltinFunctions.add("getrandmax");
        allBuiltinFunctions.add("getrusage");
        allBuiltinFunctions.add("getservbyname");
        allBuiltinFunctions.add("getservbyport");
        allBuiltinFunctions.add("gettext");
        allBuiltinFunctions.add("gettimeofday");
        allBuiltinFunctions.add("gettype");
        allBuiltinFunctions.add("glob");
        allBuiltinFunctions.add("gmdate");
        allBuiltinFunctions.add("gmmktime");
        allBuiltinFunctions.add("gmp_abs");
        allBuiltinFunctions.add("gmp_add");
        allBuiltinFunctions.add("gmp_and");
        allBuiltinFunctions.add("gmp_clrbit");
        allBuiltinFunctions.add("gmp_cmp");
        allBuiltinFunctions.add("gmp_com");
        allBuiltinFunctions.add("gmp_div");
        allBuiltinFunctions.add("gmp_div_q");
        allBuiltinFunctions.add("gmp_div_qr");
        allBuiltinFunctions.add("gmp_div_r");
        allBuiltinFunctions.add("gmp_divexact");
        allBuiltinFunctions.add("gmp_fact");
        allBuiltinFunctions.add("gmp_gcd");
        allBuiltinFunctions.add("gmp_gcdext");
        allBuiltinFunctions.add("gmp_hamdist");
        allBuiltinFunctions.add("gmp_init");
        allBuiltinFunctions.add("gmp_intval");
        allBuiltinFunctions.add("gmp_invert");
        allBuiltinFunctions.add("gmp_jacobi");
        allBuiltinFunctions.add("gmp_legendre");
        allBuiltinFunctions.add("gmp_mod");
        allBuiltinFunctions.add("gmp_mul");
        allBuiltinFunctions.add("gmp_neg");
        allBuiltinFunctions.add("gmp_or");
        allBuiltinFunctions.add("gmp_perfect_square");
        allBuiltinFunctions.add("gmp_popcount");
        allBuiltinFunctions.add("gmp_pow");
        allBuiltinFunctions.add("gmp_powm");
        allBuiltinFunctions.add("gmp_prob_prime");
        allBuiltinFunctions.add("gmp_random");
        allBuiltinFunctions.add("gmp_scan0");
        allBuiltinFunctions.add("gmp_scan1");
        allBuiltinFunctions.add("gmp_setbit");
        allBuiltinFunctions.add("gmp_sign");
        allBuiltinFunctions.add("gmp_sqrt");
        allBuiltinFunctions.add("gmp_sqrtrem");
        allBuiltinFunctions.add("gmp_strval");
        allBuiltinFunctions.add("gmp_sub");
        allBuiltinFunctions.add("gmp_xor");
        allBuiltinFunctions.add("gmstrftime");
        allBuiltinFunctions.add("gregoriantojd");
        allBuiltinFunctions.add("gzclose");
        allBuiltinFunctions.add("gzcompress");
        allBuiltinFunctions.add("gzdeflate");
        allBuiltinFunctions.add("gzencode");
        allBuiltinFunctions.add("gzeof");
        allBuiltinFunctions.add("gzfile");
        allBuiltinFunctions.add("gzgetc");
        allBuiltinFunctions.add("gzgets");
        allBuiltinFunctions.add("gzgetss");
        allBuiltinFunctions.add("gzinflate");
        allBuiltinFunctions.add("gzopen");
        allBuiltinFunctions.add("gzpassthru");
        allBuiltinFunctions.add("gzputs");
        allBuiltinFunctions.add("gzread");
        allBuiltinFunctions.add("gzrewind");
        allBuiltinFunctions.add("gzseek");
        allBuiltinFunctions.add("gztell");
        allBuiltinFunctions.add("gzuncompress");
        allBuiltinFunctions.add("gzwrite");
        allBuiltinFunctions.add("header");
        allBuiltinFunctions.add("headers_list");
        allBuiltinFunctions.add("headers_sent");
        allBuiltinFunctions.add("hebrev");
        allBuiltinFunctions.add("hebrevc");
        allBuiltinFunctions.add("hexdec");
        allBuiltinFunctions.add("highlight_file");
        allBuiltinFunctions.add("highlight_string");
        allBuiltinFunctions.add("html_entity_decode");
        allBuiltinFunctions.add("htmlentities");
        allBuiltinFunctions.add("htmlspecialchars");
        allBuiltinFunctions.add("http_build_query");
        allBuiltinFunctions.add("hw_api->checkin");
        allBuiltinFunctions.add("hw_api->checkout");
        allBuiltinFunctions.add("hw_api->children");
        allBuiltinFunctions.add("hw_api->content");
        allBuiltinFunctions.add("hw_api->copy");
        allBuiltinFunctions.add("hw_api->dbstat");
        allBuiltinFunctions.add("hw_api->dcstat");
        allBuiltinFunctions.add("hw_api->dstanchors");
        allBuiltinFunctions.add("hw_api->dstofsrcanchor");
        allBuiltinFunctions.add("hw_api->find");
        allBuiltinFunctions.add("hw_api->ftstat");
        allBuiltinFunctions.add("hw_api->hwstat");
        allBuiltinFunctions.add("hw_api->identify");
        allBuiltinFunctions.add("hw_api->info");
        allBuiltinFunctions.add("hw_api->insert");
        allBuiltinFunctions.add("hw_api->insertanchor");
        allBuiltinFunctions.add("hw_api->insertcollection");
        allBuiltinFunctions.add("hw_api->insertdocument");
        allBuiltinFunctions.add("hw_api->link");
        allBuiltinFunctions.add("hw_api->lock");
        allBuiltinFunctions.add("hw_api->move");
        allBuiltinFunctions.add("hw_api->object");
        allBuiltinFunctions.add("hw_api->objectbyanchor");
        allBuiltinFunctions.add("hw_api->parents");
        allBuiltinFunctions.add("hw_api->remove");
        allBuiltinFunctions.add("hw_api->replace");
        allBuiltinFunctions.add("hw_api->setcommittedversion");
        allBuiltinFunctions.add("hw_api->srcanchors");
        allBuiltinFunctions.add("hw_api->srcsofdst");
        allBuiltinFunctions.add("hw_api->unlock");
        allBuiltinFunctions.add("hw_api->user");
        allBuiltinFunctions.add("hw_api->userlist");
        allBuiltinFunctions.add("hw_api_attribute");
        allBuiltinFunctions.add("hw_api_attribute->key");
        allBuiltinFunctions.add("hw_api_attribute->langdepvalue");
        allBuiltinFunctions.add("hw_api_attribute->value");
        allBuiltinFunctions.add("hw_api_attribute->values");
        allBuiltinFunctions.add("hw_api_content");
        allBuiltinFunctions.add("hw_api_content->mimetype");
        allBuiltinFunctions.add("hw_api_content->read");
        allBuiltinFunctions.add("hw_api_error->count");
        allBuiltinFunctions.add("hw_api_error->reason");
        allBuiltinFunctions.add("hw_api_object");
        allBuiltinFunctions.add("hw_api_object->assign");
        allBuiltinFunctions.add("hw_api_object->attreditable");
        allBuiltinFunctions.add("hw_api_object->count");
        allBuiltinFunctions.add("hw_api_object->insert");
        allBuiltinFunctions.add("hw_api_object->remove");
        allBuiltinFunctions.add("hw_api_object->title");
        allBuiltinFunctions.add("hw_api_object->value");
        allBuiltinFunctions.add("hw_api_reason->description");
        allBuiltinFunctions.add("hw_api_reason->type");
        allBuiltinFunctions.add("hw_array2objrec");
        allBuiltinFunctions.add("hw_changeobject");
        allBuiltinFunctions.add("hw_children");
        allBuiltinFunctions.add("hw_childrenobj");
        allBuiltinFunctions.add("hw_close");
        allBuiltinFunctions.add("hw_connect");
        allBuiltinFunctions.add("hw_connection_info");
        allBuiltinFunctions.add("hw_cp");
        allBuiltinFunctions.add("hw_deleteobject");
        allBuiltinFunctions.add("hw_docbyanchor");
        allBuiltinFunctions.add("hw_docbyanchorobj");
        allBuiltinFunctions.add("hw_document_attributes");
        allBuiltinFunctions.add("hw_document_bodytag");
        allBuiltinFunctions.add("hw_document_content");
        allBuiltinFunctions.add("hw_document_setcontent");
        allBuiltinFunctions.add("hw_document_size");
        allBuiltinFunctions.add("hw_dummy");
        allBuiltinFunctions.add("hw_edittext");
        allBuiltinFunctions.add("hw_error");
        allBuiltinFunctions.add("hw_errormsg");
        allBuiltinFunctions.add("hw_free_document");
        allBuiltinFunctions.add("hw_getanchors");
        allBuiltinFunctions.add("hw_getanchorsobj");
        allBuiltinFunctions.add("hw_getandlock");
        allBuiltinFunctions.add("hw_getchildcoll");
        allBuiltinFunctions.add("hw_getchildcollobj");
        allBuiltinFunctions.add("hw_getchilddoccoll");
        allBuiltinFunctions.add("hw_getchilddoccollobj");
        allBuiltinFunctions.add("hw_getobject");
        allBuiltinFunctions.add("hw_getobjectbyquery");
        allBuiltinFunctions.add("hw_getobjectbyquerycoll");
        allBuiltinFunctions.add("hw_getobjectbyquerycollobj");
        allBuiltinFunctions.add("hw_getobjectbyqueryobj");
        allBuiltinFunctions.add("hw_getparents");
        allBuiltinFunctions.add("hw_getparentsobj");
        allBuiltinFunctions.add("hw_getrellink");
        allBuiltinFunctions.add("hw_getremote");
        allBuiltinFunctions.add("hw_getremotechildren");
        allBuiltinFunctions.add("hw_getsrcbydestobj");
        allBuiltinFunctions.add("hw_gettext");
        allBuiltinFunctions.add("hw_getusername");
        allBuiltinFunctions.add("hw_identify");
        allBuiltinFunctions.add("hw_incollections");
        allBuiltinFunctions.add("hw_info");
        allBuiltinFunctions.add("hw_inscoll");
        allBuiltinFunctions.add("hw_insdoc");
        allBuiltinFunctions.add("hw_insertanchors");
        allBuiltinFunctions.add("hw_insertdocument");
        allBuiltinFunctions.add("hw_insertobject");
        allBuiltinFunctions.add("hw_mapid");
        allBuiltinFunctions.add("hw_modifyobject");
        allBuiltinFunctions.add("hw_mv");
        allBuiltinFunctions.add("hw_new_document");
        allBuiltinFunctions.add("hw_objrec2array");
        allBuiltinFunctions.add("hw_output_document");
        allBuiltinFunctions.add("hw_pconnect");
        allBuiltinFunctions.add("hw_pipedocument");
        allBuiltinFunctions.add("hw_root");
        allBuiltinFunctions.add("hw_setlinkroot");
        allBuiltinFunctions.add("hw_stat");
        allBuiltinFunctions.add("hw_unlock");
        allBuiltinFunctions.add("hw_who");
        allBuiltinFunctions.add("hwapi_hgcsp");
        allBuiltinFunctions.add("hypot");
        allBuiltinFunctions.add("ibase_add_user");
        allBuiltinFunctions.add("ibase_affected_rows");
        allBuiltinFunctions.add("ibase_backup");
        allBuiltinFunctions.add("ibase_blob_add");
        allBuiltinFunctions.add("ibase_blob_cancel");
        allBuiltinFunctions.add("ibase_blob_close");
        allBuiltinFunctions.add("ibase_blob_create");
        allBuiltinFunctions.add("ibase_blob_echo");
        allBuiltinFunctions.add("ibase_blob_get");
        allBuiltinFunctions.add("ibase_blob_import");
        allBuiltinFunctions.add("ibase_blob_info");
        allBuiltinFunctions.add("ibase_blob_open");
        allBuiltinFunctions.add("ibase_close");
        allBuiltinFunctions.add("ibase_commit");
        allBuiltinFunctions.add("ibase_commit_ret");
        allBuiltinFunctions.add("ibase_connect");
        allBuiltinFunctions.add("ibase_db_info");
        allBuiltinFunctions.add("ibase_delete_user");
        allBuiltinFunctions.add("ibase_drop_db");
        allBuiltinFunctions.add("ibase_errcode");
        allBuiltinFunctions.add("ibase_errmsg");
        allBuiltinFunctions.add("ibase_execute");
        allBuiltinFunctions.add("ibase_fetch_assoc");
        allBuiltinFunctions.add("ibase_fetch_object");
        allBuiltinFunctions.add("ibase_fetch_row");
        allBuiltinFunctions.add("ibase_field_info");
        allBuiltinFunctions.add("ibase_free_event_handler");
        allBuiltinFunctions.add("ibase_free_query");
        allBuiltinFunctions.add("ibase_free_result");
        allBuiltinFunctions.add("ibase_gen_id");
        allBuiltinFunctions.add("ibase_maintain_db");
        allBuiltinFunctions.add("ibase_modify_user");
        allBuiltinFunctions.add("ibase_name_result");
        allBuiltinFunctions.add("ibase_num_fields");
        allBuiltinFunctions.add("ibase_num_params");
        allBuiltinFunctions.add("ibase_param_info");
        allBuiltinFunctions.add("ibase_pconnect");
        allBuiltinFunctions.add("ibase_prepare");
        allBuiltinFunctions.add("ibase_query");
        allBuiltinFunctions.add("ibase_restore");
        allBuiltinFunctions.add("ibase_rollback");
        allBuiltinFunctions.add("ibase_rollback_ret");
        allBuiltinFunctions.add("ibase_server_info");
        allBuiltinFunctions.add("ibase_service_attach");
        allBuiltinFunctions.add("ibase_service_detach");
        allBuiltinFunctions.add("ibase_set_event_handler");
        allBuiltinFunctions.add("ibase_timefmt");
        allBuiltinFunctions.add("ibase_trans");
        allBuiltinFunctions.add("ibase_wait_event");
        allBuiltinFunctions.add("iconv");
        allBuiltinFunctions.add("iconv_get_encoding");
        allBuiltinFunctions.add("iconv_mime_decode");
        allBuiltinFunctions.add("iconv_mime_decode_headers");
        allBuiltinFunctions.add("iconv_mime_encode");
        allBuiltinFunctions.add("iconv_set_encoding");
        allBuiltinFunctions.add("iconv_strlen");
        allBuiltinFunctions.add("iconv_strpos");
        allBuiltinFunctions.add("iconv_strrpos");
        allBuiltinFunctions.add("iconv_substr");
        allBuiltinFunctions.add("id3_get_frame_long_name");
        allBuiltinFunctions.add("id3_get_frame_short_name");
        allBuiltinFunctions.add("id3_get_genre_id");
        allBuiltinFunctions.add("id3_get_genre_list");
        allBuiltinFunctions.add("id3_get_genre_name");
        allBuiltinFunctions.add("id3_get_tag");
        allBuiltinFunctions.add("id3_get_version");
        allBuiltinFunctions.add("id3_remove_tag");
        allBuiltinFunctions.add("id3_set_tag");
        allBuiltinFunctions.add("idate");
        allBuiltinFunctions.add("ifx_affected_rows");
        allBuiltinFunctions.add("ifx_blobinfile_mode");
        allBuiltinFunctions.add("ifx_byteasvarchar");
        allBuiltinFunctions.add("ifx_close");
        allBuiltinFunctions.add("ifx_connect");
        allBuiltinFunctions.add("ifx_copy_blob");
        allBuiltinFunctions.add("ifx_create_blob");
        allBuiltinFunctions.add("ifx_create_char");
        allBuiltinFunctions.add("ifx_do");
        allBuiltinFunctions.add("ifx_error");
        allBuiltinFunctions.add("ifx_errormsg");
        allBuiltinFunctions.add("ifx_fetch_row");
        allBuiltinFunctions.add("ifx_fieldproperties");
        allBuiltinFunctions.add("ifx_fieldtypes");
        allBuiltinFunctions.add("ifx_free_blob");
        allBuiltinFunctions.add("ifx_free_char");
        allBuiltinFunctions.add("ifx_free_result");
        allBuiltinFunctions.add("ifx_get_blob");
        allBuiltinFunctions.add("ifx_get_char");
        allBuiltinFunctions.add("ifx_getsqlca");
        allBuiltinFunctions.add("ifx_htmltbl_result");
        allBuiltinFunctions.add("ifx_nullformat");
        allBuiltinFunctions.add("ifx_num_fields");
        allBuiltinFunctions.add("ifx_num_rows");
        allBuiltinFunctions.add("ifx_pconnect");
        allBuiltinFunctions.add("ifx_prepare");
        allBuiltinFunctions.add("ifx_query");
        allBuiltinFunctions.add("ifx_textasvarchar");
        allBuiltinFunctions.add("ifx_update_blob");
        allBuiltinFunctions.add("ifx_update_char");
        allBuiltinFunctions.add("ifxus_close_slob");
        allBuiltinFunctions.add("ifxus_create_slob");
        allBuiltinFunctions.add("ifxus_free_slob");
        allBuiltinFunctions.add("ifxus_open_slob");
        allBuiltinFunctions.add("ifxus_read_slob");
        allBuiltinFunctions.add("ifxus_seek_slob");
        allBuiltinFunctions.add("ifxus_tell_slob");
        allBuiltinFunctions.add("ifxus_write_slob");
        allBuiltinFunctions.add("ignore_user_abort");
        allBuiltinFunctions.add("image2wbmp");
        allBuiltinFunctions.add("image_type_to_extension");
        allBuiltinFunctions.add("image_type_to_mime_type");
        allBuiltinFunctions.add("imagealphablending");
        allBuiltinFunctions.add("imageantialias");
        allBuiltinFunctions.add("imagearc");
        allBuiltinFunctions.add("imagechar");
        allBuiltinFunctions.add("imagecharup");
        allBuiltinFunctions.add("imagecolorallocate");
        allBuiltinFunctions.add("imagecolorallocatealpha");
        allBuiltinFunctions.add("imagecolorat");
        allBuiltinFunctions.add("imagecolorclosest");
        allBuiltinFunctions.add("imagecolorclosestalpha");
        allBuiltinFunctions.add("imagecolorclosesthwb");
        allBuiltinFunctions.add("imagecolordeallocate");
        allBuiltinFunctions.add("imagecolorexact");
        allBuiltinFunctions.add("imagecolorexactalpha");
        allBuiltinFunctions.add("imagecolormatch");
        allBuiltinFunctions.add("imagecolorresolve");
        allBuiltinFunctions.add("imagecolorresolvealpha");
        allBuiltinFunctions.add("imagecolorset");
        allBuiltinFunctions.add("imagecolorsforindex");
        allBuiltinFunctions.add("imagecolorstotal");
        allBuiltinFunctions.add("imagecolortransparent");
        allBuiltinFunctions.add("imagecopy");
        allBuiltinFunctions.add("imagecopymerge");
        allBuiltinFunctions.add("imagecopymergegray");
        allBuiltinFunctions.add("imagecopyresampled");
        allBuiltinFunctions.add("imagecopyresized");
        allBuiltinFunctions.add("imagecreate");
        allBuiltinFunctions.add("imagecreatefromgd");
        allBuiltinFunctions.add("imagecreatefromgd2");
        allBuiltinFunctions.add("imagecreatefromgd2part");
        allBuiltinFunctions.add("imagecreatefromgif");
        allBuiltinFunctions.add("imagecreatefromjpeg");
        allBuiltinFunctions.add("imagecreatefrompng");
        allBuiltinFunctions.add("imagecreatefromstring");
        allBuiltinFunctions.add("imagecreatefromwbmp");
        allBuiltinFunctions.add("imagecreatefromxbm");
        allBuiltinFunctions.add("imagecreatefromxpm");
        allBuiltinFunctions.add("imagecreatetruecolor");
        allBuiltinFunctions.add("imagedashedline");
        allBuiltinFunctions.add("imagedestroy");
        allBuiltinFunctions.add("imageellipse");
        allBuiltinFunctions.add("imagefill");
        allBuiltinFunctions.add("imagefilledarc");
        allBuiltinFunctions.add("imagefilledellipse");
        allBuiltinFunctions.add("imagefilledpolygon");
        allBuiltinFunctions.add("imagefilledrectangle");
        allBuiltinFunctions.add("imagefilltoborder");
        allBuiltinFunctions.add("imagefilter");
        allBuiltinFunctions.add("imagefontheight");
        allBuiltinFunctions.add("imagefontwidth");
        allBuiltinFunctions.add("imageftbbox");
        allBuiltinFunctions.add("imagefttext");
        allBuiltinFunctions.add("imagegammacorrect");
        allBuiltinFunctions.add("imagegd");
        allBuiltinFunctions.add("imagegd2");
        allBuiltinFunctions.add("imagegif");
        allBuiltinFunctions.add("imageinterlace");
        allBuiltinFunctions.add("imageistruecolor");
        allBuiltinFunctions.add("imagejpeg");
        allBuiltinFunctions.add("imagelayereffect");
        allBuiltinFunctions.add("imageline");
        allBuiltinFunctions.add("imageloadfont");
        allBuiltinFunctions.add("imagepalettecopy");
        allBuiltinFunctions.add("imagepng");
        allBuiltinFunctions.add("imagepolygon");
        allBuiltinFunctions.add("imagepsbbox");
        allBuiltinFunctions.add("imagepscopyfont");
        allBuiltinFunctions.add("imagepsencodefont");
        allBuiltinFunctions.add("imagepsextendfont");
        allBuiltinFunctions.add("imagepsfreefont");
        allBuiltinFunctions.add("imagepsloadfont");
        allBuiltinFunctions.add("imagepsslantfont");
        allBuiltinFunctions.add("imagepstext");
        allBuiltinFunctions.add("imagerectangle");
        allBuiltinFunctions.add("imagerotate");
        allBuiltinFunctions.add("imagesavealpha");
        allBuiltinFunctions.add("imagesetbrush");
        allBuiltinFunctions.add("imagesetpixel");
        allBuiltinFunctions.add("imagesetstyle");
        allBuiltinFunctions.add("imagesetthickness");
        allBuiltinFunctions.add("imagesettile");
        allBuiltinFunctions.add("imagestring");
        allBuiltinFunctions.add("imagestringup");
        allBuiltinFunctions.add("imagesx");
        allBuiltinFunctions.add("imagesy");
        allBuiltinFunctions.add("imagetruecolortopalette");
        allBuiltinFunctions.add("imagettfbbox");
        allBuiltinFunctions.add("imagettftext");
        allBuiltinFunctions.add("imagetypes");
        allBuiltinFunctions.add("imagewbmp");
        allBuiltinFunctions.add("imagexbm");
        allBuiltinFunctions.add("imap_8bit");
        allBuiltinFunctions.add("imap_alerts");
        allBuiltinFunctions.add("imap_append");
        allBuiltinFunctions.add("imap_base64");
        allBuiltinFunctions.add("imap_binary");
        allBuiltinFunctions.add("imap_body");
        allBuiltinFunctions.add("imap_bodystruct");
        allBuiltinFunctions.add("imap_check");
        allBuiltinFunctions.add("imap_clearflag_full");
        allBuiltinFunctions.add("imap_close");
        allBuiltinFunctions.add("imap_createmailbox");
        allBuiltinFunctions.add("imap_delete");
        allBuiltinFunctions.add("imap_deletemailbox");
        allBuiltinFunctions.add("imap_errors");
        allBuiltinFunctions.add("imap_expunge");
        allBuiltinFunctions.add("imap_fetch_overview");
        allBuiltinFunctions.add("imap_fetchbody");
        allBuiltinFunctions.add("imap_fetchheader");
        allBuiltinFunctions.add("imap_fetchstructure");
        allBuiltinFunctions.add("imap_get_quota");
        allBuiltinFunctions.add("imap_get_quotaroot");
        allBuiltinFunctions.add("imap_getacl");
        allBuiltinFunctions.add("imap_getmailboxes");
        allBuiltinFunctions.add("imap_getsubscribed");
        allBuiltinFunctions.add("imap_header");
        allBuiltinFunctions.add("imap_headerinfo");
        allBuiltinFunctions.add("imap_headers");
        allBuiltinFunctions.add("imap_last_error");
        allBuiltinFunctions.add("imap_list");
        allBuiltinFunctions.add("imap_listmailbox");
        allBuiltinFunctions.add("imap_listscan");
        allBuiltinFunctions.add("imap_listsubscribed");
        allBuiltinFunctions.add("imap_lsub");
        allBuiltinFunctions.add("imap_mail");
        allBuiltinFunctions.add("imap_mail_compose");
        allBuiltinFunctions.add("imap_mail_copy");
        allBuiltinFunctions.add("imap_mail_move");
        allBuiltinFunctions.add("imap_mailboxmsginfo");
        allBuiltinFunctions.add("imap_mime_header_decode");
        allBuiltinFunctions.add("imap_msgno");
        allBuiltinFunctions.add("imap_num_msg");
        allBuiltinFunctions.add("imap_num_recent");
        allBuiltinFunctions.add("imap_open");
        allBuiltinFunctions.add("imap_ping");
        allBuiltinFunctions.add("imap_qprint");
        allBuiltinFunctions.add("imap_renamemailbox");
        allBuiltinFunctions.add("imap_reopen");
        allBuiltinFunctions.add("imap_rfc822_parse_adrlist");
        allBuiltinFunctions.add("imap_rfc822_parse_headers");
        allBuiltinFunctions.add("imap_rfc822_write_address");
        allBuiltinFunctions.add("imap_scanmailbox");
        allBuiltinFunctions.add("imap_search");
        allBuiltinFunctions.add("imap_set_quota");
        allBuiltinFunctions.add("imap_setacl");
        allBuiltinFunctions.add("imap_setflag_full");
        allBuiltinFunctions.add("imap_sort");
        allBuiltinFunctions.add("imap_status");
        allBuiltinFunctions.add("imap_subscribe");
        allBuiltinFunctions.add("imap_thread");
        allBuiltinFunctions.add("imap_timeout");
        allBuiltinFunctions.add("imap_uid");
        allBuiltinFunctions.add("imap_undelete");
        allBuiltinFunctions.add("imap_unsubscribe");
        allBuiltinFunctions.add("imap_utf7_decode");
        allBuiltinFunctions.add("imap_utf7_encode");
        allBuiltinFunctions.add("imap_utf8");
        allBuiltinFunctions.add("implode");
        allBuiltinFunctions.add("import_request_variables");
        allBuiltinFunctions.add("in_array");
        allBuiltinFunctions.add("inet_ntop");
        allBuiltinFunctions.add("inet_pton");
        allBuiltinFunctions.add("ingres_autocommit");
        allBuiltinFunctions.add("ingres_close");
        allBuiltinFunctions.add("ingres_commit");
        allBuiltinFunctions.add("ingres_connect");
        allBuiltinFunctions.add("ingres_fetch_array");
        allBuiltinFunctions.add("ingres_fetch_object");
        allBuiltinFunctions.add("ingres_fetch_row");
        allBuiltinFunctions.add("ingres_field_length");
        allBuiltinFunctions.add("ingres_field_name");
        allBuiltinFunctions.add("ingres_field_nullable");
        allBuiltinFunctions.add("ingres_field_precision");
        allBuiltinFunctions.add("ingres_field_scale");
        allBuiltinFunctions.add("ingres_field_type");
        allBuiltinFunctions.add("ingres_num_fields");
        allBuiltinFunctions.add("ingres_num_rows");
        allBuiltinFunctions.add("ingres_pconnect");
        allBuiltinFunctions.add("ingres_query");
        allBuiltinFunctions.add("ingres_rollback");
        allBuiltinFunctions.add("ini_alter");
        allBuiltinFunctions.add("ini_get");
        allBuiltinFunctions.add("ini_get_all");
        allBuiltinFunctions.add("ini_restore");
        allBuiltinFunctions.add("ini_set");
        allBuiltinFunctions.add("interface_exists");
        allBuiltinFunctions.add("intval");
        allBuiltinFunctions.add("ip2long");
        allBuiltinFunctions.add("iptcembed");
        allBuiltinFunctions.add("iptcparse");
        allBuiltinFunctions.add("ircg_channel_mode");
        allBuiltinFunctions.add("ircg_disconnect");
        allBuiltinFunctions.add("ircg_eval_ecmascript_params");
        allBuiltinFunctions.add("ircg_fetch_error_msg");
        allBuiltinFunctions.add("ircg_get_username");
        allBuiltinFunctions.add("ircg_html_encode");
        allBuiltinFunctions.add("ircg_ignore_add");
        allBuiltinFunctions.add("ircg_ignore_del");
        allBuiltinFunctions.add("ircg_invite");
        allBuiltinFunctions.add("ircg_is_conn_alive");
        allBuiltinFunctions.add("ircg_join");
        allBuiltinFunctions.add("ircg_kick");
        allBuiltinFunctions.add("ircg_list");
        allBuiltinFunctions.add("ircg_lookup_format_messages");
        allBuiltinFunctions.add("ircg_lusers");
        allBuiltinFunctions.add("ircg_msg");
        allBuiltinFunctions.add("ircg_names");
        allBuiltinFunctions.add("ircg_nick");
        allBuiltinFunctions.add("ircg_nickname_escape");
        allBuiltinFunctions.add("ircg_nickname_unescape");
        allBuiltinFunctions.add("ircg_notice");
        allBuiltinFunctions.add("ircg_oper");
        allBuiltinFunctions.add("ircg_part");
        allBuiltinFunctions.add("ircg_pconnect");
        allBuiltinFunctions.add("ircg_register_format_messages");
        allBuiltinFunctions.add("ircg_set_current");
        allBuiltinFunctions.add("ircg_set_file");
        allBuiltinFunctions.add("ircg_set_on_die");
        allBuiltinFunctions.add("ircg_topic");
        allBuiltinFunctions.add("ircg_who");
        allBuiltinFunctions.add("ircg_whois");
        allBuiltinFunctions.add("is_a");
        allBuiltinFunctions.add("is_array");
        allBuiltinFunctions.add("is_bool");
        allBuiltinFunctions.add("is_callable");
        allBuiltinFunctions.add("is_dir");
        allBuiltinFunctions.add("is_double");
        allBuiltinFunctions.add("is_executable");
        allBuiltinFunctions.add("is_file");
        allBuiltinFunctions.add("is_finite");
        allBuiltinFunctions.add("is_float");
        allBuiltinFunctions.add("is_infinite");
        allBuiltinFunctions.add("is_int");
        allBuiltinFunctions.add("is_integer");
        allBuiltinFunctions.add("is_link");
        allBuiltinFunctions.add("is_long");
        allBuiltinFunctions.add("is_nan");
        allBuiltinFunctions.add("is_null");
        allBuiltinFunctions.add("is_numeric");
        allBuiltinFunctions.add("is_object");
        allBuiltinFunctions.add("is_readable");
        allBuiltinFunctions.add("is_real");
        allBuiltinFunctions.add("is_resource");
        allBuiltinFunctions.add("is_scalar");
        allBuiltinFunctions.add("is_soap_fault");
        allBuiltinFunctions.add("is_string");
        allBuiltinFunctions.add("is_subclass_of");
        allBuiltinFunctions.add("is_uploaded_file");
        allBuiltinFunctions.add("is_writable");
        allBuiltinFunctions.add("is_writeable");
        allBuiltinFunctions.add("isset");
        allBuiltinFunctions.add("iterator-to-array");
        allBuiltinFunctions.add("iterator_count");
        allBuiltinFunctions.add("java_last_exception_clear");
        allBuiltinFunctions.add("java_last_exception_get");
        allBuiltinFunctions.add("jddayofweek");
        allBuiltinFunctions.add("jdmonthname");
        allBuiltinFunctions.add("jdtofrench");
        allBuiltinFunctions.add("jdtogregorian");
        allBuiltinFunctions.add("jdtojewish");
        allBuiltinFunctions.add("jdtojulian");
        allBuiltinFunctions.add("jdtounix");
        allBuiltinFunctions.add("jewishtojd");
        allBuiltinFunctions.add("join");
        allBuiltinFunctions.add("jpeg2wbmp");
        allBuiltinFunctions.add("juliantojd");
        allBuiltinFunctions.add("key");
        allBuiltinFunctions.add("krsort");
        allBuiltinFunctions.add("ksort");
        allBuiltinFunctions.add("lcg_value");
        allBuiltinFunctions.add("ldap_8859_to_t61");
        allBuiltinFunctions.add("ldap_add");
        allBuiltinFunctions.add("ldap_bind");
        allBuiltinFunctions.add("ldap_close");
        allBuiltinFunctions.add("ldap_compare");
        allBuiltinFunctions.add("ldap_connect");
        allBuiltinFunctions.add("ldap_count_entries");
        allBuiltinFunctions.add("ldap_delete");
        allBuiltinFunctions.add("ldap_dn2ufn");
        allBuiltinFunctions.add("ldap_err2str");
        allBuiltinFunctions.add("ldap_errno");
        allBuiltinFunctions.add("ldap_error");
        allBuiltinFunctions.add("ldap_explode_dn");
        allBuiltinFunctions.add("ldap_first_attribute");
        allBuiltinFunctions.add("ldap_first_entry");
        allBuiltinFunctions.add("ldap_first_reference");
        allBuiltinFunctions.add("ldap_free_result");
        allBuiltinFunctions.add("ldap_get_attributes");
        allBuiltinFunctions.add("ldap_get_dn");
        allBuiltinFunctions.add("ldap_get_entries");
        allBuiltinFunctions.add("ldap_get_option");
        allBuiltinFunctions.add("ldap_get_values");
        allBuiltinFunctions.add("ldap_get_values_len");
        allBuiltinFunctions.add("ldap_list");
        allBuiltinFunctions.add("ldap_mod_add");
        allBuiltinFunctions.add("ldap_mod_del");
        allBuiltinFunctions.add("ldap_mod_replace");
        allBuiltinFunctions.add("ldap_modify");
        allBuiltinFunctions.add("ldap_next_attribute");
        allBuiltinFunctions.add("ldap_next_entry");
        allBuiltinFunctions.add("ldap_next_reference");
        allBuiltinFunctions.add("ldap_parse_reference");
        allBuiltinFunctions.add("ldap_parse_result");
        allBuiltinFunctions.add("ldap_read");
        allBuiltinFunctions.add("ldap_rename");
        allBuiltinFunctions.add("ldap_sasl_bind");
        allBuiltinFunctions.add("ldap_search");
        allBuiltinFunctions.add("ldap_set_option");
        allBuiltinFunctions.add("ldap_set_rebind_proc");
        allBuiltinFunctions.add("ldap_sort");
        allBuiltinFunctions.add("ldap_start_tls");
        allBuiltinFunctions.add("ldap_t61_to_8859");
        allBuiltinFunctions.add("ldap_unbind");
        allBuiltinFunctions.add("levenshtein");
        allBuiltinFunctions.add("LimitIterator::getPosition");
        allBuiltinFunctions.add("LimitIterator::next");
        allBuiltinFunctions.add("LimitIterator::rewind");
        allBuiltinFunctions.add("LimitIterator::seek");
        allBuiltinFunctions.add("LimitIterator::valid");
        allBuiltinFunctions.add("link");
        allBuiltinFunctions.add("linkinfo");
        allBuiltinFunctions.add("list");
        allBuiltinFunctions.add("lob->append");
        allBuiltinFunctions.add("lob->close");
        allBuiltinFunctions.add("lob->eof");
        allBuiltinFunctions.add("lob->erase");
        allBuiltinFunctions.add("lob->export");
        allBuiltinFunctions.add("lob->flush");
        allBuiltinFunctions.add("lob->getBuffering");
        allBuiltinFunctions.add("lob->import");
        allBuiltinFunctions.add("lob->load");
        allBuiltinFunctions.add("lob->read");
        allBuiltinFunctions.add("lob->rewind");
        allBuiltinFunctions.add("lob->save");
        allBuiltinFunctions.add("lob->seek");
        allBuiltinFunctions.add("lob->setBuffering");
        allBuiltinFunctions.add("lob->size");
        allBuiltinFunctions.add("lob->tell");
        allBuiltinFunctions.add("lob->truncate");
        allBuiltinFunctions.add("lob->write");
        allBuiltinFunctions.add("lob->writeTemporary");
        allBuiltinFunctions.add("localeconv");
        allBuiltinFunctions.add("localtime");
        allBuiltinFunctions.add("log");
        allBuiltinFunctions.add("log10");
        allBuiltinFunctions.add("log1p");
        allBuiltinFunctions.add("long2ip");
        allBuiltinFunctions.add("lstat");
        allBuiltinFunctions.add("ltrim");
        allBuiltinFunctions.add("lzf_compress");
        allBuiltinFunctions.add("lzf_decompress");
        allBuiltinFunctions.add("lzf_optimized_for");
        allBuiltinFunctions.add("mail");
        allBuiltinFunctions.add("mailparse_determine_best_xfer_encoding");
        allBuiltinFunctions.add("mailparse_msg_create");
        allBuiltinFunctions.add("mailparse_msg_extract_part");
        allBuiltinFunctions.add("mailparse_msg_extract_part_file");
        allBuiltinFunctions.add("mailparse_msg_free");
        allBuiltinFunctions.add("mailparse_msg_get_part");
        allBuiltinFunctions.add("mailparse_msg_get_part_data");
        allBuiltinFunctions.add("mailparse_msg_get_structure");
        allBuiltinFunctions.add("mailparse_msg_parse");
        allBuiltinFunctions.add("mailparse_msg_parse_file");
        allBuiltinFunctions.add("mailparse_rfc822_parse_addresses");
        allBuiltinFunctions.add("mailparse_stream_encode");
        allBuiltinFunctions.add("mailparse_uudecode_all");
        allBuiltinFunctions.add("main");
        allBuiltinFunctions.add("max");
        allBuiltinFunctions.add("mb_convert_case");
        allBuiltinFunctions.add("mb_convert_encoding");
        allBuiltinFunctions.add("mb_convert_kana");
        allBuiltinFunctions.add("mb_convert_variables");
        allBuiltinFunctions.add("mb_decode_mimeheader");
        allBuiltinFunctions.add("mb_decode_numericentity");
        allBuiltinFunctions.add("mb_detect_encoding");
        allBuiltinFunctions.add("mb_detect_order");
        allBuiltinFunctions.add("mb_encode_mimeheader");
        allBuiltinFunctions.add("mb_encode_numericentity");
        allBuiltinFunctions.add("mb_ereg");
        allBuiltinFunctions.add("mb_ereg_match");
        allBuiltinFunctions.add("mb_ereg_replace");
        allBuiltinFunctions.add("mb_ereg_search");
        allBuiltinFunctions.add("mb_ereg_search_getpos");
        allBuiltinFunctions.add("mb_ereg_search_getregs");
        allBuiltinFunctions.add("mb_ereg_search_init");
        allBuiltinFunctions.add("mb_ereg_search_pos");
        allBuiltinFunctions.add("mb_ereg_search_regs");
        allBuiltinFunctions.add("mb_ereg_search_setpos");
        allBuiltinFunctions.add("mb_eregi");
        allBuiltinFunctions.add("mb_eregi_replace");
        allBuiltinFunctions.add("mb_get_info");
        allBuiltinFunctions.add("mb_http_input");
        allBuiltinFunctions.add("mb_http_output");
        allBuiltinFunctions.add("mb_internal_encoding");
        allBuiltinFunctions.add("mb_language");
        allBuiltinFunctions.add("mb_list_encodings");
        allBuiltinFunctions.add("mb_output_handler");
        allBuiltinFunctions.add("mb_parse_str");
        allBuiltinFunctions.add("mb_preferred_mime_name");
        allBuiltinFunctions.add("mb_regex_encoding");
        allBuiltinFunctions.add("mb_regex_set_options");
        allBuiltinFunctions.add("mb_send_mail");
        allBuiltinFunctions.add("mb_split");
        allBuiltinFunctions.add("mb_strcut");
        allBuiltinFunctions.add("mb_strimwidth");
        allBuiltinFunctions.add("mb_strlen");
        allBuiltinFunctions.add("mb_strpos");
        allBuiltinFunctions.add("mb_strrpos");
        allBuiltinFunctions.add("mb_strtolower");
        allBuiltinFunctions.add("mb_strtoupper");
        allBuiltinFunctions.add("mb_strwidth");
        allBuiltinFunctions.add("mb_substitute_character");
        allBuiltinFunctions.add("mb_substr");
        allBuiltinFunctions.add("mb_substr_count");
        allBuiltinFunctions.add("mcal_append_event");
        allBuiltinFunctions.add("mcal_close");
        allBuiltinFunctions.add("mcal_create_calendar");
        allBuiltinFunctions.add("mcal_date_compare");
        allBuiltinFunctions.add("mcal_date_valid");
        allBuiltinFunctions.add("mcal_day_of_week");
        allBuiltinFunctions.add("mcal_day_of_year");
        allBuiltinFunctions.add("mcal_days_in_month");
        allBuiltinFunctions.add("mcal_delete_calendar");
        allBuiltinFunctions.add("mcal_delete_event");
        allBuiltinFunctions.add("mcal_event_add_attribute");
        allBuiltinFunctions.add("mcal_event_init");
        allBuiltinFunctions.add("mcal_event_set_alarm");
        allBuiltinFunctions.add("mcal_event_set_category");
        allBuiltinFunctions.add("mcal_event_set_class");
        allBuiltinFunctions.add("mcal_event_set_description");
        allBuiltinFunctions.add("mcal_event_set_end");
        allBuiltinFunctions.add("mcal_event_set_recur_daily");
        allBuiltinFunctions.add("mcal_event_set_recur_monthly_mday");
        allBuiltinFunctions.add("mcal_event_set_recur_monthly_wday");
        allBuiltinFunctions.add("mcal_event_set_recur_none");
        allBuiltinFunctions.add("mcal_event_set_recur_weekly");
        allBuiltinFunctions.add("mcal_event_set_recur_yearly");
        allBuiltinFunctions.add("mcal_event_set_start");
        allBuiltinFunctions.add("mcal_event_set_title");
        allBuiltinFunctions.add("mcal_expunge");
        allBuiltinFunctions.add("mcal_fetch_current_stream_event");
        allBuiltinFunctions.add("mcal_fetch_event");
        allBuiltinFunctions.add("mcal_is_leap_year");
        allBuiltinFunctions.add("mcal_list_alarms");
        allBuiltinFunctions.add("mcal_list_events");
        allBuiltinFunctions.add("mcal_next_recurrence");
        allBuiltinFunctions.add("mcal_open");
        allBuiltinFunctions.add("mcal_popen");
        allBuiltinFunctions.add("mcal_rename_calendar");
        allBuiltinFunctions.add("mcal_reopen");
        allBuiltinFunctions.add("mcal_snooze");
        allBuiltinFunctions.add("mcal_store_event");
        allBuiltinFunctions.add("mcal_time_valid");
        allBuiltinFunctions.add("mcal_week_of_year");
        allBuiltinFunctions.add("mcrypt_cbc");
        allBuiltinFunctions.add("mcrypt_cfb");
        allBuiltinFunctions.add("mcrypt_create_iv");
        allBuiltinFunctions.add("mcrypt_decrypt");
        allBuiltinFunctions.add("mcrypt_ecb");
        allBuiltinFunctions.add("mcrypt_enc_get_algorithms_name");
        allBuiltinFunctions.add("mcrypt_enc_get_block_size");
        allBuiltinFunctions.add("mcrypt_enc_get_iv_size");
        allBuiltinFunctions.add("mcrypt_enc_get_key_size");
        allBuiltinFunctions.add("mcrypt_enc_get_modes_name");
        allBuiltinFunctions.add("mcrypt_enc_get_supported_key_sizes");
        allBuiltinFunctions.add("mcrypt_enc_is_block_algorithm");
        allBuiltinFunctions.add("mcrypt_enc_is_block_algorithm_mode");
        allBuiltinFunctions.add("mcrypt_enc_is_block_mode");
        allBuiltinFunctions.add("mcrypt_enc_self_test");
        allBuiltinFunctions.add("mcrypt_encrypt");
        allBuiltinFunctions.add("mcrypt_generic");
        allBuiltinFunctions.add("mcrypt_generic_deinit");
        allBuiltinFunctions.add("mcrypt_generic_end");
        allBuiltinFunctions.add("mcrypt_generic_init");
        allBuiltinFunctions.add("mcrypt_get_block_size");
        allBuiltinFunctions.add("mcrypt_get_cipher_name");
        allBuiltinFunctions.add("mcrypt_get_iv_size");
        allBuiltinFunctions.add("mcrypt_get_key_size");
        allBuiltinFunctions.add("mcrypt_list_algorithms");
        allBuiltinFunctions.add("mcrypt_list_modes");
        allBuiltinFunctions.add("mcrypt_module_close");
        allBuiltinFunctions.add("mcrypt_module_get_algo_block_size");
        allBuiltinFunctions.add("mcrypt_module_get_algo_key_size");
        allBuiltinFunctions.add("mcrypt_module_get_supported_key_sizes");
        allBuiltinFunctions.add("mcrypt_module_is_block_algorithm");
        allBuiltinFunctions.add("mcrypt_module_is_block_algorithm_mode");
        allBuiltinFunctions.add("mcrypt_module_is_block_mode");
        allBuiltinFunctions.add("mcrypt_module_open");
        allBuiltinFunctions.add("mcrypt_module_self_test");
        allBuiltinFunctions.add("mcrypt_ofb");
        allBuiltinFunctions.add("mcve_adduser");
        allBuiltinFunctions.add("mcve_adduserarg");
        allBuiltinFunctions.add("mcve_bt");
        allBuiltinFunctions.add("mcve_checkstatus");
        allBuiltinFunctions.add("mcve_chkpwd");
        allBuiltinFunctions.add("mcve_chngpwd");
        allBuiltinFunctions.add("mcve_completeauthorizations");
        allBuiltinFunctions.add("mcve_connect");
        allBuiltinFunctions.add("mcve_connectionerror");
        allBuiltinFunctions.add("mcve_deleteresponse");
        allBuiltinFunctions.add("mcve_deletetrans");
        allBuiltinFunctions.add("mcve_deleteusersetup");
        allBuiltinFunctions.add("mcve_deluser");
        allBuiltinFunctions.add("mcve_destroyconn");
        allBuiltinFunctions.add("mcve_destroyengine");
        allBuiltinFunctions.add("mcve_disableuser");
        allBuiltinFunctions.add("mcve_edituser");
        allBuiltinFunctions.add("mcve_enableuser");
        allBuiltinFunctions.add("mcve_force");
        allBuiltinFunctions.add("mcve_getcell");
        allBuiltinFunctions.add("mcve_getcellbynum");
        allBuiltinFunctions.add("mcve_getcommadelimited");
        allBuiltinFunctions.add("mcve_getheader");
        allBuiltinFunctions.add("mcve_getuserarg");
        allBuiltinFunctions.add("mcve_getuserparam");
        allBuiltinFunctions.add("mcve_gft");
        allBuiltinFunctions.add("mcve_gl");
        allBuiltinFunctions.add("mcve_gut");
        allBuiltinFunctions.add("mcve_initconn");
        allBuiltinFunctions.add("mcve_initengine");
        allBuiltinFunctions.add("mcve_initusersetup");
        allBuiltinFunctions.add("mcve_iscommadelimited");
        allBuiltinFunctions.add("mcve_liststats");
        allBuiltinFunctions.add("mcve_listusers");
        allBuiltinFunctions.add("mcve_maxconntimeout");
        allBuiltinFunctions.add("mcve_monitor");
        allBuiltinFunctions.add("mcve_numcolumns");
        allBuiltinFunctions.add("mcve_numrows");
        allBuiltinFunctions.add("mcve_override");
        allBuiltinFunctions.add("mcve_parsecommadelimited");
        allBuiltinFunctions.add("mcve_ping");
        allBuiltinFunctions.add("mcve_preauth");
        allBuiltinFunctions.add("mcve_preauthcompletion");
        allBuiltinFunctions.add("mcve_qc");
        allBuiltinFunctions.add("mcve_responseparam");
        allBuiltinFunctions.add("mcve_return");
        allBuiltinFunctions.add("mcve_returncode");
        allBuiltinFunctions.add("mcve_returnstatus");
        allBuiltinFunctions.add("mcve_sale");
        allBuiltinFunctions.add("mcve_setblocking");
        allBuiltinFunctions.add("mcve_setdropfile");
        allBuiltinFunctions.add("mcve_setip");
        allBuiltinFunctions.add("mcve_setssl");
        allBuiltinFunctions.add("mcve_setssl_files");
        allBuiltinFunctions.add("mcve_settimeout");
        allBuiltinFunctions.add("mcve_settle");
        allBuiltinFunctions.add("mcve_text_avs");
        allBuiltinFunctions.add("mcve_text_code");
        allBuiltinFunctions.add("mcve_text_cv");
        allBuiltinFunctions.add("mcve_transactionauth");
        allBuiltinFunctions.add("mcve_transactionavs");
        allBuiltinFunctions.add("mcve_transactionbatch");
        allBuiltinFunctions.add("mcve_transactioncv");
        allBuiltinFunctions.add("mcve_transactionid");
        allBuiltinFunctions.add("mcve_transactionitem");
        allBuiltinFunctions.add("mcve_transactionssent");
        allBuiltinFunctions.add("mcve_transactiontext");
        allBuiltinFunctions.add("mcve_transinqueue");
        allBuiltinFunctions.add("mcve_transnew");
        allBuiltinFunctions.add("mcve_transparam");
        allBuiltinFunctions.add("mcve_transsend");
        allBuiltinFunctions.add("mcve_ub");
        allBuiltinFunctions.add("mcve_uwait");
        allBuiltinFunctions.add("mcve_verifyconnection");
        allBuiltinFunctions.add("mcve_verifysslcert");
        allBuiltinFunctions.add("mcve_void");
        allBuiltinFunctions.add("md5");
        allBuiltinFunctions.add("md5_file");
        allBuiltinFunctions.add("mdecrypt_generic");
        allBuiltinFunctions.add("Memcache::add");
        allBuiltinFunctions.add("Memcache::close");
        allBuiltinFunctions.add("Memcache::connect");
        allBuiltinFunctions.add("Memcache::decrement");
        allBuiltinFunctions.add("Memcache::delete");
        allBuiltinFunctions.add("Memcache::flush");
        allBuiltinFunctions.add("Memcache::get");
        allBuiltinFunctions.add("Memcache::getStats");
        allBuiltinFunctions.add("Memcache::getVersion");
        allBuiltinFunctions.add("Memcache::increment");
        allBuiltinFunctions.add("Memcache::pconnect");
        allBuiltinFunctions.add("Memcache::replace");
        allBuiltinFunctions.add("Memcache::set");
        allBuiltinFunctions.add("memcache_debug");
        allBuiltinFunctions.add("memory_get_usage");
        allBuiltinFunctions.add("metaphone");
        allBuiltinFunctions.add("method_exists");
        allBuiltinFunctions.add("mhash");
        allBuiltinFunctions.add("mhash_count");
        allBuiltinFunctions.add("mhash_get_block_size");
        allBuiltinFunctions.add("mhash_get_hash_name");
        allBuiltinFunctions.add("mhash_keygen_s2k");
        allBuiltinFunctions.add("microtime");
        allBuiltinFunctions.add("mime_content_type");
        allBuiltinFunctions.add("min");
        allBuiltinFunctions.add("ming_setcubicthreshold");
        allBuiltinFunctions.add("ming_setscale");
        allBuiltinFunctions.add("ming_useswfversion");
        allBuiltinFunctions.add("mkdir");
        allBuiltinFunctions.add("mktime");
        allBuiltinFunctions.add("money_format");
        allBuiltinFunctions.add("move_uploaded_file");
        allBuiltinFunctions.add("msession_connect");
        allBuiltinFunctions.add("msession_count");
        allBuiltinFunctions.add("msession_create");
        allBuiltinFunctions.add("msession_destroy");
        allBuiltinFunctions.add("msession_disconnect");
        allBuiltinFunctions.add("msession_find");
        allBuiltinFunctions.add("msession_get");
        allBuiltinFunctions.add("msession_get_array");
        allBuiltinFunctions.add("msession_get_data");
        allBuiltinFunctions.add("msession_inc");
        allBuiltinFunctions.add("msession_list");
        allBuiltinFunctions.add("msession_listvar");
        allBuiltinFunctions.add("msession_lock");
        allBuiltinFunctions.add("msession_plugin");
        allBuiltinFunctions.add("msession_randstr");
        allBuiltinFunctions.add("msession_set");
        allBuiltinFunctions.add("msession_set_array");
        allBuiltinFunctions.add("msession_set_data");
        allBuiltinFunctions.add("msession_timeout");
        allBuiltinFunctions.add("msession_uniq");
        allBuiltinFunctions.add("msession_unlock");
        allBuiltinFunctions.add("msg_get_queue");
        allBuiltinFunctions.add("msg_receive");
        allBuiltinFunctions.add("msg_remove_queue");
        allBuiltinFunctions.add("msg_send");
        allBuiltinFunctions.add("msg_set_queue");
        allBuiltinFunctions.add("msg_stat_queue");
        allBuiltinFunctions.add("msql");
        allBuiltinFunctions.add("msql_affected_rows");
        allBuiltinFunctions.add("msql_close");
        allBuiltinFunctions.add("msql_connect");
        allBuiltinFunctions.add("msql_create_db");
        allBuiltinFunctions.add("msql_createdb");
        allBuiltinFunctions.add("msql_data_seek");
        allBuiltinFunctions.add("msql_db_query");
        allBuiltinFunctions.add("msql_dbname");
        allBuiltinFunctions.add("msql_drop_db");
        allBuiltinFunctions.add("msql_error");
        allBuiltinFunctions.add("msql_fetch_array");
        allBuiltinFunctions.add("msql_fetch_field");
        allBuiltinFunctions.add("msql_fetch_object");
        allBuiltinFunctions.add("msql_fetch_row");
        allBuiltinFunctions.add("msql_field_flags");
        allBuiltinFunctions.add("msql_field_len");
        allBuiltinFunctions.add("msql_field_name");
        allBuiltinFunctions.add("msql_field_seek");
        allBuiltinFunctions.add("msql_field_table");
        allBuiltinFunctions.add("msql_field_type");
        allBuiltinFunctions.add("msql_fieldflags");
        allBuiltinFunctions.add("msql_fieldlen");
        allBuiltinFunctions.add("msql_fieldname");
        allBuiltinFunctions.add("msql_fieldtable");
        allBuiltinFunctions.add("msql_fieldtype");
        allBuiltinFunctions.add("msql_free_result");
        allBuiltinFunctions.add("msql_list_dbs");
        allBuiltinFunctions.add("msql_list_fields");
        allBuiltinFunctions.add("msql_list_tables");
        allBuiltinFunctions.add("msql_num_fields");
        allBuiltinFunctions.add("msql_num_rows");
        allBuiltinFunctions.add("msql_numfields");
        allBuiltinFunctions.add("msql_numrows");
        allBuiltinFunctions.add("msql_pconnect");
        allBuiltinFunctions.add("msql_query");
        allBuiltinFunctions.add("msql_regcase");
        allBuiltinFunctions.add("msql_result");
        allBuiltinFunctions.add("msql_select_db");
        allBuiltinFunctions.add("msql_tablename");
        allBuiltinFunctions.add("mssql_bind");
        allBuiltinFunctions.add("mssql_close");
        allBuiltinFunctions.add("mssql_connect");
        allBuiltinFunctions.add("mssql_data_seek");
        allBuiltinFunctions.add("mssql_execute");
        allBuiltinFunctions.add("mssql_fetch_array");
        allBuiltinFunctions.add("mssql_fetch_assoc");
        allBuiltinFunctions.add("mssql_fetch_batch");
        allBuiltinFunctions.add("mssql_fetch_field");
        allBuiltinFunctions.add("mssql_fetch_object");
        allBuiltinFunctions.add("mssql_fetch_row");
        allBuiltinFunctions.add("mssql_field_length");
        allBuiltinFunctions.add("mssql_field_name");
        allBuiltinFunctions.add("mssql_field_seek");
        allBuiltinFunctions.add("mssql_field_type");
        allBuiltinFunctions.add("mssql_free_result");
        allBuiltinFunctions.add("mssql_free_statement");
        allBuiltinFunctions.add("mssql_get_last_message");
        allBuiltinFunctions.add("mssql_guid_string");
        allBuiltinFunctions.add("mssql_init");
        allBuiltinFunctions.add("mssql_min_error_severity");
        allBuiltinFunctions.add("mssql_min_message_severity");
        allBuiltinFunctions.add("mssql_next_result");
        allBuiltinFunctions.add("mssql_num_fields");
        allBuiltinFunctions.add("mssql_num_rows");
        allBuiltinFunctions.add("mssql_pconnect");
        allBuiltinFunctions.add("mssql_query");
        allBuiltinFunctions.add("mssql_result");
        allBuiltinFunctions.add("mssql_rows_affected");
        allBuiltinFunctions.add("mssql_select_db");
        allBuiltinFunctions.add("mt_getrandmax");
        allBuiltinFunctions.add("mt_rand");
        allBuiltinFunctions.add("mt_srand");
        allBuiltinFunctions.add("muscat_close");
        allBuiltinFunctions.add("muscat_get");
        allBuiltinFunctions.add("muscat_give");
        allBuiltinFunctions.add("muscat_setup");
        allBuiltinFunctions.add("muscat_setup_net");
        allBuiltinFunctions.add("mysql_affected_rows");
        allBuiltinFunctions.add("mysql_change_user");
        allBuiltinFunctions.add("mysql_client_encoding");
        allBuiltinFunctions.add("mysql_close");
        allBuiltinFunctions.add("mysql_connect");
        allBuiltinFunctions.add("mysql_create_db");
        allBuiltinFunctions.add("mysql_data_seek");
        allBuiltinFunctions.add("mysql_db_name");
        allBuiltinFunctions.add("mysql_db_query");
        allBuiltinFunctions.add("mysql_drop_db");
        allBuiltinFunctions.add("mysql_errno");
        allBuiltinFunctions.add("mysql_error");
        allBuiltinFunctions.add("mysql_escape_string");
        allBuiltinFunctions.add("mysql_fetch_array");
        allBuiltinFunctions.add("mysql_fetch_assoc");
        allBuiltinFunctions.add("mysql_fetch_field");
        allBuiltinFunctions.add("mysql_fetch_lengths");
        allBuiltinFunctions.add("mysql_fetch_object");
        allBuiltinFunctions.add("mysql_fetch_row");
        allBuiltinFunctions.add("mysql_field_flags");
        allBuiltinFunctions.add("mysql_field_len");
        allBuiltinFunctions.add("mysql_field_name");
        allBuiltinFunctions.add("mysql_field_seek");
        allBuiltinFunctions.add("mysql_field_table");
        allBuiltinFunctions.add("mysql_field_type");
        allBuiltinFunctions.add("mysql_free_result");
        allBuiltinFunctions.add("mysql_get_client_info");
        allBuiltinFunctions.add("mysql_get_host_info");
        allBuiltinFunctions.add("mysql_get_proto_info");
        allBuiltinFunctions.add("mysql_get_server_info");
        allBuiltinFunctions.add("mysql_info");
        allBuiltinFunctions.add("mysql_insert_id");
        allBuiltinFunctions.add("mysql_list_dbs");
        allBuiltinFunctions.add("mysql_list_fields");
        allBuiltinFunctions.add("mysql_list_processes");
        allBuiltinFunctions.add("mysql_list_tables");
        allBuiltinFunctions.add("mysql_num_fields");
        allBuiltinFunctions.add("mysql_num_rows");
        allBuiltinFunctions.add("mysql_pconnect");
        allBuiltinFunctions.add("mysql_ping");
        allBuiltinFunctions.add("mysql_query");
        allBuiltinFunctions.add("mysql_real_escape_string");
        allBuiltinFunctions.add("mysql_result");
        allBuiltinFunctions.add("mysql_select_db");
        allBuiltinFunctions.add("mysql_stat");
        allBuiltinFunctions.add("mysql_tablename");
        allBuiltinFunctions.add("mysql_thread_id");
        allBuiltinFunctions.add("mysql_unbuffered_query");
        allBuiltinFunctions.add("mysqli()");
        allBuiltinFunctions.add("mysqli->affected_rows");
        allBuiltinFunctions.add("mysqli->autocommit");
        allBuiltinFunctions.add("mysqli->change_user");
        allBuiltinFunctions.add("mysqli->character_set_name");
        allBuiltinFunctions.add("mysqli->close");
        allBuiltinFunctions.add("mysqli->commit");
        allBuiltinFunctions.add("mysqli->disable_reads_from_master");
        allBuiltinFunctions.add("mysqli->dump_debug_info");
        allBuiltinFunctions.add("mysqli->errno");
        allBuiltinFunctions.add("mysqli->fetch_assoc");
        allBuiltinFunctions.add("mysqli->field_count");
        allBuiltinFunctions.add("mysqli->get_host_info");
        allBuiltinFunctions.add("mysqli->info");
        allBuiltinFunctions.add("mysqli->insert_id");
        allBuiltinFunctions.add("mysqli->kill");
        allBuiltinFunctions.add("mysqli->more_results");
        allBuiltinFunctions.add("mysqli->multi_query");
        allBuiltinFunctions.add("mysqli->next_result");
        allBuiltinFunctions.add("mysqli->options");
        allBuiltinFunctions.add("mysqli->ping");
        allBuiltinFunctions.add("mysqli->prepare");
        allBuiltinFunctions.add("mysqli->protocol_version");
        allBuiltinFunctions.add("mysqli->query");
        allBuiltinFunctions.add("mysqli->real_connect");
        allBuiltinFunctions.add("mysqli->real_escape_string");
        allBuiltinFunctions.add("mysqli->real_query");
        allBuiltinFunctions.add("mysqli->rollback");
        allBuiltinFunctions.add("mysqli->rpl_query_type");
        allBuiltinFunctions.add("mysqli->select_db");
        allBuiltinFunctions.add("mysqli->send_query");
        allBuiltinFunctions.add("mysqli->server_info");
        allBuiltinFunctions.add("mysqli->sqlstate");
        allBuiltinFunctions.add("mysqli->ssl_set");
        allBuiltinFunctions.add("mysqli->stat");
        allBuiltinFunctions.add("mysqli->stmt_init");
        allBuiltinFunctions.add("mysqli->store_result");
        allBuiltinFunctions.add("mysqli->thread_id");
        allBuiltinFunctions.add("mysqli->use_result");
        allBuiltinFunctions.add("mysqli->warning_count");
        allBuiltinFunctions.add("mysqli_affected_rows");
        allBuiltinFunctions.add("mysqli_autocommit");
        allBuiltinFunctions.add("mysqli_bind_param");
        allBuiltinFunctions.add("mysqli_bind_result");
        allBuiltinFunctions.add("mysqli_change_user");
        allBuiltinFunctions.add("mysqli_character_set_name");
        allBuiltinFunctions.add("mysqli_client_encoding");
        allBuiltinFunctions.add("mysqli_close");
        allBuiltinFunctions.add("mysqli_commit");
        allBuiltinFunctions.add("mysqli_connect");
        allBuiltinFunctions.add("mysqli_connect_errno");
        allBuiltinFunctions.add("mysqli_connect_error");
        allBuiltinFunctions.add("mysqli_data_seek");
        allBuiltinFunctions.add("mysqli_debug");
        allBuiltinFunctions.add("mysqli_disable_reads_from_master");
        allBuiltinFunctions.add("mysqli_disable_rpl_parse");
        allBuiltinFunctions.add("mysqli_dump_debug_info");
        allBuiltinFunctions.add("mysqli_embedded_connect");
        allBuiltinFunctions.add("mysqli_enable_reads_from_master");
        allBuiltinFunctions.add("mysqli_enable_rpl_parse");
        allBuiltinFunctions.add("mysqli_errno");
        allBuiltinFunctions.add("mysqli_error");
        allBuiltinFunctions.add("mysqli_escape_string");
        allBuiltinFunctions.add("mysqli_execute");
        allBuiltinFunctions.add("mysqli_fetch");
        allBuiltinFunctions.add("mysqli_fetch_array");
        allBuiltinFunctions.add("mysqli_fetch_assoc");
        allBuiltinFunctions.add("mysqli_fetch_field");
        allBuiltinFunctions.add("mysqli_fetch_field_direct");
        allBuiltinFunctions.add("mysqli_fetch_fields");
        allBuiltinFunctions.add("mysqli_fetch_lengths");
        allBuiltinFunctions.add("mysqli_fetch_object");
        allBuiltinFunctions.add("mysqli_fetch_row");
        allBuiltinFunctions.add("mysqli_field_count");
        allBuiltinFunctions.add("mysqli_field_seek");
        allBuiltinFunctions.add("mysqli_field_tell");
        allBuiltinFunctions.add("mysqli_free_result");
        allBuiltinFunctions.add("mysqli_get_client_info");
        allBuiltinFunctions.add("mysqli_get_client_version");
        allBuiltinFunctions.add("mysqli_get_host_info");
        allBuiltinFunctions.add("mysqli_get_metadata");
        allBuiltinFunctions.add("mysqli_get_proto_info");
        allBuiltinFunctions.add("mysqli_get_server_info");
        allBuiltinFunctions.add("mysqli_get_server_version");
        allBuiltinFunctions.add("mysqli_info");
        allBuiltinFunctions.add("mysqli_init");
        allBuiltinFunctions.add("mysqli_insert_id");
        allBuiltinFunctions.add("mysqli_kill");
        allBuiltinFunctions.add("mysqli_master_query");
        allBuiltinFunctions.add("mysqli_more_results");
        allBuiltinFunctions.add("mysqli_multi_query");
        allBuiltinFunctions.add("mysqli_next_result");
        allBuiltinFunctions.add("mysqli_num_fields");
        allBuiltinFunctions.add("mysqli_num_rows");
        allBuiltinFunctions.add("mysqli_options");
        allBuiltinFunctions.add("mysqli_param_count");
        allBuiltinFunctions.add("mysqli_ping");
        allBuiltinFunctions.add("mysqli_prepare");
        allBuiltinFunctions.add("mysqli_query");
        allBuiltinFunctions.add("mysqli_real_connect");
        allBuiltinFunctions.add("mysqli_real_escape_string");
        allBuiltinFunctions.add("mysqli_real_query");
        allBuiltinFunctions.add("mysqli_report");
        allBuiltinFunctions.add("mysqli_rollback");
        allBuiltinFunctions.add("mysqli_rpl_parse_enabled");
        allBuiltinFunctions.add("mysqli_rpl_probe");
        allBuiltinFunctions.add("mysqli_rpl_query_type");
        allBuiltinFunctions.add("mysqli_select_db");
        allBuiltinFunctions.add("mysqli_send_long_data");
        allBuiltinFunctions.add("mysqli_send_query");
        allBuiltinFunctions.add("mysqli_server_end");
        allBuiltinFunctions.add("mysqli_server_init");
        allBuiltinFunctions.add("mysqli_set_opt");
        allBuiltinFunctions.add("mysqli_sqlstate");
        allBuiltinFunctions.add("mysqli_ssl_set");
        allBuiltinFunctions.add("mysqli_stat");
        allBuiltinFunctions.add("mysqli_stmt->affected_rows");
        allBuiltinFunctions.add("mysqli_stmt->close");
        allBuiltinFunctions.add("mysqli_stmt->errno");
        allBuiltinFunctions.add("mysqli_stmt->error");
        allBuiltinFunctions.add("mysqli_stmt->store_result");
        allBuiltinFunctions.add("mysqli_stmt_affected_rows");
        allBuiltinFunctions.add("mysqli_stmt_bind_param");
        allBuiltinFunctions.add("mysqli_stmt_bind_result");
        allBuiltinFunctions.add("mysqli_stmt_close");
        allBuiltinFunctions.add("mysqli_stmt_data_seek");
        allBuiltinFunctions.add("mysqli_stmt_errno");
        allBuiltinFunctions.add("mysqli_stmt_error");
        allBuiltinFunctions.add("mysqli_stmt_execute");
        allBuiltinFunctions.add("mysqli_stmt_fetch");
        allBuiltinFunctions.add("mysqli_stmt_free_result");
        allBuiltinFunctions.add("mysqli_stmt_init");
        allBuiltinFunctions.add("mysqli_stmt_num_rows");
        allBuiltinFunctions.add("mysqli_stmt_param_count");
        allBuiltinFunctions.add("mysqli_stmt_prepare");
        allBuiltinFunctions.add("mysqli_stmt_reset");
        allBuiltinFunctions.add("mysqli_stmt_result_metadata");
        allBuiltinFunctions.add("mysqli_stmt_send_long_data");
        allBuiltinFunctions.add("mysqli_stmt_sqlstate");
        allBuiltinFunctions.add("mysqli_stmt_store_result");
        allBuiltinFunctions.add("mysqli_store_result");
        allBuiltinFunctions.add("mysqli_thread_id");
        allBuiltinFunctions.add("mysqli_thread_safe");
        allBuiltinFunctions.add("mysqli_use_result");
        allBuiltinFunctions.add("mysqli_warning_count");
        allBuiltinFunctions.add("natcasesort");
        allBuiltinFunctions.add("natsort");
        allBuiltinFunctions.add("ncurses_addch");
        allBuiltinFunctions.add("ncurses_addchnstr");
        allBuiltinFunctions.add("ncurses_addchstr");
        allBuiltinFunctions.add("ncurses_addnstr");
        allBuiltinFunctions.add("ncurses_addstr");
        allBuiltinFunctions.add("ncurses_assume_default_colors");
        allBuiltinFunctions.add("ncurses_attroff");
        allBuiltinFunctions.add("ncurses_attron");
        allBuiltinFunctions.add("ncurses_attrset");
        allBuiltinFunctions.add("ncurses_baudrate");
        allBuiltinFunctions.add("ncurses_beep");
        allBuiltinFunctions.add("ncurses_bkgd");
        allBuiltinFunctions.add("ncurses_bkgdset");
        allBuiltinFunctions.add("ncurses_border");
        allBuiltinFunctions.add("ncurses_bottom_panel");
        allBuiltinFunctions.add("ncurses_can_change_color");
        allBuiltinFunctions.add("ncurses_cbreak");
        allBuiltinFunctions.add("ncurses_clear");
        allBuiltinFunctions.add("ncurses_clrtobot");
        allBuiltinFunctions.add("ncurses_clrtoeol");
        allBuiltinFunctions.add("ncurses_color_content");
        allBuiltinFunctions.add("ncurses_color_set");
        allBuiltinFunctions.add("ncurses_curs_set");
        allBuiltinFunctions.add("ncurses_def_prog_mode");
        allBuiltinFunctions.add("ncurses_def_shell_mode");
        allBuiltinFunctions.add("ncurses_define_key");
        allBuiltinFunctions.add("ncurses_del_panel");
        allBuiltinFunctions.add("ncurses_delay_output");
        allBuiltinFunctions.add("ncurses_delch");
        allBuiltinFunctions.add("ncurses_deleteln");
        allBuiltinFunctions.add("ncurses_delwin");
        allBuiltinFunctions.add("ncurses_doupdate");
        allBuiltinFunctions.add("ncurses_echo");
        allBuiltinFunctions.add("ncurses_echochar");
        allBuiltinFunctions.add("ncurses_end");
        allBuiltinFunctions.add("ncurses_erase");
        allBuiltinFunctions.add("ncurses_erasechar");
        allBuiltinFunctions.add("ncurses_filter");
        allBuiltinFunctions.add("ncurses_flash");
        allBuiltinFunctions.add("ncurses_flushinp");
        allBuiltinFunctions.add("ncurses_getch");
        allBuiltinFunctions.add("ncurses_getmaxyx");
        allBuiltinFunctions.add("ncurses_getmouse");
        allBuiltinFunctions.add("ncurses_getyx");
        allBuiltinFunctions.add("ncurses_halfdelay");
        allBuiltinFunctions.add("ncurses_has_colors");
        allBuiltinFunctions.add("ncurses_has_ic");
        allBuiltinFunctions.add("ncurses_has_il");
        allBuiltinFunctions.add("ncurses_has_key");
        allBuiltinFunctions.add("ncurses_hide_panel");
        allBuiltinFunctions.add("ncurses_hline");
        allBuiltinFunctions.add("ncurses_inch");
        allBuiltinFunctions.add("ncurses_init");
        allBuiltinFunctions.add("ncurses_init_color");
        allBuiltinFunctions.add("ncurses_init_pair");
        allBuiltinFunctions.add("ncurses_insch");
        allBuiltinFunctions.add("ncurses_insdelln");
        allBuiltinFunctions.add("ncurses_insertln");
        allBuiltinFunctions.add("ncurses_insstr");
        allBuiltinFunctions.add("ncurses_instr");
        allBuiltinFunctions.add("ncurses_isendwin");
        allBuiltinFunctions.add("ncurses_keyok");
        allBuiltinFunctions.add("ncurses_keypad");
        allBuiltinFunctions.add("ncurses_killchar");
        allBuiltinFunctions.add("ncurses_longname");
        allBuiltinFunctions.add("ncurses_meta");
        allBuiltinFunctions.add("ncurses_mouse_trafo");
        allBuiltinFunctions.add("ncurses_mouseinterval");
        allBuiltinFunctions.add("ncurses_mousemask");
        allBuiltinFunctions.add("ncurses_move");
        allBuiltinFunctions.add("ncurses_move_panel");
        allBuiltinFunctions.add("ncurses_mvaddch");
        allBuiltinFunctions.add("ncurses_mvaddchnstr");
        allBuiltinFunctions.add("ncurses_mvaddchstr");
        allBuiltinFunctions.add("ncurses_mvaddnstr");
        allBuiltinFunctions.add("ncurses_mvaddstr");
        allBuiltinFunctions.add("ncurses_mvcur");
        allBuiltinFunctions.add("ncurses_mvdelch");
        allBuiltinFunctions.add("ncurses_mvgetch");
        allBuiltinFunctions.add("ncurses_mvhline");
        allBuiltinFunctions.add("ncurses_mvinch");
        allBuiltinFunctions.add("ncurses_mvvline");
        allBuiltinFunctions.add("ncurses_mvwaddstr");
        allBuiltinFunctions.add("ncurses_napms");
        allBuiltinFunctions.add("ncurses_new_panel");
        allBuiltinFunctions.add("ncurses_newpad");
        allBuiltinFunctions.add("ncurses_newwin");
        allBuiltinFunctions.add("ncurses_nl");
        allBuiltinFunctions.add("ncurses_nocbreak");
        allBuiltinFunctions.add("ncurses_noecho");
        allBuiltinFunctions.add("ncurses_nonl");
        allBuiltinFunctions.add("ncurses_noqiflush");
        allBuiltinFunctions.add("ncurses_noraw");
        allBuiltinFunctions.add("ncurses_pair_content");
        allBuiltinFunctions.add("ncurses_panel_above");
        allBuiltinFunctions.add("ncurses_panel_below");
        allBuiltinFunctions.add("ncurses_panel_window");
        allBuiltinFunctions.add("ncurses_pnoutrefresh");
        allBuiltinFunctions.add("ncurses_prefresh");
        allBuiltinFunctions.add("ncurses_putp");
        allBuiltinFunctions.add("ncurses_qiflush");
        allBuiltinFunctions.add("ncurses_raw");
        allBuiltinFunctions.add("ncurses_refresh");
        allBuiltinFunctions.add("ncurses_replace_panel");
        allBuiltinFunctions.add("ncurses_reset_prog_mode");
        allBuiltinFunctions.add("ncurses_reset_shell_mode");
        allBuiltinFunctions.add("ncurses_resetty");
        allBuiltinFunctions.add("ncurses_savetty");
        allBuiltinFunctions.add("ncurses_scr_dump");
        allBuiltinFunctions.add("ncurses_scr_init");
        allBuiltinFunctions.add("ncurses_scr_restore");
        allBuiltinFunctions.add("ncurses_scr_set");
        allBuiltinFunctions.add("ncurses_scrl");
        allBuiltinFunctions.add("ncurses_show_panel");
        allBuiltinFunctions.add("ncurses_slk_attr");
        allBuiltinFunctions.add("ncurses_slk_attroff");
        allBuiltinFunctions.add("ncurses_slk_attron");
        allBuiltinFunctions.add("ncurses_slk_attrset");
        allBuiltinFunctions.add("ncurses_slk_clear");
        allBuiltinFunctions.add("ncurses_slk_color");
        allBuiltinFunctions.add("ncurses_slk_init");
        allBuiltinFunctions.add("ncurses_slk_noutrefresh");
        allBuiltinFunctions.add("ncurses_slk_refresh");
        allBuiltinFunctions.add("ncurses_slk_restore");
        allBuiltinFunctions.add("ncurses_slk_set");
        allBuiltinFunctions.add("ncurses_slk_touch");
        allBuiltinFunctions.add("ncurses_standend");
        allBuiltinFunctions.add("ncurses_standout");
        allBuiltinFunctions.add("ncurses_start_color");
        allBuiltinFunctions.add("ncurses_termattrs");
        allBuiltinFunctions.add("ncurses_termname");
        allBuiltinFunctions.add("ncurses_timeout");
        allBuiltinFunctions.add("ncurses_top_panel");
        allBuiltinFunctions.add("ncurses_typeahead");
        allBuiltinFunctions.add("ncurses_ungetch");
        allBuiltinFunctions.add("ncurses_ungetmouse");
        allBuiltinFunctions.add("ncurses_update_panels");
        allBuiltinFunctions.add("ncurses_use_default_colors");
        allBuiltinFunctions.add("ncurses_use_env");
        allBuiltinFunctions.add("ncurses_use_extended_names");
        allBuiltinFunctions.add("ncurses_vidattr");
        allBuiltinFunctions.add("ncurses_vline");
        allBuiltinFunctions.add("ncurses_waddch");
        allBuiltinFunctions.add("ncurses_waddstr");
        allBuiltinFunctions.add("ncurses_wattroff");
        allBuiltinFunctions.add("ncurses_wattron");
        allBuiltinFunctions.add("ncurses_wattrset");
        allBuiltinFunctions.add("ncurses_wborder");
        allBuiltinFunctions.add("ncurses_wclear");
        allBuiltinFunctions.add("ncurses_wcolor_set");
        allBuiltinFunctions.add("ncurses_werase");
        allBuiltinFunctions.add("ncurses_wgetch");
        allBuiltinFunctions.add("ncurses_whline");
        allBuiltinFunctions.add("ncurses_wmouse_trafo");
        allBuiltinFunctions.add("ncurses_wmove");
        allBuiltinFunctions.add("ncurses_wnoutrefresh");
        allBuiltinFunctions.add("ncurses_wrefresh");
        allBuiltinFunctions.add("ncurses_wstandend");
        allBuiltinFunctions.add("ncurses_wstandout");
        allBuiltinFunctions.add("ncurses_wvline");
        allBuiltinFunctions.add("next");
        allBuiltinFunctions.add("ngettext");
        allBuiltinFunctions.add("nl2br");
        allBuiltinFunctions.add("nl_langinfo");
        allBuiltinFunctions.add("notes_body");
        allBuiltinFunctions.add("notes_copy_db");
        allBuiltinFunctions.add("notes_create_db");
        allBuiltinFunctions.add("notes_create_note");
        allBuiltinFunctions.add("notes_drop_db");
        allBuiltinFunctions.add("notes_find_note");
        allBuiltinFunctions.add("notes_header_info");
        allBuiltinFunctions.add("notes_list_msgs");
        allBuiltinFunctions.add("notes_mark_read");
        allBuiltinFunctions.add("notes_mark_unread");
        allBuiltinFunctions.add("notes_nav_create");
        allBuiltinFunctions.add("notes_search");
        allBuiltinFunctions.add("notes_unread");
        allBuiltinFunctions.add("notes_version");
        allBuiltinFunctions.add("nsapi_request_headers");
        allBuiltinFunctions.add("nsapi_response_headers");
        allBuiltinFunctions.add("nsapi_virtual");
        allBuiltinFunctions.add("number_format");
        allBuiltinFunctions.add("ob_clean");
        allBuiltinFunctions.add("ob_end_clean");
        allBuiltinFunctions.add("ob_end_flush");
        allBuiltinFunctions.add("ob_flush");
        allBuiltinFunctions.add("ob_get_clean");
        allBuiltinFunctions.add("ob_get_contents");
        allBuiltinFunctions.add("ob_get_flush");
        allBuiltinFunctions.add("ob_get_length");
        allBuiltinFunctions.add("ob_get_level");
        allBuiltinFunctions.add("ob_get_status");
        allBuiltinFunctions.add("ob_gzhandler");
        allBuiltinFunctions.add("ob_iconv_handler");
        allBuiltinFunctions.add("ob_implicit_flush");
        allBuiltinFunctions.add("ob_list_handlers");
        allBuiltinFunctions.add("ob_start");
        allBuiltinFunctions.add("ob_tidyhandler");
        allBuiltinFunctions.add("OCI-Collection->append");
        allBuiltinFunctions.add("OCI-Collection->assign");
        allBuiltinFunctions.add("OCI-Collection->assignElem");
        allBuiltinFunctions.add("OCI-Collection->free");
        allBuiltinFunctions.add("OCI-Collection->getElem");
        allBuiltinFunctions.add("OCI-Collection->max");
        allBuiltinFunctions.add("OCI-Collection->size");
        allBuiltinFunctions.add("OCI-Collection->trim");
        allBuiltinFunctions.add("oci_bind_by_name");
        allBuiltinFunctions.add("oci_cancel");
        allBuiltinFunctions.add("oci_close");
        allBuiltinFunctions.add("oci_commit");
        allBuiltinFunctions.add("oci_connect");
        allBuiltinFunctions.add("oci_define_by_name");
        allBuiltinFunctions.add("oci_error");
        allBuiltinFunctions.add("oci_execute");
        allBuiltinFunctions.add("oci_fetch");
        allBuiltinFunctions.add("oci_fetch_all");
        allBuiltinFunctions.add("oci_fetch_array");
        allBuiltinFunctions.add("oci_fetch_assoc");
        allBuiltinFunctions.add("oci_fetch_object");
        allBuiltinFunctions.add("oci_fetch_row");
        allBuiltinFunctions.add("oci_field_is_null");
        allBuiltinFunctions.add("oci_field_name");
        allBuiltinFunctions.add("oci_field_precision");
        allBuiltinFunctions.add("oci_field_scale");
        allBuiltinFunctions.add("oci_field_size");
        allBuiltinFunctions.add("oci_field_type");
        allBuiltinFunctions.add("oci_field_type_raw");
        allBuiltinFunctions.add("oci_free_statement");
        allBuiltinFunctions.add("oci_internal_debug");
        allBuiltinFunctions.add("oci_lob_copy");
        allBuiltinFunctions.add("oci_lob_is_equal");
        allBuiltinFunctions.add("oci_new_collection");
        allBuiltinFunctions.add("oci_new_connect");
        allBuiltinFunctions.add("oci_new_cursor");
        allBuiltinFunctions.add("oci_new_descriptor");
        allBuiltinFunctions.add("oci_num_fields");
        allBuiltinFunctions.add("oci_num_rows");
        allBuiltinFunctions.add("oci_parse");
        allBuiltinFunctions.add("oci_password_change");
        allBuiltinFunctions.add("oci_pconnect");
        allBuiltinFunctions.add("oci_result");
        allBuiltinFunctions.add("oci_rollback");
        allBuiltinFunctions.add("oci_server_version");
        allBuiltinFunctions.add("oci_set_prefetch");
        allBuiltinFunctions.add("oci_statement_type");
        allBuiltinFunctions.add("ocibindbyname");
        allBuiltinFunctions.add("ocicancel");
        allBuiltinFunctions.add("ocicloselob");
        allBuiltinFunctions.add("ocicollappend");
        allBuiltinFunctions.add("ocicollassign");
        allBuiltinFunctions.add("ocicollassignelem");
        allBuiltinFunctions.add("ocicollgetelem");
        allBuiltinFunctions.add("ocicollmax");
        allBuiltinFunctions.add("ocicollsize");
        allBuiltinFunctions.add("ocicolltrim");
        allBuiltinFunctions.add("ocicolumnisnull");
        allBuiltinFunctions.add("ocicolumnname");
        allBuiltinFunctions.add("ocicolumnprecision");
        allBuiltinFunctions.add("ocicolumnscale");
        allBuiltinFunctions.add("ocicolumnsize");
        allBuiltinFunctions.add("ocicolumntype");
        allBuiltinFunctions.add("ocicolumntyperaw");
        allBuiltinFunctions.add("ocicommit");
        allBuiltinFunctions.add("ocidefinebyname");
        allBuiltinFunctions.add("ocierror");
        allBuiltinFunctions.add("ociexecute");
        allBuiltinFunctions.add("ocifetch");
        allBuiltinFunctions.add("ocifetchinto");
        allBuiltinFunctions.add("ocifetchstatement");
        allBuiltinFunctions.add("ocifreecollection");
        allBuiltinFunctions.add("ocifreecursor");
        allBuiltinFunctions.add("ocifreedesc");
        allBuiltinFunctions.add("ocifreestatement");
        allBuiltinFunctions.add("ociinternaldebug");
        allBuiltinFunctions.add("ociloadlob");
        allBuiltinFunctions.add("ocilogoff");
        allBuiltinFunctions.add("ocilogon");
        allBuiltinFunctions.add("ocinewcollection");
        allBuiltinFunctions.add("ocinewcursor");
        allBuiltinFunctions.add("ocinewdescriptor");
        allBuiltinFunctions.add("ocinlogon");
        allBuiltinFunctions.add("ocinumcols");
        allBuiltinFunctions.add("ociparse");
        allBuiltinFunctions.add("ociplogon");
        allBuiltinFunctions.add("ociresult");
        allBuiltinFunctions.add("ocirollback");
        allBuiltinFunctions.add("ocirowcount");
        allBuiltinFunctions.add("ocisavelob");
        allBuiltinFunctions.add("ocisavelobfile");
        allBuiltinFunctions.add("ociserverversion");
        allBuiltinFunctions.add("ocisetprefetch");
        allBuiltinFunctions.add("ocistatementtype");
        allBuiltinFunctions.add("ociwritelobtofile");
        allBuiltinFunctions.add("ociwritetemporarylob");
        allBuiltinFunctions.add("octdec");
        allBuiltinFunctions.add("odbc_autocommit");
        allBuiltinFunctions.add("odbc_binmode");
        allBuiltinFunctions.add("odbc_close");
        allBuiltinFunctions.add("odbc_close_all");
        allBuiltinFunctions.add("odbc_columnprivileges");
        allBuiltinFunctions.add("odbc_columns");
        allBuiltinFunctions.add("odbc_commit");
        allBuiltinFunctions.add("odbc_connect");
        allBuiltinFunctions.add("odbc_cursor");
        allBuiltinFunctions.add("odbc_data_source");
        allBuiltinFunctions.add("odbc_do");
        allBuiltinFunctions.add("odbc_error");
        allBuiltinFunctions.add("odbc_errormsg");
        allBuiltinFunctions.add("odbc_exec");
        allBuiltinFunctions.add("odbc_execute");
        allBuiltinFunctions.add("odbc_fetch_array");
        allBuiltinFunctions.add("odbc_fetch_into");
        allBuiltinFunctions.add("odbc_fetch_object");
        allBuiltinFunctions.add("odbc_fetch_row");
        allBuiltinFunctions.add("odbc_field_len");
        allBuiltinFunctions.add("odbc_field_name");
        allBuiltinFunctions.add("odbc_field_num");
        allBuiltinFunctions.add("odbc_field_precision");
        allBuiltinFunctions.add("odbc_field_scale");
        allBuiltinFunctions.add("odbc_field_type");
        allBuiltinFunctions.add("odbc_foreignkeys");
        allBuiltinFunctions.add("odbc_free_result");
        allBuiltinFunctions.add("odbc_gettypeinfo");
        allBuiltinFunctions.add("odbc_longreadlen");
        allBuiltinFunctions.add("odbc_next_result");
        allBuiltinFunctions.add("odbc_num_fields");
        allBuiltinFunctions.add("odbc_num_rows");
        allBuiltinFunctions.add("odbc_pconnect");
        allBuiltinFunctions.add("odbc_prepare");
        allBuiltinFunctions.add("odbc_primarykeys");
        allBuiltinFunctions.add("odbc_procedurecolumns");
        allBuiltinFunctions.add("odbc_procedures");
        allBuiltinFunctions.add("odbc_result");
        allBuiltinFunctions.add("odbc_result_all");
        allBuiltinFunctions.add("odbc_rollback");
        allBuiltinFunctions.add("odbc_setoption");
        allBuiltinFunctions.add("odbc_specialcolumns");
        allBuiltinFunctions.add("odbc_statistics");
        allBuiltinFunctions.add("odbc_tableprivileges");
        allBuiltinFunctions.add("odbc_tables");
        allBuiltinFunctions.add("openal_buffer_create");
        allBuiltinFunctions.add("openal_buffer_data");
        allBuiltinFunctions.add("openal_buffer_destroy");
        allBuiltinFunctions.add("openal_buffer_get");
        allBuiltinFunctions.add("openal_buffer_loadwav");
        allBuiltinFunctions.add("openal_context_create");
        allBuiltinFunctions.add("openal_context_current");
        allBuiltinFunctions.add("openal_context_destroy");
        allBuiltinFunctions.add("openal_context_process");
        allBuiltinFunctions.add("openal_context_suspend");
        allBuiltinFunctions.add("openal_device_close");
        allBuiltinFunctions.add("openal_device_open");
        allBuiltinFunctions.add("openal_listener_get");
        allBuiltinFunctions.add("openal_listener_set");
        allBuiltinFunctions.add("openal_source_create");
        allBuiltinFunctions.add("openal_source_destroy");
        allBuiltinFunctions.add("openal_source_get");
        allBuiltinFunctions.add("openal_source_pause");
        allBuiltinFunctions.add("openal_source_play");
        allBuiltinFunctions.add("openal_source_rewind");
        allBuiltinFunctions.add("openal_source_set");
        allBuiltinFunctions.add("openal_source_stop");
        allBuiltinFunctions.add("openal_stream");
        allBuiltinFunctions.add("opendir");
        allBuiltinFunctions.add("openlog");
        allBuiltinFunctions.add("openssl_csr_export");
        allBuiltinFunctions.add("openssl_csr_export_to_file");
        allBuiltinFunctions.add("openssl_csr_new");
        allBuiltinFunctions.add("openssl_csr_sign");
        allBuiltinFunctions.add("openssl_error_string");
        allBuiltinFunctions.add("openssl_free_key");
        allBuiltinFunctions.add("openssl_get_privatekey");
        allBuiltinFunctions.add("openssl_get_publickey");
        allBuiltinFunctions.add("openssl_open");
        allBuiltinFunctions.add("openssl_pkcs7_decrypt");
        allBuiltinFunctions.add("openssl_pkcs7_encrypt");
        allBuiltinFunctions.add("openssl_pkcs7_sign");
        allBuiltinFunctions.add("openssl_pkcs7_verify");
        allBuiltinFunctions.add("openssl_pkey_export");
        allBuiltinFunctions.add("openssl_pkey_export_to_file");
        allBuiltinFunctions.add("openssl_pkey_get_private");
        allBuiltinFunctions.add("openssl_pkey_get_public");
        allBuiltinFunctions.add("openssl_pkey_new");
        allBuiltinFunctions.add("openssl_private_decrypt");
        allBuiltinFunctions.add("openssl_private_encrypt");
        allBuiltinFunctions.add("openssl_public_decrypt");
        allBuiltinFunctions.add("openssl_public_encrypt");
        allBuiltinFunctions.add("openssl_seal");
        allBuiltinFunctions.add("openssl_sign");
        allBuiltinFunctions.add("openssl_verify");
        allBuiltinFunctions.add("openssl_x509_check_private_key");
        allBuiltinFunctions.add("openssl_x509_checkpurpose");
        allBuiltinFunctions.add("openssl_x509_export");
        allBuiltinFunctions.add("openssl_x509_export_to_file");
        allBuiltinFunctions.add("openssl_x509_free");
        allBuiltinFunctions.add("openssl_x509_parse");
        allBuiltinFunctions.add("openssl_x509_read");
        allBuiltinFunctions.add("ora_bind");
        allBuiltinFunctions.add("ora_close");
        allBuiltinFunctions.add("ora_columnname");
        allBuiltinFunctions.add("ora_columnsize");
        allBuiltinFunctions.add("ora_columntype");
        allBuiltinFunctions.add("ora_commit");
        allBuiltinFunctions.add("ora_commitoff");
        allBuiltinFunctions.add("ora_commiton");
        allBuiltinFunctions.add("ora_do");
        allBuiltinFunctions.add("ora_error");
        allBuiltinFunctions.add("ora_errorcode");
        allBuiltinFunctions.add("ora_exec");
        allBuiltinFunctions.add("ora_fetch");
        allBuiltinFunctions.add("ora_fetch_into");
        allBuiltinFunctions.add("ora_getcolumn");
        allBuiltinFunctions.add("ora_logoff");
        allBuiltinFunctions.add("ora_logon");
        allBuiltinFunctions.add("ora_numcols");
        allBuiltinFunctions.add("ora_numrows");
        allBuiltinFunctions.add("ora_open");
        allBuiltinFunctions.add("ora_parse");
        allBuiltinFunctions.add("ora_plogon");
        allBuiltinFunctions.add("ora_rollback");
        allBuiltinFunctions.add("ord");
        allBuiltinFunctions.add("output_add_rewrite_var");
        allBuiltinFunctions.add("output_reset_rewrite_vars");
        allBuiltinFunctions.add("overload");
        allBuiltinFunctions.add("override_function");
        allBuiltinFunctions.add("ovrimos_close");
        allBuiltinFunctions.add("ovrimos_commit");
        allBuiltinFunctions.add("ovrimos_connect");
        allBuiltinFunctions.add("ovrimos_cursor");
        allBuiltinFunctions.add("ovrimos_exec");
        allBuiltinFunctions.add("ovrimos_execute");
        allBuiltinFunctions.add("ovrimos_fetch_into");
        allBuiltinFunctions.add("ovrimos_fetch_row");
        allBuiltinFunctions.add("ovrimos_field_len");
        allBuiltinFunctions.add("ovrimos_field_name");
        allBuiltinFunctions.add("ovrimos_field_num");
        allBuiltinFunctions.add("ovrimos_field_type");
        allBuiltinFunctions.add("ovrimos_free_result");
        allBuiltinFunctions.add("ovrimos_longreadlen");
        allBuiltinFunctions.add("ovrimos_num_fields");
        allBuiltinFunctions.add("ovrimos_num_rows");
        allBuiltinFunctions.add("ovrimos_prepare");
        allBuiltinFunctions.add("ovrimos_result");
        allBuiltinFunctions.add("ovrimos_result_all");
        allBuiltinFunctions.add("ovrimos_rollback");
        allBuiltinFunctions.add("pack");
        allBuiltinFunctions.add("ParentIterator::getChildren");
        allBuiltinFunctions.add("ParentIterator::hasChildren");
        allBuiltinFunctions.add("ParentIterator::next");
        allBuiltinFunctions.add("ParentIterator::rewind");
        allBuiltinFunctions.add("parse_ini_file");
        allBuiltinFunctions.add("parse_str");
        allBuiltinFunctions.add("parse_url");
        allBuiltinFunctions.add("parsekit_compile_file");
        allBuiltinFunctions.add("parsekit_compile_string");
        allBuiltinFunctions.add("parsekit_func_arginfo");
        allBuiltinFunctions.add("passthru");
        allBuiltinFunctions.add("pathinfo");
        allBuiltinFunctions.add("pclose");
        allBuiltinFunctions.add("pcntl_alarm");
        allBuiltinFunctions.add("pcntl_exec");
        allBuiltinFunctions.add("pcntl_fork");
        allBuiltinFunctions.add("pcntl_getpriority");
        allBuiltinFunctions.add("pcntl_setpriority");
        allBuiltinFunctions.add("pcntl_signal");
        allBuiltinFunctions.add("pcntl_wait");
        allBuiltinFunctions.add("pcntl_waitpid");
        allBuiltinFunctions.add("pcntl_wexitstatus");
        allBuiltinFunctions.add("pcntl_wifexited");
        allBuiltinFunctions.add("pcntl_wifsignaled");
        allBuiltinFunctions.add("pcntl_wifstopped");
        allBuiltinFunctions.add("pcntl_wstopsig");
        allBuiltinFunctions.add("pcntl_wtermsig");
        allBuiltinFunctions.add("pdf_add_annotation");
        allBuiltinFunctions.add("pdf_add_bookmark");
        allBuiltinFunctions.add("pdf_add_launchlink");
        allBuiltinFunctions.add("pdf_add_locallink");
        allBuiltinFunctions.add("pdf_add_note");
        allBuiltinFunctions.add("pdf_add_outline");
        allBuiltinFunctions.add("pdf_add_pdflink");
        allBuiltinFunctions.add("pdf_add_thumbnail");
        allBuiltinFunctions.add("pdf_add_weblink");
        allBuiltinFunctions.add("pdf_arc");
        allBuiltinFunctions.add("pdf_arcn");
        allBuiltinFunctions.add("pdf_attach_file");
        allBuiltinFunctions.add("pdf_begin_page");
        allBuiltinFunctions.add("pdf_begin_pattern");
        allBuiltinFunctions.add("pdf_begin_template");
        allBuiltinFunctions.add("pdf_circle");
        allBuiltinFunctions.add("pdf_clip");
        allBuiltinFunctions.add("pdf_close");
        allBuiltinFunctions.add("pdf_close_image");
        allBuiltinFunctions.add("pdf_close_pdi");
        allBuiltinFunctions.add("pdf_close_pdi_page");
        allBuiltinFunctions.add("pdf_closepath");
        allBuiltinFunctions.add("pdf_closepath_fill_stroke");
        allBuiltinFunctions.add("pdf_closepath_stroke");
        allBuiltinFunctions.add("pdf_concat");
        allBuiltinFunctions.add("pdf_continue_text");
        allBuiltinFunctions.add("pdf_curveto");
        allBuiltinFunctions.add("pdf_delete");
        allBuiltinFunctions.add("pdf_end_page");
        allBuiltinFunctions.add("pdf_end_pattern");
        allBuiltinFunctions.add("pdf_end_template");
        allBuiltinFunctions.add("pdf_endpath");
        allBuiltinFunctions.add("pdf_fill");
        allBuiltinFunctions.add("pdf_fill_stroke");
        allBuiltinFunctions.add("pdf_findfont");
        allBuiltinFunctions.add("pdf_get_buffer");
        allBuiltinFunctions.add("pdf_get_font");
        allBuiltinFunctions.add("pdf_get_fontname");
        allBuiltinFunctions.add("pdf_get_fontsize");
        allBuiltinFunctions.add("pdf_get_image_height");
        allBuiltinFunctions.add("pdf_get_image_width");
        allBuiltinFunctions.add("pdf_get_majorversion");
        allBuiltinFunctions.add("pdf_get_minorversion");
        allBuiltinFunctions.add("pdf_get_parameter");
        allBuiltinFunctions.add("pdf_get_pdi_parameter");
        allBuiltinFunctions.add("pdf_get_pdi_value");
        allBuiltinFunctions.add("pdf_get_value");
        allBuiltinFunctions.add("pdf_initgraphics");
        allBuiltinFunctions.add("pdf_lineto");
        allBuiltinFunctions.add("pdf_makespotcolor");
        allBuiltinFunctions.add("pdf_moveto");
        allBuiltinFunctions.add("pdf_new");
        allBuiltinFunctions.add("pdf_open");
        allBuiltinFunctions.add("pdf_open_ccitt");
        allBuiltinFunctions.add("pdf_open_file");
        allBuiltinFunctions.add("pdf_open_gif");
        allBuiltinFunctions.add("pdf_open_image");
        allBuiltinFunctions.add("pdf_open_image_file");
        allBuiltinFunctions.add("pdf_open_jpeg");
        allBuiltinFunctions.add("pdf_open_memory_image");
        allBuiltinFunctions.add("pdf_open_pdi");
        allBuiltinFunctions.add("pdf_open_pdi_page");
        allBuiltinFunctions.add("pdf_open_png");
        allBuiltinFunctions.add("pdf_open_tiff");
        allBuiltinFunctions.add("pdf_place_image");
        allBuiltinFunctions.add("pdf_place_pdi_page");
        allBuiltinFunctions.add("pdf_rect");
        allBuiltinFunctions.add("pdf_restore");
        allBuiltinFunctions.add("pdf_rotate");
        allBuiltinFunctions.add("pdf_save");
        allBuiltinFunctions.add("pdf_scale");
        allBuiltinFunctions.add("pdf_set_border_color");
        allBuiltinFunctions.add("pdf_set_border_dash");
        allBuiltinFunctions.add("pdf_set_border_style");
        allBuiltinFunctions.add("pdf_set_char_spacing");
        allBuiltinFunctions.add("pdf_set_duration");
        allBuiltinFunctions.add("pdf_set_font");
        allBuiltinFunctions.add("pdf_set_horiz_scaling");
        allBuiltinFunctions.add("pdf_set_info");
        allBuiltinFunctions.add("pdf_set_info_author");
        allBuiltinFunctions.add("pdf_set_info_creator");
        allBuiltinFunctions.add("pdf_set_info_keywords");
        allBuiltinFunctions.add("pdf_set_info_subject");
        allBuiltinFunctions.add("pdf_set_info_title");
        allBuiltinFunctions.add("pdf_set_leading");
        allBuiltinFunctions.add("pdf_set_parameter");
        allBuiltinFunctions.add("pdf_set_text_matrix");
        allBuiltinFunctions.add("pdf_set_text_pos");
        allBuiltinFunctions.add("pdf_set_text_rendering");
        allBuiltinFunctions.add("pdf_set_text_rise");
        allBuiltinFunctions.add("pdf_set_value");
        allBuiltinFunctions.add("pdf_set_word_spacing");
        allBuiltinFunctions.add("pdf_setcolor");
        allBuiltinFunctions.add("pdf_setdash");
        allBuiltinFunctions.add("pdf_setflat");
        allBuiltinFunctions.add("pdf_setfont");
        allBuiltinFunctions.add("pdf_setgray");
        allBuiltinFunctions.add("pdf_setgray_fill");
        allBuiltinFunctions.add("pdf_setgray_stroke");
        allBuiltinFunctions.add("pdf_setlinecap");
        allBuiltinFunctions.add("pdf_setlinejoin");
        allBuiltinFunctions.add("pdf_setlinewidth");
        allBuiltinFunctions.add("pdf_setmatrix");
        allBuiltinFunctions.add("pdf_setmiterlimit");
        allBuiltinFunctions.add("pdf_setpolydash");
        allBuiltinFunctions.add("pdf_setrgbcolor");
        allBuiltinFunctions.add("pdf_setrgbcolor_fill");
        allBuiltinFunctions.add("pdf_setrgbcolor_stroke");
        allBuiltinFunctions.add("pdf_show");
        allBuiltinFunctions.add("pdf_show_boxed");
        allBuiltinFunctions.add("pdf_show_xy");
        allBuiltinFunctions.add("pdf_skew");
        allBuiltinFunctions.add("pdf_stringwidth");
        allBuiltinFunctions.add("pdf_stroke");
        allBuiltinFunctions.add("pdf_translate");
        allBuiltinFunctions.add("PDO::__construct");
        allBuiltinFunctions.add("PDO::beginTransaction");
        allBuiltinFunctions.add("PDO::commit");
        allBuiltinFunctions.add("PDO::errorCode");
        allBuiltinFunctions.add("PDO::errorInfo");
        allBuiltinFunctions.add("PDO::exec");
        allBuiltinFunctions.add("PDO::lastInsertId");
        allBuiltinFunctions.add("PDO::prepare");
        allBuiltinFunctions.add("PDO::rollBack");
        allBuiltinFunctions.add("PDO::setAttribute");
        allBuiltinFunctions.add("PDOStatement::bindColumn");
        allBuiltinFunctions.add("PDOStatement::bindParam");
        allBuiltinFunctions.add("PDOStatement::errorCode");
        allBuiltinFunctions.add("PDOStatement::errorInfo");
        allBuiltinFunctions.add("PDOStatement::execute");
        allBuiltinFunctions.add("PDOStatement::fetch");
        allBuiltinFunctions.add("PDOStatement::fetchAll");
        allBuiltinFunctions.add("PDOStatement::fetchSingle");
        allBuiltinFunctions.add("PDOStatement::rowCount");
        allBuiltinFunctions.add("pfpro_cleanup");
        allBuiltinFunctions.add("pfpro_init");
        allBuiltinFunctions.add("pfpro_process");
        allBuiltinFunctions.add("pfpro_process_raw");
        allBuiltinFunctions.add("pfpro_version");
        allBuiltinFunctions.add("pfsockopen");
        allBuiltinFunctions.add("pg_affected_rows");
        allBuiltinFunctions.add("pg_cancel_query");
        allBuiltinFunctions.add("pg_client_encoding");
        allBuiltinFunctions.add("pg_close");
        allBuiltinFunctions.add("pg_connect");
        allBuiltinFunctions.add("pg_connection_busy");
        allBuiltinFunctions.add("pg_connection_reset");
        allBuiltinFunctions.add("pg_connection_status");
        allBuiltinFunctions.add("pg_convert");
        allBuiltinFunctions.add("pg_copy_from");
        allBuiltinFunctions.add("pg_copy_to");
        allBuiltinFunctions.add("pg_dbname");
        allBuiltinFunctions.add("pg_delete");
        allBuiltinFunctions.add("pg_end_copy");
        allBuiltinFunctions.add("pg_escape_bytea");
        allBuiltinFunctions.add("pg_escape_string");
        allBuiltinFunctions.add("pg_fetch_all");
        allBuiltinFunctions.add("pg_fetch_array");
        allBuiltinFunctions.add("pg_fetch_assoc");
        allBuiltinFunctions.add("pg_fetch_object");
        allBuiltinFunctions.add("pg_fetch_result");
        allBuiltinFunctions.add("pg_fetch_row");
        allBuiltinFunctions.add("pg_field_is_null");
        allBuiltinFunctions.add("pg_field_name");
        allBuiltinFunctions.add("pg_field_num");
        allBuiltinFunctions.add("pg_field_prtlen");
        allBuiltinFunctions.add("pg_field_size");
        allBuiltinFunctions.add("pg_field_type");
        allBuiltinFunctions.add("pg_free_result");
        allBuiltinFunctions.add("pg_get_notify");
        allBuiltinFunctions.add("pg_get_pid");
        allBuiltinFunctions.add("pg_get_result");
        allBuiltinFunctions.add("pg_host");
        allBuiltinFunctions.add("pg_insert");
        allBuiltinFunctions.add("pg_last_error");
        allBuiltinFunctions.add("pg_last_notice");
        allBuiltinFunctions.add("pg_last_oid");
        allBuiltinFunctions.add("pg_lo_close");
        allBuiltinFunctions.add("pg_lo_create");
        allBuiltinFunctions.add("pg_lo_export");
        allBuiltinFunctions.add("pg_lo_import");
        allBuiltinFunctions.add("pg_lo_open");
        allBuiltinFunctions.add("pg_lo_read");
        allBuiltinFunctions.add("pg_lo_read_all");
        allBuiltinFunctions.add("pg_lo_seek");
        allBuiltinFunctions.add("pg_lo_tell");
        allBuiltinFunctions.add("pg_lo_unlink");
        allBuiltinFunctions.add("pg_lo_write");
        allBuiltinFunctions.add("pg_meta_data");
        allBuiltinFunctions.add("pg_num_fields");
        allBuiltinFunctions.add("pg_num_rows");
        allBuiltinFunctions.add("pg_options");
        allBuiltinFunctions.add("pg_parameter_status");
        allBuiltinFunctions.add("pg_pconnect");
        allBuiltinFunctions.add("pg_ping");
        allBuiltinFunctions.add("pg_port");
        allBuiltinFunctions.add("pg_put_line");
        allBuiltinFunctions.add("pg_query");
        allBuiltinFunctions.add("pg_result_error");
        allBuiltinFunctions.add("pg_result_seek");
        allBuiltinFunctions.add("pg_result_status");
        allBuiltinFunctions.add("pg_select");
        allBuiltinFunctions.add("pg_send_query");
        allBuiltinFunctions.add("pg_set_client_encoding");
        allBuiltinFunctions.add("pg_trace");
        allBuiltinFunctions.add("pg_tty");
        allBuiltinFunctions.add("pg_unescape_bytea");
        allBuiltinFunctions.add("pg_untrace");
        allBuiltinFunctions.add("pg_update");
        allBuiltinFunctions.add("pg_version");
        allBuiltinFunctions.add("php_check_syntax");
        allBuiltinFunctions.add("php_ini_scanned_files");
        allBuiltinFunctions.add("php_logo_guid");
        allBuiltinFunctions.add("php_register_url_stream_wrapper");
        allBuiltinFunctions.add("php_sapi_name");
        allBuiltinFunctions.add("php_stream_can_cast");
        allBuiltinFunctions.add("php_stream_cast");
        allBuiltinFunctions.add("php_stream_close");
        allBuiltinFunctions.add("php_stream_closedir");
        allBuiltinFunctions.add("php_stream_copy_to_mem");
        allBuiltinFunctions.add("php_stream_copy_to_stream");
        allBuiltinFunctions.add("php_stream_eof");
        allBuiltinFunctions.add("php_stream_filter_register_factory");
        allBuiltinFunctions.add("php_stream_filter_unregister_factory");
        allBuiltinFunctions.add("php_stream_flush");
        allBuiltinFunctions.add("php_stream_fopen_from_file");
        allBuiltinFunctions.add("php_stream_fopen_temporary_file");
        allBuiltinFunctions.add("php_stream_fopen_tmpfile");
        allBuiltinFunctions.add("php_stream_getc");
        allBuiltinFunctions.add("php_stream_gets");
        allBuiltinFunctions.add("php_stream_is");
        allBuiltinFunctions.add("php_stream_is_persistent");
        allBuiltinFunctions.add("php_stream_make_seekable");
        allBuiltinFunctions.add("php_stream_open_wrapper");
        allBuiltinFunctions.add("php_stream_open_wrapper_as_file");
        allBuiltinFunctions.add("php_stream_open_wrapper_ex");
        allBuiltinFunctions.add("php_stream_opendir");
        allBuiltinFunctions.add("php_stream_passthru");
        allBuiltinFunctions.add("php_stream_read");
        allBuiltinFunctions.add("php_stream_readdir");
        allBuiltinFunctions.add("php_stream_rewinddir");
        allBuiltinFunctions.add("php_stream_seek");
        allBuiltinFunctions.add("php_stream_sock_open_from_socket");
        allBuiltinFunctions.add("php_stream_sock_open_host");
        allBuiltinFunctions.add("php_stream_sock_open_unix");
        allBuiltinFunctions.add("php_stream_stat");
        allBuiltinFunctions.add("php_stream_stat_path");
        allBuiltinFunctions.add("php_stream_tell");
        allBuiltinFunctions.add("php_stream_write");
        allBuiltinFunctions.add("php_strip_whitespace");
        allBuiltinFunctions.add("php_uname");
        allBuiltinFunctions.add("php_unregister_url_stream_wrapper");
        allBuiltinFunctions.add("phpcredits");
        allBuiltinFunctions.add("phpinfo");
        allBuiltinFunctions.add("phpversion");
        allBuiltinFunctions.add("pi");
        allBuiltinFunctions.add("png2wbmp");
        allBuiltinFunctions.add("popen");
        allBuiltinFunctions.add("pos");
        allBuiltinFunctions.add("posix_ctermid");
        allBuiltinFunctions.add("posix_get_last_error");
        allBuiltinFunctions.add("posix_getcwd");
        allBuiltinFunctions.add("posix_getegid");
        allBuiltinFunctions.add("posix_geteuid");
        allBuiltinFunctions.add("posix_getgid");
        allBuiltinFunctions.add("posix_getgrgid");
        allBuiltinFunctions.add("posix_getgrnam");
        allBuiltinFunctions.add("posix_getgroups");
        allBuiltinFunctions.add("posix_getlogin");
        allBuiltinFunctions.add("posix_getpgid");
        allBuiltinFunctions.add("posix_getpgrp");
        allBuiltinFunctions.add("posix_getpid");
        allBuiltinFunctions.add("posix_getppid");
        allBuiltinFunctions.add("posix_getpwnam");
        allBuiltinFunctions.add("posix_getpwuid");
        allBuiltinFunctions.add("posix_getrlimit");
        allBuiltinFunctions.add("posix_getsid");
        allBuiltinFunctions.add("posix_getuid");
        allBuiltinFunctions.add("posix_isatty");
        allBuiltinFunctions.add("posix_kill");
        allBuiltinFunctions.add("posix_mkfifo");
        allBuiltinFunctions.add("posix_setegid");
        allBuiltinFunctions.add("posix_seteuid");
        allBuiltinFunctions.add("posix_setgid");
        allBuiltinFunctions.add("posix_setpgid");
        allBuiltinFunctions.add("posix_setsid");
        allBuiltinFunctions.add("posix_setuid");
        allBuiltinFunctions.add("posix_strerror");
        allBuiltinFunctions.add("posix_times");
        allBuiltinFunctions.add("posix_ttyname");
        allBuiltinFunctions.add("posix_uname");
        allBuiltinFunctions.add("pow");
        allBuiltinFunctions.add("preg_grep");
        allBuiltinFunctions.add("preg_match");
        allBuiltinFunctions.add("preg_match_all");
        allBuiltinFunctions.add("preg_quote");
        allBuiltinFunctions.add("preg_replace");
        allBuiltinFunctions.add("preg_replace_callback");
        allBuiltinFunctions.add("preg_split");
        allBuiltinFunctions.add("prev");
        allBuiltinFunctions.add("print");
        allBuiltinFunctions.add("print_r");
        allBuiltinFunctions.add("printer_abort");
        allBuiltinFunctions.add("printer_close");
        allBuiltinFunctions.add("printer_create_brush");
        allBuiltinFunctions.add("printer_create_dc");
        allBuiltinFunctions.add("printer_create_font");
        allBuiltinFunctions.add("printer_create_pen");
        allBuiltinFunctions.add("printer_delete_brush");
        allBuiltinFunctions.add("printer_delete_dc");
        allBuiltinFunctions.add("printer_delete_font");
        allBuiltinFunctions.add("printer_delete_pen");
        allBuiltinFunctions.add("printer_draw_bmp");
        allBuiltinFunctions.add("printer_draw_chord");
        allBuiltinFunctions.add("printer_draw_elipse");
        allBuiltinFunctions.add("printer_draw_line");
        allBuiltinFunctions.add("printer_draw_pie");
        allBuiltinFunctions.add("printer_draw_rectangle");
        allBuiltinFunctions.add("printer_draw_roundrect");
        allBuiltinFunctions.add("printer_draw_text");
        allBuiltinFunctions.add("printer_end_doc");
        allBuiltinFunctions.add("printer_end_page");
        allBuiltinFunctions.add("printer_get_option");
        allBuiltinFunctions.add("printer_list");
        allBuiltinFunctions.add("printer_logical_fontheight");
        allBuiltinFunctions.add("printer_open");
        allBuiltinFunctions.add("printer_select_brush");
        allBuiltinFunctions.add("printer_select_font");
        allBuiltinFunctions.add("printer_select_pen");
        allBuiltinFunctions.add("printer_set_option");
        allBuiltinFunctions.add("printer_start_doc");
        allBuiltinFunctions.add("printer_start_page");
        allBuiltinFunctions.add("printer_write");
        allBuiltinFunctions.add("printf");
        allBuiltinFunctions.add("proc_close");
        allBuiltinFunctions.add("proc_get_status");
        allBuiltinFunctions.add("proc_nice");
        allBuiltinFunctions.add("proc_open");
        allBuiltinFunctions.add("proc_terminate");
        allBuiltinFunctions.add("pspell_add_to_personal");
        allBuiltinFunctions.add("pspell_add_to_session");
        allBuiltinFunctions.add("pspell_check");
        allBuiltinFunctions.add("pspell_clear_session");
        allBuiltinFunctions.add("pspell_config_create");
        allBuiltinFunctions.add("pspell_config_data_dir");
        allBuiltinFunctions.add("pspell_config_dict_dir");
        allBuiltinFunctions.add("pspell_config_ignore");
        allBuiltinFunctions.add("pspell_config_mode");
        allBuiltinFunctions.add("pspell_config_personal");
        allBuiltinFunctions.add("pspell_config_repl");
        allBuiltinFunctions.add("pspell_config_runtogether");
        allBuiltinFunctions.add("pspell_config_save_repl");
        allBuiltinFunctions.add("pspell_new");
        allBuiltinFunctions.add("pspell_new_config");
        allBuiltinFunctions.add("pspell_new_personal");
        allBuiltinFunctions.add("pspell_save_wordlist");
        allBuiltinFunctions.add("pspell_store_replacement");
        allBuiltinFunctions.add("pspell_suggest");
        allBuiltinFunctions.add("putenv");
        allBuiltinFunctions.add("qdom_error");
        allBuiltinFunctions.add("qdom_tree");
        allBuiltinFunctions.add("quoted_printable_decode");
        allBuiltinFunctions.add("quotemeta");
        allBuiltinFunctions.add("rad2deg");
        allBuiltinFunctions.add("rand");
        allBuiltinFunctions.add("range");
        allBuiltinFunctions.add("Rar::extract");
        allBuiltinFunctions.add("Rar::getAttr");
        allBuiltinFunctions.add("Rar::getCrc");
        allBuiltinFunctions.add("Rar::getFileTime");
        allBuiltinFunctions.add("Rar::getHostOs");
        allBuiltinFunctions.add("Rar::getMethod");
        allBuiltinFunctions.add("Rar::getName");
        allBuiltinFunctions.add("Rar::getPackedSize");
        allBuiltinFunctions.add("Rar::getUnpackedSize");
        allBuiltinFunctions.add("Rar::getVersion");
        allBuiltinFunctions.add("rar_close");
        allBuiltinFunctions.add("rar_entry_get");
        allBuiltinFunctions.add("rar_list");
        allBuiltinFunctions.add("rar_open");
        allBuiltinFunctions.add("rawurldecode");
        allBuiltinFunctions.add("rawurlencode");
        allBuiltinFunctions.add("read_exif_data");
        allBuiltinFunctions.add("readdir");
        allBuiltinFunctions.add("readfile");
        allBuiltinFunctions.add("readgzfile");
        allBuiltinFunctions.add("readline");
        allBuiltinFunctions.add("readline_add_history");
        allBuiltinFunctions.add("readline_callback_handler_install");
        allBuiltinFunctions.add("readline_callback_handler_remove");
        allBuiltinFunctions.add("readline_callback_read_char");
        allBuiltinFunctions.add("readline_clear_history");
        allBuiltinFunctions.add("readline_completion_function");
        allBuiltinFunctions.add("readline_info");
        allBuiltinFunctions.add("readline_list_history");
        allBuiltinFunctions.add("readline_on_new_line");
        allBuiltinFunctions.add("readline_read_history");
        allBuiltinFunctions.add("readline_redisplay");
        allBuiltinFunctions.add("readline_write_history");
        allBuiltinFunctions.add("readlink");
        allBuiltinFunctions.add("realpath");
        allBuiltinFunctions.add("recode");
        allBuiltinFunctions.add("recode_file");
        allBuiltinFunctions.add("recode_string");
        allBuiltinFunctions.add("RecursiveDirectoryIterator::getChildren");
        allBuiltinFunctions.add("RecursiveDirectoryIterator::hasChildren");
        allBuiltinFunctions.add("RecursiveDirectoryIterator::key");
        allBuiltinFunctions.add("RecursiveDirectoryIterator::next");
        allBuiltinFunctions.add("RecursiveDirectoryIterator::rewind");
        allBuiltinFunctions.add("RecursiveIteratorIterator::current");
        allBuiltinFunctions.add("RecursiveIteratorIterator::getDepth");
        allBuiltinFunctions.add("RecursiveIteratorIterator::getSubIterator");
        allBuiltinFunctions.add("RecursiveIteratorIterator::key");
        allBuiltinFunctions.add("RecursiveIteratorIterator::next");
        allBuiltinFunctions.add("RecursiveIteratorIterator::rewind");
        allBuiltinFunctions.add("RecursiveIteratorIterator::valid");
        allBuiltinFunctions.add("register_shutdown_function");
        allBuiltinFunctions.add("register_tick_function");
        allBuiltinFunctions.add("rename");
        allBuiltinFunctions.add("rename_function");
        allBuiltinFunctions.add("reset");
        allBuiltinFunctions.add("restore_error_handler");
        allBuiltinFunctions.add("restore_exception_handler");
        allBuiltinFunctions.add("restore_include_path");
        allBuiltinFunctions.add("result->current_field");
        allBuiltinFunctions.add("result->data_seek");
        allBuiltinFunctions.add("result->fetch_array");
        allBuiltinFunctions.add("result->fetch_field");
        allBuiltinFunctions.add("result->fetch_field_direct");
        allBuiltinFunctions.add("result->fetch_fields");
        allBuiltinFunctions.add("result->fetch_object");
        allBuiltinFunctions.add("result->fetch_row");
        allBuiltinFunctions.add("result->field_count");
        allBuiltinFunctions.add("result->field_seek");
        allBuiltinFunctions.add("result->free");
        allBuiltinFunctions.add("result->lengths");
        allBuiltinFunctions.add("rewind");
        allBuiltinFunctions.add("rewinddir");
        allBuiltinFunctions.add("rmdir");
        allBuiltinFunctions.add("round");
        allBuiltinFunctions.add("rsort");
        allBuiltinFunctions.add("rtrim");
        allBuiltinFunctions.add("scandir");
        allBuiltinFunctions.add("sem_acquire");
        allBuiltinFunctions.add("sem_get");
        allBuiltinFunctions.add("sem_release");
        allBuiltinFunctions.add("sem_remove");
        allBuiltinFunctions.add("serialize");
        allBuiltinFunctions.add("sesam_affected_rows");
        allBuiltinFunctions.add("sesam_commit");
        allBuiltinFunctions.add("sesam_connect");
        allBuiltinFunctions.add("sesam_diagnostic");
        allBuiltinFunctions.add("sesam_disconnect");
        allBuiltinFunctions.add("sesam_errormsg");
        allBuiltinFunctions.add("sesam_execimm");
        allBuiltinFunctions.add("sesam_fetch_array");
        allBuiltinFunctions.add("sesam_fetch_result");
        allBuiltinFunctions.add("sesam_fetch_row");
        allBuiltinFunctions.add("sesam_field_array");
        allBuiltinFunctions.add("sesam_field_name");
        allBuiltinFunctions.add("sesam_free_result");
        allBuiltinFunctions.add("sesam_num_fields");
        allBuiltinFunctions.add("sesam_query");
        allBuiltinFunctions.add("sesam_rollback");
        allBuiltinFunctions.add("sesam_seek_row");
        allBuiltinFunctions.add("sesam_settransaction");
        allBuiltinFunctions.add("session_cache_expire");
        allBuiltinFunctions.add("session_cache_limiter");
        allBuiltinFunctions.add("session_commit");
        allBuiltinFunctions.add("session_decode");
        allBuiltinFunctions.add("session_destroy");
        allBuiltinFunctions.add("session_encode");
        allBuiltinFunctions.add("session_get_cookie_params");
        allBuiltinFunctions.add("session_id");
        allBuiltinFunctions.add("session_is_registered");
        allBuiltinFunctions.add("session_module_name");
        allBuiltinFunctions.add("session_name");
        allBuiltinFunctions.add("session_regenerate_id");
        allBuiltinFunctions.add("session_register");
        allBuiltinFunctions.add("session_save_path");
        allBuiltinFunctions.add("session_set_cookie_params");
        allBuiltinFunctions.add("session_set_save_handler");
        allBuiltinFunctions.add("session_start");
        allBuiltinFunctions.add("session_unregister");
        allBuiltinFunctions.add("session_unset");
        allBuiltinFunctions.add("session_write_close");
        allBuiltinFunctions.add("set_error_handler");
        allBuiltinFunctions.add("set_exception_handler");
        allBuiltinFunctions.add("set_file_buffer");
        allBuiltinFunctions.add("set_include_path");
        allBuiltinFunctions.add("set_magic_quotes_runtime");
        allBuiltinFunctions.add("set_time_limit");
        allBuiltinFunctions.add("setcookie");
        allBuiltinFunctions.add("setlocale");
        allBuiltinFunctions.add("setrawcookie");
        allBuiltinFunctions.add("settype");
        allBuiltinFunctions.add("sha1");
        allBuiltinFunctions.add("sha1_file");
        allBuiltinFunctions.add("shell_exec");
        allBuiltinFunctions.add("shm_attach");
        allBuiltinFunctions.add("shm_detach");
        allBuiltinFunctions.add("shm_get_var");
        allBuiltinFunctions.add("shm_put_var");
        allBuiltinFunctions.add("shm_remove");
        allBuiltinFunctions.add("shm_remove_var");
        allBuiltinFunctions.add("shmop_close");
        allBuiltinFunctions.add("shmop_delete");
        allBuiltinFunctions.add("shmop_open");
        allBuiltinFunctions.add("shmop_read");
        allBuiltinFunctions.add("shmop_size");
        allBuiltinFunctions.add("shmop_write");
        allBuiltinFunctions.add("show_source");
        allBuiltinFunctions.add("shuffle");
        allBuiltinFunctions.add("similar_text");
        allBuiltinFunctions.add("simplexml_import_dom");
        allBuiltinFunctions.add("simplexml_load_file");
        allBuiltinFunctions.add("simplexml_load_string");
        allBuiltinFunctions.add("SimpleXMLElement->asXML");
        allBuiltinFunctions.add("SimpleXMLElement->attributes");
        allBuiltinFunctions.add("SimpleXMLElement->children");
        allBuiltinFunctions.add("SimpleXMLElement->xpath");
        allBuiltinFunctions.add("SimpleXMLIterator::current");
        allBuiltinFunctions.add("SimpleXMLIterator::getChildren");
        allBuiltinFunctions.add("SimpleXMLIterator::hasChildren");
        allBuiltinFunctions.add("SimpleXMLIterator::key");
        allBuiltinFunctions.add("SimpleXMLIterator::next");
        allBuiltinFunctions.add("SimpleXMLIterator::rewind");
        allBuiltinFunctions.add("SimpleXMLIterator::valid");
        allBuiltinFunctions.add("sin");
        allBuiltinFunctions.add("sinh");
        allBuiltinFunctions.add("sizeof");
        allBuiltinFunctions.add("sleep");
        allBuiltinFunctions.add("snmp_get_quick_print");
        allBuiltinFunctions.add("snmp_get_valueretrieval");
        allBuiltinFunctions.add("snmp_read_mib");
        allBuiltinFunctions.add("snmp_set_enum_print");
        allBuiltinFunctions.add("snmp_set_oid_numeric_print");
        allBuiltinFunctions.add("snmp_set_quick_print");
        allBuiltinFunctions.add("snmp_set_valueretrieval");
        allBuiltinFunctions.add("snmpget");
        allBuiltinFunctions.add("snmpgetnext");
        allBuiltinFunctions.add("snmprealwalk");
        allBuiltinFunctions.add("snmpset");
        allBuiltinFunctions.add("snmpwalk");
        allBuiltinFunctions.add("snmpwalkoid");
        allBuiltinFunctions.add("SoapClient::__call");
        allBuiltinFunctions.add("SoapClient::__getFunctions");
        allBuiltinFunctions.add("SoapClient::__getLastRequest");
        allBuiltinFunctions.add("SoapClient::__getLastResponse");
        allBuiltinFunctions.add("SoapClient::__getTypes");
        allBuiltinFunctions.add("SoapClient::SoapClient");
        allBuiltinFunctions.add("SoapFault::SoapFault");
        allBuiltinFunctions.add("SoapHeader::SoapHeader");
        allBuiltinFunctions.add("SoapParam::SoapParam");
        allBuiltinFunctions.add("SoapServer::addFunction");
        allBuiltinFunctions.add("SoapServer::getFunctions");
        allBuiltinFunctions.add("SoapServer::handle");
        allBuiltinFunctions.add("SoapServer::setClass");
        allBuiltinFunctions.add("SoapServer::setPersistence");
        allBuiltinFunctions.add("SoapServer::SoapServer");
        allBuiltinFunctions.add("SoapVar::SoapVar");
        allBuiltinFunctions.add("socket_accept");
        allBuiltinFunctions.add("socket_bind");
        allBuiltinFunctions.add("socket_clear_error");
        allBuiltinFunctions.add("socket_close");
        allBuiltinFunctions.add("socket_connect");
        allBuiltinFunctions.add("socket_create");
        allBuiltinFunctions.add("socket_create_listen");
        allBuiltinFunctions.add("socket_create_pair");
        allBuiltinFunctions.add("socket_get_option");
        allBuiltinFunctions.add("socket_get_status");
        allBuiltinFunctions.add("socket_getpeername");
        allBuiltinFunctions.add("socket_getsockname");
        allBuiltinFunctions.add("socket_last_error");
        allBuiltinFunctions.add("socket_listen");
        allBuiltinFunctions.add("socket_read");
        allBuiltinFunctions.add("socket_recv");
        allBuiltinFunctions.add("socket_recvfrom");
        allBuiltinFunctions.add("socket_select");
        allBuiltinFunctions.add("socket_send");
        allBuiltinFunctions.add("socket_sendto");
        allBuiltinFunctions.add("socket_set_block");
        allBuiltinFunctions.add("socket_set_blocking");
        allBuiltinFunctions.add("socket_set_nonblock");
        allBuiltinFunctions.add("socket_set_option");
        allBuiltinFunctions.add("socket_set_timeout");
        allBuiltinFunctions.add("socket_shutdown");
        allBuiltinFunctions.add("socket_strerror");
        allBuiltinFunctions.add("socket_write");
        allBuiltinFunctions.add("sort");
        allBuiltinFunctions.add("soundex");
        allBuiltinFunctions.add("spl_classes");
        allBuiltinFunctions.add("split");
        allBuiltinFunctions.add("spliti");
        allBuiltinFunctions.add("sprintf");
        allBuiltinFunctions.add("sql_regcase");
        allBuiltinFunctions.add("sqlite_array_query");
        allBuiltinFunctions.add("sqlite_busy_timeout");
        allBuiltinFunctions.add("sqlite_changes");
        allBuiltinFunctions.add("sqlite_close");
        allBuiltinFunctions.add("sqlite_column");
        allBuiltinFunctions.add("sqlite_create_aggregate");
        allBuiltinFunctions.add("sqlite_create_function");
        allBuiltinFunctions.add("sqlite_current");
        allBuiltinFunctions.add("sqlite_error_string");
        allBuiltinFunctions.add("sqlite_escape_string");
        allBuiltinFunctions.add("sqlite_exec");
        allBuiltinFunctions.add("sqlite_factory");
        allBuiltinFunctions.add("sqlite_fetch_all");
        allBuiltinFunctions.add("sqlite_fetch_array");
        allBuiltinFunctions.add("sqlite_fetch_column_types");
        allBuiltinFunctions.add("sqlite_fetch_object");
        allBuiltinFunctions.add("sqlite_fetch_single");
        allBuiltinFunctions.add("sqlite_fetch_string");
        allBuiltinFunctions.add("sqlite_field_name");
        allBuiltinFunctions.add("sqlite_has_more");
        allBuiltinFunctions.add("sqlite_has_prev");
        allBuiltinFunctions.add("sqlite_last_error");
        allBuiltinFunctions.add("sqlite_last_insert_rowid");
        allBuiltinFunctions.add("sqlite_libencoding");
        allBuiltinFunctions.add("sqlite_libversion");
        allBuiltinFunctions.add("sqlite_next");
        allBuiltinFunctions.add("sqlite_num_fields");
        allBuiltinFunctions.add("sqlite_num_rows");
        allBuiltinFunctions.add("sqlite_open");
        allBuiltinFunctions.add("sqlite_popen");
        allBuiltinFunctions.add("sqlite_prev");
        allBuiltinFunctions.add("sqlite_query");
        allBuiltinFunctions.add("sqlite_rewind");
        allBuiltinFunctions.add("sqlite_seek");
        allBuiltinFunctions.add("sqlite_single_query");
        allBuiltinFunctions.add("sqlite_udf_decode_binary");
        allBuiltinFunctions.add("sqlite_udf_encode_binary");
        allBuiltinFunctions.add("sqlite_unbuffered_query");
        allBuiltinFunctions.add("sqrt");
        allBuiltinFunctions.add("srand");
        allBuiltinFunctions.add("sscanf");
        allBuiltinFunctions.add("ssh2_auth_none");
        allBuiltinFunctions.add("ssh2_auth_password");
        allBuiltinFunctions.add("ssh2_auth_pubkey_file");
        allBuiltinFunctions.add("ssh2_connect");
        allBuiltinFunctions.add("ssh2_exec");
        allBuiltinFunctions.add("ssh2_fetch_stream");
        allBuiltinFunctions.add("ssh2_fingerprint");
        allBuiltinFunctions.add("ssh2_methods_negotiated");
        allBuiltinFunctions.add("ssh2_scp_recv");
        allBuiltinFunctions.add("ssh2_scp_send");
        allBuiltinFunctions.add("ssh2_sftp");
        allBuiltinFunctions.add("ssh2_sftp_lstat");
        allBuiltinFunctions.add("ssh2_sftp_mkdir");
        allBuiltinFunctions.add("ssh2_sftp_readlink");
        allBuiltinFunctions.add("ssh2_sftp_realpath");
        allBuiltinFunctions.add("ssh2_sftp_rename");
        allBuiltinFunctions.add("ssh2_sftp_rmdir");
        allBuiltinFunctions.add("ssh2_sftp_stat");
        allBuiltinFunctions.add("ssh2_sftp_symlink");
        allBuiltinFunctions.add("ssh2_sftp_unlink");
        allBuiltinFunctions.add("ssh2_shell");
        allBuiltinFunctions.add("ssh2_tunnel");
        allBuiltinFunctions.add("stat");
        allBuiltinFunctions.add("stmt->bind_param");
        allBuiltinFunctions.add("stmt->bind_result");
        allBuiltinFunctions.add("stmt->data_seek");
        allBuiltinFunctions.add("stmt->execute");
        allBuiltinFunctions.add("stmt->fetch");
        allBuiltinFunctions.add("stmt->free_result");
        allBuiltinFunctions.add("stmt->num_rows");
        allBuiltinFunctions.add("stmt->param_count");
        allBuiltinFunctions.add("stmt->prepare");
        allBuiltinFunctions.add("stmt->reset");
        allBuiltinFunctions.add("stmt->send_long_data");
        allBuiltinFunctions.add("str_ireplace");
        allBuiltinFunctions.add("str_pad");
        allBuiltinFunctions.add("str_repeat");
        allBuiltinFunctions.add("str_replace");
        allBuiltinFunctions.add("str_rot13");
        allBuiltinFunctions.add("str_shuffle");
        allBuiltinFunctions.add("str_split");
        allBuiltinFunctions.add("str_word_count");
        allBuiltinFunctions.add("strcasecmp");
        allBuiltinFunctions.add("strchr");
        allBuiltinFunctions.add("strcmp");
        allBuiltinFunctions.add("strcoll");
        allBuiltinFunctions.add("strcspn");
        allBuiltinFunctions.add("stream_context_create");
        allBuiltinFunctions.add("stream_context_get_default");
        allBuiltinFunctions.add("stream_context_get_options");
        allBuiltinFunctions.add("stream_context_set_option");
        allBuiltinFunctions.add("stream_context_set_params");
        allBuiltinFunctions.add("stream_copy_to_stream");
        allBuiltinFunctions.add("stream_filter_append");
        allBuiltinFunctions.add("stream_filter_prepend");
        allBuiltinFunctions.add("stream_filter_register");
        allBuiltinFunctions.add("stream_filter_remove");
        allBuiltinFunctions.add("stream_get_contents");
        allBuiltinFunctions.add("stream_get_filters");
        allBuiltinFunctions.add("stream_get_line");
        allBuiltinFunctions.add("stream_get_meta_data");
        allBuiltinFunctions.add("stream_get_transports");
        allBuiltinFunctions.add("stream_get_wrappers");
        allBuiltinFunctions.add("stream_register_wrapper");
        allBuiltinFunctions.add("stream_select");
        allBuiltinFunctions.add("stream_set_blocking");
        allBuiltinFunctions.add("stream_set_timeout");
        allBuiltinFunctions.add("stream_set_write_buffer");
        allBuiltinFunctions.add("stream_socket_accept");
        allBuiltinFunctions.add("stream_socket_client");
        allBuiltinFunctions.add("stream_socket_enable_crypto");
        allBuiltinFunctions.add("stream_socket_get_name");
        allBuiltinFunctions.add("stream_socket_pair");
        allBuiltinFunctions.add("stream_socket_recvfrom");
        allBuiltinFunctions.add("stream_socket_sendto");
        allBuiltinFunctions.add("stream_socket_server");
        allBuiltinFunctions.add("stream_wrapper_register");
        allBuiltinFunctions.add("stream_wrapper_restore");
        allBuiltinFunctions.add("stream_wrapper_unregister");
        allBuiltinFunctions.add("strftime");
        allBuiltinFunctions.add("strip_tags");
        allBuiltinFunctions.add("stripcslashes");
        allBuiltinFunctions.add("stripos");
        allBuiltinFunctions.add("stripslashes");
        allBuiltinFunctions.add("stristr");
        allBuiltinFunctions.add("strlen");
        allBuiltinFunctions.add("strnatcasecmp");
        allBuiltinFunctions.add("strnatcmp");
        allBuiltinFunctions.add("strncasecmp");
        allBuiltinFunctions.add("strncmp");
        allBuiltinFunctions.add("strpbrk");
        allBuiltinFunctions.add("strpos");
        allBuiltinFunctions.add("strptime");
        allBuiltinFunctions.add("strrchr");
        allBuiltinFunctions.add("strrev");
        allBuiltinFunctions.add("strripos");
        allBuiltinFunctions.add("strrpos");
        allBuiltinFunctions.add("strspn");
        allBuiltinFunctions.add("strstr");
        allBuiltinFunctions.add("strtok");
        allBuiltinFunctions.add("strtolower");
        allBuiltinFunctions.add("strtotime");
        allBuiltinFunctions.add("strtoupper");
        allBuiltinFunctions.add("strtr");
        allBuiltinFunctions.add("strval");
        allBuiltinFunctions.add("substr");
        allBuiltinFunctions.add("substr_compare");
        allBuiltinFunctions.add("substr_count");
        allBuiltinFunctions.add("substr_replace");
        allBuiltinFunctions.add("swf_actiongeturl");
        allBuiltinFunctions.add("swf_actiongotoframe");
        allBuiltinFunctions.add("swf_actiongotolabel");
        allBuiltinFunctions.add("swf_actionnextframe");
        allBuiltinFunctions.add("swf_actionplay");
        allBuiltinFunctions.add("swf_actionprevframe");
        allBuiltinFunctions.add("swf_actionsettarget");
        allBuiltinFunctions.add("swf_actionstop");
        allBuiltinFunctions.add("swf_actiontogglequality");
        allBuiltinFunctions.add("swf_actionwaitforframe");
        allBuiltinFunctions.add("swf_addbuttonrecord");
        allBuiltinFunctions.add("swf_addcolor");
        allBuiltinFunctions.add("swf_closefile");
        allBuiltinFunctions.add("swf_definebitmap");
        allBuiltinFunctions.add("swf_definefont");
        allBuiltinFunctions.add("swf_defineline");
        allBuiltinFunctions.add("swf_definepoly");
        allBuiltinFunctions.add("swf_definerect");
        allBuiltinFunctions.add("swf_definetext");
        allBuiltinFunctions.add("swf_endbutton");
        allBuiltinFunctions.add("swf_enddoaction");
        allBuiltinFunctions.add("swf_endshape");
        allBuiltinFunctions.add("swf_endsymbol");
        allBuiltinFunctions.add("swf_fontsize");
        allBuiltinFunctions.add("swf_fontslant");
        allBuiltinFunctions.add("swf_fonttracking");
        allBuiltinFunctions.add("swf_getbitmapinfo");
        allBuiltinFunctions.add("swf_getfontinfo");
        allBuiltinFunctions.add("swf_getframe");
        allBuiltinFunctions.add("swf_labelframe");
        allBuiltinFunctions.add("swf_lookat");
        allBuiltinFunctions.add("swf_modifyobject");
        allBuiltinFunctions.add("swf_mulcolor");
        allBuiltinFunctions.add("swf_nextid");
        allBuiltinFunctions.add("swf_oncondition");
        allBuiltinFunctions.add("swf_openfile");
        allBuiltinFunctions.add("swf_ortho");
        allBuiltinFunctions.add("swf_ortho2");
        allBuiltinFunctions.add("swf_perspective");
        allBuiltinFunctions.add("swf_placeobject");
        allBuiltinFunctions.add("swf_polarview");
        allBuiltinFunctions.add("swf_popmatrix");
        allBuiltinFunctions.add("swf_posround");
        allBuiltinFunctions.add("swf_pushmatrix");
        allBuiltinFunctions.add("swf_removeobject");
        allBuiltinFunctions.add("swf_rotate");
        allBuiltinFunctions.add("swf_scale");
        allBuiltinFunctions.add("swf_setfont");
        allBuiltinFunctions.add("swf_setframe");
        allBuiltinFunctions.add("swf_shapearc");
        allBuiltinFunctions.add("swf_shapecurveto");
        allBuiltinFunctions.add("swf_shapecurveto3");
        allBuiltinFunctions.add("swf_shapefillbitmapclip");
        allBuiltinFunctions.add("swf_shapefillbitmaptile");
        allBuiltinFunctions.add("swf_shapefilloff");
        allBuiltinFunctions.add("swf_shapefillsolid");
        allBuiltinFunctions.add("swf_shapelinesolid");
        allBuiltinFunctions.add("swf_shapelineto");
        allBuiltinFunctions.add("swf_shapemoveto");
        allBuiltinFunctions.add("swf_showframe");
        allBuiltinFunctions.add("swf_startbutton");
        allBuiltinFunctions.add("swf_startdoaction");
        allBuiltinFunctions.add("swf_startshape");
        allBuiltinFunctions.add("swf_startsymbol");
        allBuiltinFunctions.add("swf_textwidth");
        allBuiltinFunctions.add("swf_translate");
        allBuiltinFunctions.add("swf_viewport");
        allBuiltinFunctions.add("swfaction");
        allBuiltinFunctions.add("swfbitmap");
        allBuiltinFunctions.add("SWFBitmap->getHeight");
        allBuiltinFunctions.add("SWFBitmap->getWidth");
        allBuiltinFunctions.add("swfbutton");
        allBuiltinFunctions.add("SWFbutton->addAction");
        allBuiltinFunctions.add("SWFbutton->addShape");
        allBuiltinFunctions.add("SWFbutton->setAction");
        allBuiltinFunctions.add("SWFbutton->setdown");
        allBuiltinFunctions.add("SWFbutton->setHit");
        allBuiltinFunctions.add("SWFbutton->setOver");
        allBuiltinFunctions.add("SWFbutton->setUp");
        allBuiltinFunctions.add("swfbutton_keypress");
        allBuiltinFunctions.add("swfdisplayitem");
        allBuiltinFunctions.add("SWFDisplayItem->addColor");
        allBuiltinFunctions.add("SWFDisplayItem->move");
        allBuiltinFunctions.add("SWFDisplayItem->moveTo");
        allBuiltinFunctions.add("SWFDisplayItem->multColor");
        allBuiltinFunctions.add("SWFDisplayItem->remove");
        allBuiltinFunctions.add("SWFDisplayItem->Rotate");
        allBuiltinFunctions.add("SWFDisplayItem->rotateTo");
        allBuiltinFunctions.add("SWFDisplayItem->scale");
        allBuiltinFunctions.add("SWFDisplayItem->scaleTo");
        allBuiltinFunctions.add("SWFDisplayItem->setDepth");
        allBuiltinFunctions.add("SWFDisplayItem->setName");
        allBuiltinFunctions.add("SWFDisplayItem->setRatio");
        allBuiltinFunctions.add("SWFDisplayItem->skewX");
        allBuiltinFunctions.add("SWFDisplayItem->skewXTo");
        allBuiltinFunctions.add("SWFDisplayItem->skewY");
        allBuiltinFunctions.add("SWFDisplayItem->skewYTo");
        allBuiltinFunctions.add("swffill");
        allBuiltinFunctions.add("SWFFill->moveTo");
        allBuiltinFunctions.add("SWFFill->rotateTo");
        allBuiltinFunctions.add("SWFFill->scaleTo");
        allBuiltinFunctions.add("SWFFill->skewXTo");
        allBuiltinFunctions.add("SWFFill->skewYTo");
        allBuiltinFunctions.add("swffont");
        allBuiltinFunctions.add("swffont->getwidth");
        allBuiltinFunctions.add("swfgradient");
        allBuiltinFunctions.add("SWFGradient->addEntry");
        allBuiltinFunctions.add("swfmorph");
        allBuiltinFunctions.add("SWFMorph->getshape1");
        allBuiltinFunctions.add("SWFMorph->getshape2");
        allBuiltinFunctions.add("swfmovie");
        allBuiltinFunctions.add("SWFMovie->add");
        allBuiltinFunctions.add("SWFMovie->nextframe");
        allBuiltinFunctions.add("SWFMovie->output");
        allBuiltinFunctions.add("swfmovie->remove");
        allBuiltinFunctions.add("SWFMovie->save");
        allBuiltinFunctions.add("SWFMovie->setbackground");
        allBuiltinFunctions.add("SWFMovie->setdimension");
        allBuiltinFunctions.add("SWFMovie->setframes");
        allBuiltinFunctions.add("SWFMovie->setrate");
        allBuiltinFunctions.add("SWFMovie->streammp3");
        allBuiltinFunctions.add("swfshape");
        allBuiltinFunctions.add("SWFShape->addFill");
        allBuiltinFunctions.add("SWFShape->drawCurve");
        allBuiltinFunctions.add("SWFShape->drawCurveTo");
        allBuiltinFunctions.add("SWFShape->drawLine");
        allBuiltinFunctions.add("SWFShape->drawLineTo");
        allBuiltinFunctions.add("SWFShape->movePen");
        allBuiltinFunctions.add("SWFShape->movePenTo");
        allBuiltinFunctions.add("SWFShape->setLeftFill");
        allBuiltinFunctions.add("SWFShape->setLine");
        allBuiltinFunctions.add("SWFShape->setRightFill");
        allBuiltinFunctions.add("swfsprite");
        allBuiltinFunctions.add("swfsprite->add");
        allBuiltinFunctions.add("SWFSprite->nextframe");
        allBuiltinFunctions.add("SWFSprite->remove");
        allBuiltinFunctions.add("SWFSprite->setframes");
        allBuiltinFunctions.add("swftext");
        allBuiltinFunctions.add("SWFText->addString");
        allBuiltinFunctions.add("SWFText->getWidth");
        allBuiltinFunctions.add("SWFText->moveTo");
        allBuiltinFunctions.add("SWFText->setColor");
        allBuiltinFunctions.add("SWFText->setFont");
        allBuiltinFunctions.add("SWFText->setHeight");
        allBuiltinFunctions.add("SWFText->setSpacing");
        allBuiltinFunctions.add("swftextfield");
        allBuiltinFunctions.add("SWFTextField->addstring");
        allBuiltinFunctions.add("SWFTextField->align");
        allBuiltinFunctions.add("SWFTextField->setbounds");
        allBuiltinFunctions.add("SWFTextField->setcolor");
        allBuiltinFunctions.add("SWFTextField->setFont");
        allBuiltinFunctions.add("SWFTextField->setHeight");
        allBuiltinFunctions.add("SWFTextField->setindentation");
        allBuiltinFunctions.add("SWFTextField->setLeftMargin");
        allBuiltinFunctions.add("SWFTextField->setLineSpacing");
        allBuiltinFunctions.add("SWFTextField->setMargins");
        allBuiltinFunctions.add("SWFTextField->setname");
        allBuiltinFunctions.add("SWFTextField->setrightMargin");
        allBuiltinFunctions.add("sybase_affected_rows");
        allBuiltinFunctions.add("sybase_close");
        allBuiltinFunctions.add("sybase_connect");
        allBuiltinFunctions.add("sybase_data_seek");
        allBuiltinFunctions.add("sybase_deadlock_retry_count");
        allBuiltinFunctions.add("sybase_fetch_array");
        allBuiltinFunctions.add("sybase_fetch_assoc");
        allBuiltinFunctions.add("sybase_fetch_field");
        allBuiltinFunctions.add("sybase_fetch_object");
        allBuiltinFunctions.add("sybase_fetch_row");
        allBuiltinFunctions.add("sybase_field_seek");
        allBuiltinFunctions.add("sybase_free_result");
        allBuiltinFunctions.add("sybase_get_last_message");
        allBuiltinFunctions.add("sybase_min_client_severity");
        allBuiltinFunctions.add("sybase_min_error_severity");
        allBuiltinFunctions.add("sybase_min_message_severity");
        allBuiltinFunctions.add("sybase_min_server_severity");
        allBuiltinFunctions.add("sybase_num_fields");
        allBuiltinFunctions.add("sybase_num_rows");
        allBuiltinFunctions.add("sybase_pconnect");
        allBuiltinFunctions.add("sybase_query");
        allBuiltinFunctions.add("sybase_result");
        allBuiltinFunctions.add("sybase_select_db");
        allBuiltinFunctions.add("sybase_set_message_handler");
        allBuiltinFunctions.add("sybase_unbuffered_query");
        allBuiltinFunctions.add("symlink");
        allBuiltinFunctions.add("syslog");
        allBuiltinFunctions.add("system");
        allBuiltinFunctions.add("tan");
        allBuiltinFunctions.add("tanh");
        allBuiltinFunctions.add("tcpwrap_check");
        allBuiltinFunctions.add("tempnam");
        allBuiltinFunctions.add("textdomain");
        allBuiltinFunctions.add("tidy::__construct");
        allBuiltinFunctions.add("tidy_access_count");
        allBuiltinFunctions.add("tidy_clean_repair");
        allBuiltinFunctions.add("tidy_config_count");
        allBuiltinFunctions.add("tidy_diagnose");
        allBuiltinFunctions.add("tidy_error_count");
        allBuiltinFunctions.add("tidy_get_body");
        allBuiltinFunctions.add("tidy_get_config");
        allBuiltinFunctions.add("tidy_get_error_buffer");
        allBuiltinFunctions.add("tidy_get_head");
        allBuiltinFunctions.add("tidy_get_html");
        allBuiltinFunctions.add("tidy_get_html_ver");
        allBuiltinFunctions.add("tidy_get_output");
        allBuiltinFunctions.add("tidy_get_release");
        allBuiltinFunctions.add("tidy_get_root");
        allBuiltinFunctions.add("tidy_get_status");
        allBuiltinFunctions.add("tidy_getopt");
        allBuiltinFunctions.add("tidy_is_xhtml");
        allBuiltinFunctions.add("tidy_is_xml");
        allBuiltinFunctions.add("tidy_load_config");
        allBuiltinFunctions.add("tidy_node->children");
        allBuiltinFunctions.add("tidy_node->get_attr");
        allBuiltinFunctions.add("tidy_node->get_nodes");
        allBuiltinFunctions.add("tidy_node->hasChildren");
        allBuiltinFunctions.add("tidy_node->hasSiblings");
        allBuiltinFunctions.add("tidy_node->isComment");
        allBuiltinFunctions.add("tidy_node->isHtml");
        allBuiltinFunctions.add("tidy_node->isJste");
        allBuiltinFunctions.add("tidy_node->isText");
        allBuiltinFunctions.add("tidy_node->isXhtml");
        allBuiltinFunctions.add("tidy_node->isXml");
        allBuiltinFunctions.add("tidy_node->next");
        allBuiltinFunctions.add("tidy_node->prev");
        allBuiltinFunctions.add("tidy_parse_file");
        allBuiltinFunctions.add("tidy_parse_string");
        allBuiltinFunctions.add("tidy_repair_file");
        allBuiltinFunctions.add("tidy_repair_string");
        allBuiltinFunctions.add("tidy_reset_config");
        allBuiltinFunctions.add("tidy_save_config");
        allBuiltinFunctions.add("tidy_set_encoding");
        allBuiltinFunctions.add("tidy_setopt");
        allBuiltinFunctions.add("tidy_warning_count");
        allBuiltinFunctions.add("tidyNode->isAsp");
        allBuiltinFunctions.add("tidyNode->isPhp");
        allBuiltinFunctions.add("time");
        allBuiltinFunctions.add("time_nanosleep");
        allBuiltinFunctions.add("tmpfile");
        allBuiltinFunctions.add("token_get_all");
        allBuiltinFunctions.add("token_name");
        allBuiltinFunctions.add("touch");
        allBuiltinFunctions.add("trigger_error");
        allBuiltinFunctions.add("trim");
        allBuiltinFunctions.add("uasort");
        allBuiltinFunctions.add("ucfirst");
        allBuiltinFunctions.add("ucwords");
        allBuiltinFunctions.add("udm_add_search_limit");
        allBuiltinFunctions.add("udm_alloc_agent");
        allBuiltinFunctions.add("udm_alloc_agent_array");
        allBuiltinFunctions.add("udm_api_version");
        allBuiltinFunctions.add("udm_cat_list");
        allBuiltinFunctions.add("udm_cat_path");
        allBuiltinFunctions.add("udm_check_charset");
        allBuiltinFunctions.add("udm_check_stored");
        allBuiltinFunctions.add("udm_clear_search_limits");
        allBuiltinFunctions.add("udm_close_stored");
        allBuiltinFunctions.add("udm_crc32");
        allBuiltinFunctions.add("udm_errno");
        allBuiltinFunctions.add("udm_error");
        allBuiltinFunctions.add("udm_find");
        allBuiltinFunctions.add("udm_free_agent");
        allBuiltinFunctions.add("udm_free_ispell_data");
        allBuiltinFunctions.add("udm_free_res");
        allBuiltinFunctions.add("udm_get_doc_count");
        allBuiltinFunctions.add("udm_get_res_field");
        allBuiltinFunctions.add("udm_get_res_param");
        allBuiltinFunctions.add("udm_hash32");
        allBuiltinFunctions.add("udm_load_ispell_data");
        allBuiltinFunctions.add("udm_open_stored");
        allBuiltinFunctions.add("udm_set_agent_param");
        allBuiltinFunctions.add("uksort");
        allBuiltinFunctions.add("umask");
        allBuiltinFunctions.add("uniqid");
        allBuiltinFunctions.add("unixtojd");
        allBuiltinFunctions.add("unlink");
        allBuiltinFunctions.add("unpack");
        allBuiltinFunctions.add("unregister_tick_function");
        allBuiltinFunctions.add("unserialize");
        allBuiltinFunctions.add("unset");
        allBuiltinFunctions.add("urldecode");
        allBuiltinFunctions.add("urlencode");
        allBuiltinFunctions.add("user_error");
        allBuiltinFunctions.add("usleep");
        allBuiltinFunctions.add("usort");
        allBuiltinFunctions.add("utf8_decode");
        allBuiltinFunctions.add("utf8_encode");
        allBuiltinFunctions.add("var_dump");
        allBuiltinFunctions.add("var_export");
        allBuiltinFunctions.add("variant");
        allBuiltinFunctions.add("variant_abs");
        allBuiltinFunctions.add("variant_add");
        allBuiltinFunctions.add("variant_and");
        allBuiltinFunctions.add("variant_cast");
        allBuiltinFunctions.add("variant_cat");
        allBuiltinFunctions.add("variant_cmp");
        allBuiltinFunctions.add("variant_date_from_timestamp");
        allBuiltinFunctions.add("variant_date_to_timestamp");
        allBuiltinFunctions.add("variant_div");
        allBuiltinFunctions.add("variant_eqv");
        allBuiltinFunctions.add("variant_fix");
        allBuiltinFunctions.add("variant_get_type");
        allBuiltinFunctions.add("variant_idiv");
        allBuiltinFunctions.add("variant_imp");
        allBuiltinFunctions.add("variant_int");
        allBuiltinFunctions.add("variant_mod");
        allBuiltinFunctions.add("variant_mul");
        allBuiltinFunctions.add("variant_neg");
        allBuiltinFunctions.add("variant_not");
        allBuiltinFunctions.add("variant_or");
        allBuiltinFunctions.add("variant_pow");
        allBuiltinFunctions.add("variant_round");
        allBuiltinFunctions.add("variant_set");
        allBuiltinFunctions.add("variant_set_type");
        allBuiltinFunctions.add("variant_sub");
        allBuiltinFunctions.add("variant_xor");
        allBuiltinFunctions.add("version_compare");
        allBuiltinFunctions.add("vfprintf");
        allBuiltinFunctions.add("virtual");
        allBuiltinFunctions.add("vpopmail_add_alias_domain");
        allBuiltinFunctions.add("vpopmail_add_alias_domain_ex");
        allBuiltinFunctions.add("vpopmail_add_domain");
        allBuiltinFunctions.add("vpopmail_add_domain_ex");
        allBuiltinFunctions.add("vpopmail_add_user");
        allBuiltinFunctions.add("vpopmail_alias_add");
        allBuiltinFunctions.add("vpopmail_alias_del");
        allBuiltinFunctions.add("vpopmail_alias_del_domain");
        allBuiltinFunctions.add("vpopmail_alias_get");
        allBuiltinFunctions.add("vpopmail_alias_get_all");
        allBuiltinFunctions.add("vpopmail_auth_user");
        allBuiltinFunctions.add("vpopmail_del_domain");
        allBuiltinFunctions.add("vpopmail_del_domain_ex");
        allBuiltinFunctions.add("vpopmail_del_user");
        allBuiltinFunctions.add("vpopmail_error");
        allBuiltinFunctions.add("vpopmail_passwd");
        allBuiltinFunctions.add("vpopmail_set_user_quota");
        allBuiltinFunctions.add("vprintf");
        allBuiltinFunctions.add("vsprintf");
        allBuiltinFunctions.add("w32api_deftype");
        allBuiltinFunctions.add("w32api_init_dtype");
        allBuiltinFunctions.add("w32api_invoke_function");
        allBuiltinFunctions.add("w32api_register_function");
        allBuiltinFunctions.add("w32api_set_call_method");
        allBuiltinFunctions.add("wddx_add_vars");
        allBuiltinFunctions.add("wddx_deserialize");
        allBuiltinFunctions.add("wddx_packet_end");
        allBuiltinFunctions.add("wddx_packet_start");
        allBuiltinFunctions.add("wddx_serialize_value");
        allBuiltinFunctions.add("wddx_serialize_vars");
        allBuiltinFunctions.add("wordwrap");
        allBuiltinFunctions.add("xattr_get");
        allBuiltinFunctions.add("xattr_list");
        allBuiltinFunctions.add("xattr_remove");
        allBuiltinFunctions.add("xattr_set");
        allBuiltinFunctions.add("xattr_supported");
        allBuiltinFunctions.add("xdiff_file_diff");
        allBuiltinFunctions.add("xdiff_file_diff_binary");
        allBuiltinFunctions.add("xdiff_file_merge3");
        allBuiltinFunctions.add("xdiff_file_patch");
        allBuiltinFunctions.add("xdiff_file_patch_binary");
        allBuiltinFunctions.add("xdiff_string_diff");
        allBuiltinFunctions.add("xdiff_string_diff_binary");
        allBuiltinFunctions.add("xdiff_string_merge3");
        allBuiltinFunctions.add("xdiff_string_patch");
        allBuiltinFunctions.add("xdiff_string_patch_binary");
        allBuiltinFunctions.add("xml_error_string");
        allBuiltinFunctions.add("xml_get_current_byte_index");
        allBuiltinFunctions.add("xml_get_current_column_number");
        allBuiltinFunctions.add("xml_get_current_line_number");
        allBuiltinFunctions.add("xml_get_error_code");
        allBuiltinFunctions.add("xml_parse");
        allBuiltinFunctions.add("xml_parse_into_struct");
        allBuiltinFunctions.add("xml_parser_create");
        allBuiltinFunctions.add("xml_parser_create_ns");
        allBuiltinFunctions.add("xml_parser_free");
        allBuiltinFunctions.add("xml_parser_get_option");
        allBuiltinFunctions.add("xml_parser_set_option");
        allBuiltinFunctions.add("xml_set_character_data_handler");
        allBuiltinFunctions.add("xml_set_default_handler");
        allBuiltinFunctions.add("xml_set_element_handler");
        allBuiltinFunctions.add("xml_set_end_namespace_decl_handler");
        allBuiltinFunctions.add("xml_set_external_entity_ref_handler");
        allBuiltinFunctions.add("xml_set_notation_decl_handler");
        allBuiltinFunctions.add("xml_set_object");
        allBuiltinFunctions.add("xml_set_processing_instruction_handler");
        allBuiltinFunctions.add("xml_set_start_namespace_decl_handler");
        allBuiltinFunctions.add("xml_set_unparsed_entity_decl_handler");
        allBuiltinFunctions.add("xmlrpc_decode");
        allBuiltinFunctions.add("xmlrpc_decode_request");
        allBuiltinFunctions.add("xmlrpc_encode");
        allBuiltinFunctions.add("xmlrpc_encode_request");
        allBuiltinFunctions.add("xmlrpc_get_type");
        allBuiltinFunctions.add("xmlrpc_is_fault");
        allBuiltinFunctions.add("xmlrpc_parse_method_descriptions");
        allBuiltinFunctions.add("xmlrpc_server_add_introspection_data");
        allBuiltinFunctions.add("xmlrpc_server_call_method");
        allBuiltinFunctions.add("xmlrpc_server_create");
        allBuiltinFunctions.add("xmlrpc_server_destroy");
        allBuiltinFunctions.add("xmlrpc_server_register_introspection_callback");
        allBuiltinFunctions.add("xmlrpc_server_register_method");
        allBuiltinFunctions.add("xmlrpc_set_type");
        allBuiltinFunctions.add("xpath_eval");
        allBuiltinFunctions.add("xpath_eval_expression");
        allBuiltinFunctions.add("xpath_new_context");
        allBuiltinFunctions.add("xptr_eval");
        allBuiltinFunctions.add("xptr_new_context");
        allBuiltinFunctions.add("xsl_xsltprocessor_get_parameter");
        allBuiltinFunctions.add("xsl_xsltprocessor_has_exslt_support");
        allBuiltinFunctions.add("xsl_xsltprocessor_import_stylesheet");
        allBuiltinFunctions.add("xsl_xsltprocessor_register_php_functions");
        allBuiltinFunctions.add("xsl_xsltprocessor_remove_parameter");
        allBuiltinFunctions.add("xsl_xsltprocessor_set_parameter");
        allBuiltinFunctions.add("xsl_xsltprocessor_transform_to_doc");
        allBuiltinFunctions.add("xsl_xsltprocessor_transform_to_uri");
        allBuiltinFunctions.add("xsl_xsltprocessor_transform_to_xml");
        allBuiltinFunctions.add("xslt_backend_info");
        allBuiltinFunctions.add("xslt_backend_name");
        allBuiltinFunctions.add("xslt_backend_version");
        allBuiltinFunctions.add("xslt_create");
        allBuiltinFunctions.add("xslt_errno");
        allBuiltinFunctions.add("xslt_error");
        allBuiltinFunctions.add("xslt_free");
        allBuiltinFunctions.add("xslt_getopt");
        allBuiltinFunctions.add("xslt_process");
        allBuiltinFunctions.add("xslt_set_base");
        allBuiltinFunctions.add("xslt_set_encoding");
        allBuiltinFunctions.add("xslt_set_error_handler");
        allBuiltinFunctions.add("xslt_set_log");
        allBuiltinFunctions.add("xslt_set_object");
        allBuiltinFunctions.add("xslt_set_sax_handler");
        allBuiltinFunctions.add("xslt_set_sax_handlers");
        allBuiltinFunctions.add("xslt_set_scheme_handler");
        allBuiltinFunctions.add("xslt_set_scheme_handlers");
        allBuiltinFunctions.add("xslt_setopt");
        allBuiltinFunctions.add("yaz_addinfo");
        allBuiltinFunctions.add("yaz_ccl_conf");
        allBuiltinFunctions.add("yaz_ccl_parse");
        allBuiltinFunctions.add("yaz_close");
        allBuiltinFunctions.add("yaz_connect");
        allBuiltinFunctions.add("yaz_database");
        allBuiltinFunctions.add("yaz_element");
        allBuiltinFunctions.add("yaz_errno");
        allBuiltinFunctions.add("yaz_error");
        allBuiltinFunctions.add("yaz_es_result");
        allBuiltinFunctions.add("yaz_get_option");
        allBuiltinFunctions.add("yaz_hits");
        allBuiltinFunctions.add("yaz_itemorder");
        allBuiltinFunctions.add("yaz_present");
        allBuiltinFunctions.add("yaz_range");
        allBuiltinFunctions.add("yaz_record");
        allBuiltinFunctions.add("yaz_scan");
        allBuiltinFunctions.add("yaz_scan_result");
        allBuiltinFunctions.add("yaz_schema");
        allBuiltinFunctions.add("yaz_search");
        allBuiltinFunctions.add("yaz_set_option");
        allBuiltinFunctions.add("yaz_sort");
        allBuiltinFunctions.add("yaz_syntax");
        allBuiltinFunctions.add("yaz_wait");
        allBuiltinFunctions.add("yp_all");
        allBuiltinFunctions.add("yp_cat");
        allBuiltinFunctions.add("yp_err_string");
        allBuiltinFunctions.add("yp_errno");
        allBuiltinFunctions.add("yp_first");
        allBuiltinFunctions.add("yp_get_default_domain");
        allBuiltinFunctions.add("yp_master");
        allBuiltinFunctions.add("yp_match");
        allBuiltinFunctions.add("yp_next");
        allBuiltinFunctions.add("yp_order");
        allBuiltinFunctions.add("zend_logo_guid");
        allBuiltinFunctions.add("zend_version");
        allBuiltinFunctions.add("zip_close");
        allBuiltinFunctions.add("zip_entry_close");
        allBuiltinFunctions.add("zip_entry_compressedsize");
        allBuiltinFunctions.add("zip_entry_compressionmethod");
        allBuiltinFunctions.add("zip_entry_filesize");
        allBuiltinFunctions.add("zip_entry_name");
        allBuiltinFunctions.add("zip_entry_open");
        allBuiltinFunctions.add("zip_entry_read");
        allBuiltinFunctions.add("zip_open");
        allBuiltinFunctions.add("zip_read");
        allBuiltinFunctions.add("zlib_get_coding_type");
        
        return allBuiltinFunctions;
    }
    
    public static boolean isBuiltinFunction(String functionName) {
        functionName = functionName.toLowerCase();
        if (functionName.startsWith("_junit_test")) {
            return true;
        }
        return BuiltinFunctions.allBuiltinFunctions.contains(functionName);
    }

}
